<?php


/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.1
 * 
 * $Id: admin.php 931 2006-08-30 19:54:17Z PaiTrakt $
 */


//Say that we are admins
define("IN_ACP", 1);
define("VBOARD", 1);

//Including pages
require_once('inc/functions.php');

/**
 * Ask the user a question, or some way they need to confirm something
 *
 * @param string $msg
 * @param array $targets
 * @return string $html
 */
function admin_confirm($msg, $targets)
{
	global $user, $screen;
	
	//language stuff
	$lang_global = new lang_global;
	
	//loop the links
	$links = '';
	foreach ($targets as $text => $target)
	{
		$links .= $screen->return_html('basic_link', array('target' => $target, 'text' => $text));
	}
	
	//template stuff
	$tohtml = array('msg'	=> $msg,
					'skin_set'	=> $user->skin_set,
					'targets'	=> $links,
					'you_sure'	=> $lang_global->confirm_you_sure
					);
					
	return $screen->return_html('confirm', $tohtml);
	
}

//If the user is admin, choose task, else dont do it, then the user will be redirected away
if($user->g_is_admin == 1)
{
	$todo	=	$_GET['act'];
	if (empty($todo))
	{
		$todo	=	'start';
	}
}
else
{
	header("Location: login.php");
	exit;
}

//	If we dont have the function that should be viewed, simply return to the admin frontpage
if (!(include_once("inc/adminfiles/" . $todo . ".php")))
{
	header("Location: admin.php");
	exit;
}

//  Do foo
$content = new admin($screen, $cache, $db, $config);

//  Print page
$screen->add_admin_wrapper($content->html);
$screen->print_page();

?>