<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Jørgen Tellnes <jorgis@jorgis.com>
 * @version 0.1
 * 
 * $Id: forum.php 957 2006-09-15 13:14:24Z jorgenboard $
 */

//yes, we are here
define("VBOARD", 1);


//====================================
//	forum.php  | Shows a forum OR does forum-spesific work
//====================================

require_once('inc/functions.php');

switch($_GET['mode'])
{
	//show a forum
	case 'f':
	show_forum();
    break;
	
	//add a forum subscription
	case 'subscribe':
	add_forum_subscription($_GET['f']);
	break;
	
	//default is to show a forum
	default:
	show_forum();
	break;
}
	
/**
 * Add forum subscription
 *
 *
 * @param int topic
 * @return void
 */
function add_forum_subscription($forum)
{
	global $db, $user;

	if($forum)
	{
		$lang	=	new lang_forum;
		$data	=	$db->get_usersubscr_in_forum($user->id, $forum);

		if(!$data->id)
		{
			$db->insert_new_usersub_forum($user->id, $forum);
			notify($lang->new_forum_subscription);
		} else {
			notify($lang->existing_forum_subscription);
		}
	}
}
	

//====================================
//	Show spesified forum function
//====================================
function show_forum()
{

	global $db, $cache, $user, $config, $screen;
	$lang_topic	=	new lang_topics;

	//do we even have a forum to view?
	if (!($showforum = $_GET['f']))
		error_msg($lang_topic->no_id, 1);
		
	//====================================	
	//starting to show from topic number x..
	//====================================
	if (!is_numeric(@$_GET['s']))
		$showfrom	=	0;
	else
		$showfrom	=	$_GET['s'];

	//====================================
	//	Updating forum read cookie (yummy!)
	//====================================
	setcookie("".$config->cookie."_forumread[".$_GET['f']."]", "".forumtime()."", forumtime()+(86400*365),"/");

	//====================================
	//	Getting our required data from our database..
	//====================================
	
	//getting the category id for this forum and the name for usage in the navigation menu
	$db_forum			=	$cache->query('get_forum_info', array($showforum));
	$db_forum			=	$db_forum[0];

	//are we in the middle of nowhere?
	if (!$db_forum)
		error_msg($lang_topic->no_id, 1);
		
	//the name of the category is?
	$db_cat				=	$cache->query('get_category', array($db_forum->cat));
	$db_cat				=	$db_cat[0];
	
	//Getting topics in this forum :)
	$db_topics			=	$db->get_topics_from_forum($showforum, $showfrom, $config->show_maxtopics, $config->prune_topics);

	//====================================
	//	Making the page, parsing template etc.
	//====================================
	$lang_forum		=	new	lang_forum;

	//====================================
	//	Build navigation link for the forum view
	//====================================
	require_once("inc/lib/pages.php");
	
	//total page numbers
	$pages = ceil($db_forum->stat_threads / $config->show_maxtopics);
	
	//the current page
	$showfrom = ($showfrom / $config->show_maxtopics) + 1;
	
	if($pages > 1)
		$pageNavigation = $lang_topic->pages . pages($showfrom, $pages, "forum.php?f={$showforum}&s=", $config->show_maxtopics);
	
	//some variables
	$i = 0;
	$topiclist = '';

	//====================================
	//	Loop through each topic and save information about it to user
	//====================================
	while($db_topics2 = $db_topics->row())
	{		

		$replies	=	$db_topics2->replys;
		$views		=	$db_topics2->views;
		
		//alternate row coloring	
		$i++;
		$id = $i%2 + 1;
			
		//let's do the page navigation for each topic
		$pages		=	ceil($replies / $config->show_maxposts);
	
		if($pages > 1) 
		{
			$pages		=	pages(1, $pages, "topic.php?t={$db_topics2->id}&amp;s=", $config->show_maxposts);
			$pages		=	"{$lang_topic->pages}{$pages}";
		}
		else 
		{
		  	$lastPageID =	0;
		  	$pages = '';
		}

		//====================================
		//	Save variables to an array
		//====================================
		$tohtml = array(
				"pages" => $pages, 
				"lastPost"	=> $lang_topic->topics_lpost,
				"by"	=> $lang_topic->by,
				"rowID"	=>	$id,
				"topicID" => $db_topics2->id,
				"topicName" => $db_topics2->title,  
				"author" => $db_topics2->starter_name,
				"authorID"	=> $db_topics2->starter_id,
				"replies" => $replies,
				"lastAuthor" => $db_topics2->lpost_name,
				"views" => $views,
				"lastPostDate" => date($config->timestamp1, forumtime($db_topics2->lpost_time)));

		//===================
		// Add to output
		//===================		
		$topiclist .= $screen->return_html('list_topic', $tohtml);			
	}
	
	//====================================			
	//	Defines variables to use in "skin"
	//====================================
		
	$navigation	=	array("index.php?c={$db_forum->cat}" => $db_cat->name, "forum.php?f={$db_forum->id}" => $db_forum->name);
	$pagetitle	=	$db_forum->name;
	$forumname	=	$pagetitle;
	$topic		=	$lang_topic->topics;
	$author		=	$lang_topic->topics_author;
	$replies	=	$lang_topic->topics_replys;
	$views		=	$lang_topic->topics_views;
	$lastpost	=	$lang_topic->topics_lpost;
	$forumID	=	$showforum;
	
	//post-office open?
	if($user->g_create_new_posts)
	{
		$html['newtopic']	=	$lang_topic->start_newtopic;
		$html['forumID']	=	$showforum;
		$html['skin_set']	=	$user->skin_set;
		$newtopic	=	$screen->return_html('button_newtopic', $html);
		

	}
	//poll me?
	if($user->g_create_new_polls)
	{
		$html['newpoll']	=	$lang_topic->start_newpoll;
		$html['forumID']	=	$showforum;
		$newpoll	=	$screen->return_html('button_newpoll', $html);
	}

	//Subscription link
	if($user->id !=1)
		$subscribe_link = $lang_forum->subscribe;

	
	//=======================
	//	Build global template array
	//=======================
	$tohtml = array(
			//"lastPageID" => $lastpage, 
			"navigation" => $pageNavigation, 
			"forumname" => $forumname, 
			"forumID"	=> $forumID, 
			"topic" => $topic, 
			"author" => $author, 
			"replies" => $replies, 
			"views" => $views, 
			"lastpost" => $lastpost, 
  			"newtopic" => $newtopic,
			"newpoll" => $newpoll,
			"subscribe" => $subscribe_link, 
			"topiclist" => $topiclist);
	

	//=======================
	//	add rest of the page
	//=======================
	$screen->add_html('forum', $tohtml);	

	//=============================
	//	Wrap it! (umm, wraps, yummmy)
	//=============================
	$screen->add_wrapper($pagetitle, $navigation);

	//=============================
	// Print page
	//=============================
	$screen->print_page();	
}

?>