/**
 * general.js - Contains JavaScripts
 * @package VikingBoard
 * @version 0.1b
 *
 * $Id: general.js 808 2006-06-24 18:54:05Z paitrakt $
 */


/**
 * Clear a text field
 * Only clears the field if the text in it is the same as the default
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @param string clear
 * @return void
 */
function clearField(clear) {
	if(clear.value == clear.defaultValue) {
		clear.value	=	'';
	}
}

/**
 * Read cookie
 * 
 * Reads a cookie and returns the content
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @param string cookiename
 * @return string
 */
function read_cookie(name)
{
	// Cookies, yummy :D
	var cookies	=	document.cookie.split(';');

	for(var i = 0; i < cookies.length; i++)
	{
		var c	=	cookies[i];

		// Remove spaces
		while (c.charAt(0) == ' ')	c = c.substring(1, c.length);

		// Is it the right cookie?
		if(c.indexOf(name) == 0)
		{
			// Yes it was, put the content in a variable
			var content	=	c.substring(name.length + 1, c.length);
			break;
		}
		else
		{
			// No content
			var content	=	'';
		}
	}
	return content;
}

/**
 * Add multiquote
 * Adds a post to the multiquote cookie
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @param int post
 * @param string cookiename
 * return void
 */
function add_multiquote(post, cookie)
{
	// Find multiquote cookie
	var quoted	=	read_cookie(cookie);

	// Is the post already quoted?
	if(quoted.match('_' + post))
	{
		// Yes it was, remove it
		quoted	= quoted.replace('_' + post, '');
	}
	else
	{
		// Nope, add it
		quoted	+=	'_' + post;
	}

	// Set the cookie
	document.cookie	=	cookie + '=' + quoted;

	return true;
}

/**
 * Edit multiquote style
 * 
 * Changes the style of the multiquote text
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @param int post
 * @param string style
 * @return void
 */
function edit_multiquote_style(post, style)
{
	// Find the multiquote element
	var element	=	document.getElementById('mq_' + post);

	// Is the element already styled?
	if(element.style.fontStyle == style)
	{
		// Change to normal
		element.style.fontStyle	=	'normal';
	}
	else
	{
		// Nope, lets style!
		element.style.fontStyle	=	style;
	}
}