<?php

/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.1b
*
* $Id: cencor.php 890 2006-08-07 10:29:55Z jorgenboard $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}


class admin {

	/**
	 * Class loaded, this is called by the main admin page script.
	 * Management of bad words.
	 * 
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 * 
	 * @return bool
	 */
    function admin($screen, $cache, $db, $config) {

        //Set "things"
        $this->lang = new lang_admin_wordcencor();
        $this->screen= $screen;
        $this->cache = $cache;
        $this->db    = $db;
        $this->config= $config;

		//Find out what to do
		switch($_GET['cmd']) {
		  
		  	case 'delete':
		  	$this->deleteRow();
		  	$this->listWords();
		  	break;

		  	case 'addword':
		  	$this->addRow();
		  	$this->listWords();
		  	break;
		  
			default:
			$this->listWords();
  		}

        //Return html page to the main admin page
        return $this->html;
    }

	/**
	 * Adds a badword cencor
	 * 
	 * @return bool
	 */
	function addRow() {
		
		//Set variables
		$before = $_POST['before'];
		$after	= $_POST['after'];
		
		//Make shure we got all we want
		if(!$before || !$after) {
			error_msg($this->lang->missingData, 1);
		}
		
		//Lets add the word if we got everything
		$this->db->add_badword($before, $after);
		
		
		//Drop the cache (it will be reloaded/recached in the listWords function)
		$md5 = md5('get_badwords');
		$this->cache->reset($md5);				//Drop cachefile		
	}

	/**
	 * Deletes a badword cencor
	 * 
	 * @return bool
	 */
	function deleteRow() {
	
		if(is_numeric($_GET['id'])) {
			
			//Get ID
			$id = $_GET['id'];
			
			//Delete from DB
			$this->db->delete_badword($id);
			
			//Drop the cache (it will be reloaded/recached in the listWords function)
			$md5 = md5('get_badwords');
			$this->cache->reset($md5);				//Drop cachefile
			
		} else {
			error_msg($this->lang->missingData, 1);
		}
	}


	/**
	 * Shows badwords management page to user
	 * 
	 * @return bool
	 */
    function listWords() {

		//Build a list off all words
		$words = $this->cache->query('get_badwords');
		
		$row['delete']	=	$this->lang->delete;
		foreach($words as $word) {
			$row['before']	=	$word->name;
			$row['after']	=	$word->nname;
			$row['id']		=	$word->id;
			$rows			.=	$this->screen->return_html('admin_cencor_row', $row);
		}
	
		//Build the page
		$html['word_before']	=	$this->lang->word_before;
		$html['word_after']		=	$this->lang->word_after;
		$html['description']	=	$this->lang->description;
		$html['action']			=	$this->lang->action;
		$html['title']			=	$this->lang->title;
		$html['wordlist']		=	$rows;
		$html['addword']		=	$this->lang->add_new;
		$html['addWord']		=	$this->lang->addWord;
        $this->html  =   $this->screen->return_html('admin_cencor_list', $html);
	}

}
?>