<?php

/**
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @author Marius Pedersen Taule <marius@vikingboard.com>
* @version 0.1b
*
* $Id: config_site.php 1001 2006-09-20 23:07:04Z ueland $
*/

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin {

	/**
	 * Class loaded, this is called by the main admin page script.
	 * This script handles the site(s) configuration
	 * 
	 * @param obj screen
	 * @param obj cache
	 * $param obj db
	 * 
	 * @return bool
	 */
    function admin($screen, $cache, $db) {

        //Set "everything"
        $this->lang = new lang_admin_config();
        $this->screen= $screen;
        $this->cache = $cache;
        $this->db    = $db;
        $this->lang  = new lang_admin_config();

        //Lets do something
        switch($_GET['cmd']) {

			//Save config
			case 'save':
			$this->saveConfig();
			break;
			
			case 'removeSite':
			$this->removeSite();
			break;
			
			case 'createNewSite':
			$this->newSite();
			break;

			//Show config
			default:
			$this->showConfig();
		}

        //Return html page to the main admin page
        return $this->html;

        //thats all :)

    }


  /**
   *
   *  Creates a new site, wihic is not activated as default
   *
   *@return none   
   */           
   function newSite() {
  
      //Add the new site
      $name = $this->lang->new_host;
      $url  = $this->lang->url;
      $host = $this->lang->host;  
      $s = $this->db->addNewSite($name, $url, $host);
      $s = $s->id;
      
      //Reset the filecache
      $this->cache->reset();
      
      //Then redirect to the new site's configuration
      header("Location:admin.php?site={$s}&act=config_site");
   }

	/**
	 *
	 * Deletes a site based on ID input
	 *
	 */
	function removeSite(){
	
		//Make shure we have a site ID
		if(is_numeric($_GET['id'])) {
		 
			$id = $_GET['id'];
			
			//We cant delete the last site
			$sites = $this->db->countSites();
			if($sites->number == 1) {
				error_msg($this->lang->cantDeleteLastSite, 1);
			} else {
				$this->db->deleteSite($id);
				notify($this->lang->siteDeleted, 1); //Site deleted sucessfully
				
        //Reset the filecache
        $this->cache->reset();
			}
		} else {
			error_msg($this->lang->cantDeleteNothing, 1);
		}
	}


	/**
	 * Saves changes of the configuration
	 * 
	 * @return bool
	 */
	function saveConfig() {
		

		//Get vars from POST/GET
		$id				    = $_GET['site'];
		$forum_name		= $_POST['forum_name'];
		$forum_url		= $_POST['forum_url'];
		$host_name		= $_POST['hostname'];
		$homepage		  = $_POST['forum_home'];
		$forum_email	= $_POST['forum_email'];
		$timestamp_1	= $_POST['timestamp1'];
		$timestamp_2	= $_POST['timestamp2'];
		$default_tpl	= $_POST['template'];
		$active			  = $_POST['active'];
		$main_cat		  = $_POST['category'];
		$main_language= $_POST['language'];
		$image_folder	= $_POST['imgcat'];
		$topics			  = $_POST['numTopics'];
		$posts			  = $_POST['numPosts'];
		$prune_time		= $_POST['pruneTime'];

		//If we miss the most important, just redirect to the site configuration again
		if(!$forum_name || !$forum_url || !$host_name || !$id) {
			header("location:admin.php?act=config_site&site=$id&error=missing");
			exit;
		}

		// Update database
		$this->db->update_site(
			$id, 
			$forum_name, 
			$forum_url, 
			$forum_email, 
			$homepage,
			$host_name, 
			$default_tpl, 
			$main_cat,
			$main_language,
			$active,
			$image_folder,
			$topics,
			$posts,
			$prune_time,
			$timestamp_1, 
			$timestamp_2
		);

		// Reset cache
		$this->cache->reset();

		header("location:admin.php?act=config_site&site={$id}&santa=has&saved=it");
		exit;
	}


	/**
	 * Shows the configuration for site foo
	 * 
	 * @return bool
	 */
    function showConfig() {

  		//Construct a list of the different sites/domain on this board
      $sites = $this->db->get_sites();
    
  		//Create a sites drop down list
  		while($s = $sites->row()) {
  		
  		  //Get "this" site`s config
  		  if($_GET['site']  == $s->id) {
  			 $site = $s;
  		  } else if(!$site) {
          $site = $s;
        }
  		  
  		  //Set some variables used in drop-down
  			$e['value']	=	$s->id;
  			$e['name']	=	$s->forum_name;
  			$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);
  		}
  
  		//General/Simple tags
  		$html['add_site']	=	$this->lang->newSite;
  		$html['delete_site']=	$this->lang->remSite;
  		$html['id']			=	$site->id;
  		$html['content']	=	$output;
  		$html['site']		=	$site->forum_name;
  		$html['siteList']	=	$element;
  		$html['act']		=	$_GET['act'];
  		$html['forum_name']	=	$site->forum_name;
  		$html['forum_url']	=	$site->forum_url;
  		$html['hostname']	=	$site->site_host;
  		$html['email']		=	$site->forum_email;
  		$html['homepage']	=	$site->site_homepage;
  		$html['time1']		=	$site->timestamp1;
  		$html['time2']		=	$site->timestamp2;
  		$html['imageFolder']=	$site->imgcat;
  		$html['numTopics']	=	$site->show_maxtopics;
  		$html['numPosts']	=	$site->show_maxposts;
  		$html['pruneTime']	=	$site->prune_topics;
  		
  		//Drop down list containing default site template
  		unset($element);
  		$templates = $this->cache->query("get_template_sets");
  		
  		foreach($templates as $template) {
  			if($template->id == $site->def_tpl) {
  				$selected = "SELECTED";
  			}
  			$e['value']	=	$template->id;
  			$e['name']	=	$template->name;
  			$e['selected']= $selected;
  			unset($selected);
  			$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);
  		}
  		
  		$html['siteTemplate']	=	$element;
  		unset($element);
  		
  		
  		//Drop down to show if the site is activated or not
  		if($site->active == 1) {
  			$e['selected']= "SELECTED";
  		} else {
  			$e['selected']= "";
  		}
  		$e['value']	=	1;
  		$e['name']	=	"Yes";
  		$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);		
  		
  		if($site->active == 0) {
  			$e['selected']= "SELECTED";
  		} else {
  			$e['selected']= "";
  		}
  		$e['value']	=	1;
  		$e['name']	=	"No";
  		$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);
  		$html['siteActive']	=	$element;
  		unset($element);
  
  
  		//Drop down list containing default site forum category
  		unset($element);
  		$categories = $this->cache->query("get_forum_categories");
  		
  		foreach($categories as $c) {
  			if($template->id == $site->def_cat) {
  				$selected = "SELECTED";
  			}
  			$e['value']	=	$c->id;
  			$e['name']	=	$c->name;
  			$e['selected']= $selected;
  			unset($selected);
  			$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);
  		}
  		
  		$html['siteCategory']	=	$element;
  		unset($element);		
  		
  
  		//Drop down list containing default site language
  		unset($element);
  		$lang = $this->cache->query("get_languages");
  		
  		foreach($lang as $l) {
  			if($l->id == $site->def_lang) {
  				$selected = "SELECTED";
  			}
  			$e['value']	=	$l->id;
  			$e['name']	=	$l->language;
  			$e['selected']= $selected;
  			unset($selected);
  			$element	.=	$this->screen->return_html('adm_conf_global_drop_content', $e);
  		}
  		
  		$html['siteLanguage']	=	$element;
  		unset($element);	
  		
  		//Return finished HTML page
  		$this->html         =   $this->screen->return_html('adm_conf_site', $html);
  		
  }
}
?>
