<?php
/**
*
* @package Vikingboard
* @author Jørgen Tellnes <jorgis@jorgis.com>
* @version 0.1.1
* 
* $Id: forums.php 933 2006-08-30 21:00:29Z jorgenboard $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}



/**
 * The general, standard admin class for handling admin-pages
 * and other stuff.
 *
 */
class admin {

	/**
	 * Class loaded, this is called by the main admin page script.
	 * This script handles the management of categories and forums
	 * 
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 * 
	 * @return bool
	 */
    function admin($screen, $cache, $db, $config) {
		
        //Set "things"
        $this->lang = new lang_admin_forums();
        $this->screen= $screen;
        $this->cache = $cache;
        $this->db    = $db;
        $this->config= $config;
		
		//Find out what to do
		$cmd = @$_GET['cmd'];
		
		switch ($cmd) {

			//Edit category
			case 'editcat':
			$this->editCategory();
			break;
			
			//Edit forum
			case 'editforum':
			$this->editForum();
			break;
			
			//Add forum
			case 'newforum':
			$this->addForum();
			break;
			
			//new category
			case 'newcat':
			$this->addCat();
			break;
			
			//Delete forum
			case 'deleteforum':
			$this->deleteForum();
			break;
			
			//Delete category
			case 'deletecat':
			$this->deleteCategory();
			break;
			
			//synchronize forum
			case 'resyncforum':
			$this->resyncForum();
			break;
			
			//move forum
			case 'moveforum':
			$this->move_forum();
			break;
			
			//move category
			case 'movecat':
			$this->move_cat();
			break;
			
			//Show listing
			default:
			$this->listForums();
			break;
  		}

        //Return html page to the main admin page
        return $this->html;
    }

    /**
     * Add a new forum to the board
     *
     */
    function addForum() 
    {

		//Save a new forum?
		if (!empty($_POST['name'])) 
		{

			//Save it if all fields is good
			if (!empty($_POST['name']) && !empty($_POST['descr']) && is_numeric($_POST['category'])) 
			{
				
				//find the order
				$order = $this->db->get_last_forum($_POST['category']);
				
				$this->db->createForum($_POST['name'], $_POST['descr'], $_POST['category'], $order->order + 10);

				//flush the cache and get back to forum listing
				$this->cache->reset();
				header("Location: admin.php?act=forums");
	  		} 
	  		else 
	  		{
				//Complain if we didn't get all the data we need
                $html['infoMessage']  =   $this->lang->missingData;
                
			}
  		}


		//What ID to add this forum to?
		if (is_numeric($_GET['id'])) 
		{
			$id =  $_GET['id'];
	  	}
		
		//Get categories and construct the list
		$categories = $this->cache->query('get_forum_categories');
		
		$categoryList	=	'';
			
		foreach ($categories as $category) 
		{
			$categoryList   .=  $this->screen->return_html('dropdown_option', array('value' => $category->id, 'selected' => '', 'name' => $category->name));
		}
		
		//Show the add forum page
		$html['id']     =   $id;
		$html['name']   =   $this->lang->forumname;
		$html['descr']  =   $this->lang->forumdescr;
		$html['category']=  $this->lang->forumcategory;
		$html['categorylist']= $categoryList;
		$html['create'] =   $this->lang->createForum;
		$html['go_back']	=	$this->lang->editforum_back;
				
		
		$this->html 			=   $this->screen->return_html('admin_forums_addforum', $html);
	}
	
	/**
	 * Add a new category to the board
	 *
	 */
	function addCat()
	{
		//is there any action?
		if ($_POST['name'] && $_POST['descr'])
		{
			//get cat order
			$order = $this->db->get_last_cat();
			
			$this->db->createCategory($_POST['name'], $_POST['descr'], $order->order + 10);
			
			//flush cache
			$this->cache->reset();
		
			header("Location: admin.php?act=forums");
		}
				
		
		$html['name']   =   $this->lang->categoryname;
		$html['descr']  =   $this->lang->categorydescr;
		$html['create'] =   $this->lang->createCategory;	
		$html['go_back'] = 	$this->lang->editforum_back;
		
		//and output
		$this->html		=	$this->screen->return_html('admin_forums_addcat', $html);
	}
   
	/**
	 * Edit a specified category
	 *
	 */
    function editCategory() 
    {

  		//Category id
		if (is_numeric($_GET['id'])) 
		{
			$id =   $_GET['id'];
  		} 
  		else 
  		{
			$id =   1;
		}
		
		//Should we save some data?
		if (isset($_POST['name'])) 
		{
			//okey then, first update database
			$this->db->updateCategory($id, $_POST['name'], $_POST['descr'], $_POST['extended']);
			
			//Then flush cached data
			$this->cache->reset();
			
			//And redirect
			header('Location: admin.php?act=forums');
			exit();
  		}
		
		//Fetch information about it
		$info   =   $this->cache->query('get_forum_category', array('0' => $id));
		$info   =   $info[0];
		
		if ($info->extend == '1')
		{
			$html['checked']	=	'checked';
		}
		else 
		{
			$html['checked']	=	'';
		}
		
		//Print the edit form
		$html['categoryName']   =   $info->name;
		$html['id']     		=   $info->id;
		$html['descr']  		=   $info->descr;
		$html['name']           =   $this->lang->catName;
		$html['description']    =   $this->lang->catDescr;
		$html['update']         =   $this->lang->catUpdate;
		$html['extended']		=	$this->lang->editforum_extended;
		
		
		$this->html 			=   $this->screen->return_html('admin_forums_editcat', $html);
		unset($html);
	}
    
	/**
	 * Edit a specified forum
	 *
	 */
	function editForum()
	{
	
		$forumid = $_GET['id'];
		
		//are there anything to do?
		if ($_POST['name'])
		{
			//update the forum info
			$this->db->update_forum_info($forumid, $_POST['name'], $_POST['description']);
			
			if ($_POST['category'] != '0')
			{
				$this->db->move_forum($forumid, $_POST['category']);
			}
			
			header('Location: admin.php?act=forums');
			die();
		}
		
		//get all categories available
		$cat = $this->db->get_forum_categories();
		$cat_move = $this->screen->return_html("dropdown_option", 
										array('value' => '0', 'selected' => 'selected="selected"', 'name' => $this->lang->editforum_sel_cat));
		while ($cats = $cat->row())
		{
			
			$html = array(	'value' 	=>	$cats->id,
							'selected'	=>	'',
							'name'		=>	$cats->name);
			$cat_move .= $this->screen->return_html("dropdown_option", $html);
			unset($html);
		}
		
		
		//then let us output the form
		$forum = $this->db->get_forum_info($forumid);
		
		$html['title']		=	$this->lang->editforum_title . '"' . $forum->name . '"';
		$html['name_label']	=	$this->lang->editforum_name;
		$html['descr_label'] =	$this->lang->editforum_descr;
		$html['back']		=	$this->lang->editforum_back;
		$html['submit']		=	$this->lang->editforum_submit;
		$html['name']		=	$forum->name;
		$html['descr']		=	$forum->descr;
		$html['id']			=	$forum->id;
		$html['move_category']	=	$this->lang->editforum_move_category;
		$html['categories']	=	$cat_move;
		$this->html			=	$this->screen->return_html('admin_forums_editforum', $html);
		
	}
	
	/**
	 * Move a forum up/down
	 *
	 */
	function move_forum()
	{
		$move 	= $_GET['move'];
		$id		= $_GET['id'];
		
		$forum 	= $this->cache->query('get_forum_cat', array($id));
		$forum 	= $forum[0];
		
		switch ($move)
		{
			case 'up':
				$this->db->change_forum_order($id, "- '15'");
				$this->realign($forum->cat);
				break;
				
			case 'down':
				$this->db->change_forum_order($id, "+ '15'");
				$this->realign($forum->cat);
				break;
		}
	}
    
	/**
	 * Move a category up/down
	 *
	 */
	function move_cat()
	{
		$move 	= $_GET['move'];
		$id		= $_GET['id'];
		
		switch ($move)
		{
			case 'up':
				$this->db->change_cat_order($id, "- '15'");
				$this->realign(0);
				break;
				
			case 'down':
				$this->db->change_cat_order($id, "+ '15'");
				$this->realign(0);
				break;
		}
	}
	
	/**
	 * Recount and readjust all the forum ordering stuffies
	 *
	 * @param int $cat
	 */
	function realign($cat)
	{
		if ($cat != '0')
		{
			//get all forums in cat, ordered by order field
			$forums = $this->db->get_forums_in_category($cat);
			
			$order = 10;
			//loop'em all!
			while ($f = $forums->row())
			{
				//update all forum orders
				$this->cache->query('update_forum_order', array($f->id, $order));
				$order += 10;
			}
		}
		elseif ($cat == '0')
		{
			$cats = $this->db->get_forum_categories();
			
			$order = 10;
			
			//loopin'
			while ($c = $cats->row())
			{
				//update all cat orders
				$this->cache->query('update_cat_order', array($c->id, $order));
				$order += 10;
			}
		}
		
		//flush cache and return
		$this->cache->reset();
		header('Location: admin.php?act=forums');
		exit();
	}
	
	/**
	 * Deletes a forum
	 *
	 */
	function deleteForum()
	{
		global $user;
		
		//global vars
		$id 		= $_GET['id'];
		$confirm 	= $_GET['confirm'];
		$do 		= $_GET['do'];
		$move		= $_POST['move'];
		
		//are there any "leftovers"?
		$forum	=	$this->db->get_topics_in_forum($id);
		
		$forumname	= 	$this->db->get_forum_info($id);
		
		//is there any topics/posts left in the forum?
		if ($forum->total > 0)
		{
			if (!$do)
			{
				//get all forums for the dropdown
				$forums		=	$this->cache->query("get_all_forums");
				 	
				$forumlist = '';
				foreach ($forums as $f)
				{
					if ($f->id != $id)
						$forumlist .= $this->screen->return_html('dropdown_option', array('value' => $f->id, 'selected' => '', 'name' => $f->name));
				}
				
				//output the choices
				$html['descr']	=	str_replace('%forum%', $forumname->name, $this->lang->delforum_descr);
				$html['id']		=	$id;
				$html['options'] =	$forumlist;
				$html['skin_set'] = $user->skin_set;
				$this->html			=	$this->screen->return_html('admin_forums_deleteforum', $html);
			}
			elseif ($do == 'delete')
			{
				//de1337
				$this->db->delete_forum($id);
				$this->cache->reset();
				header("Location: admin.php?act=forums");
				exit();
			}
			elseif ($do == 'move')
			{
				//move to the selected forum
				$this->db->move_forum_contents($id, $move);
				
				//and unlink the forum
				$this->db->delete_forum($id);
				$this->cache->reset();
				header("Location: admin.php?act=forums");
				exit();
				
			}
			
		}
		elseif ($forum->total == 0)
		{
			//reaaally sure?
			if ($confirm != 'yes')
			{
				$this->html 		= admin_confirm(str_replace('%forum%', $forumname->name, $this->lang->delforum_descr_notopics), array($this->lang->delete_forum => 'admin.php?act=forums&amp;cmd=deleteforum&amp;id=' . $id . '&amp;confirm=yes', $this->lang->abort_delete => 'admin.php?act=forums'));
			}
			elseif ($confirm == 'yes')
			{
				//de1337
				$this->db->delete_forum($id);
				$this->cache->reset();
				header("Location: admin.php?act=forums");
				exit();
			}
		}
		
		
	}
	
	/**
	 * Deletes a category
	 *
	 * 
	 * @todo Fix the order-values for moved forums, so that they will be max_order + 1 and above
	 */
	function deleteCategory()
	{
		global $user;
		
		//globals
		$id 		=	$_GET['id'];
		$confirm	=	$_GET['confirm'];
		$do			=	$_GET['do'];
		$move		=	$_POST['move'];
		
		//get some info, so we can make qualified judgements
		$cat 		= $this->db->get_cat_topics($id);
		$catinfo	= $this->db->get_forum_category($id);
		$catinfo	= $catinfo->row();
		
		//is there any topics (and therefore also posts) left in the category?
		if ($cat->topics > '0')
		{
			
			//then, what do the user want us to do?
			if (!$do)
			{
				$cats 	=	$this->cache->query('get_forum_categories', array());
			
				//get the categories to suggest
				$categories = '';
				foreach ($cats as $cat)
				{
					if ($cat->id != $id)
					{
						$categories .= $this->screen->return_html('dropdown_option', array('value' => $cat->id, 'selected' => '', 'name' => $cat->name));
					}
				}
				
				//construct the page and send it to stdout
				$html = array('skin_set' 	=> $user->skin_set,
								'descr'		=> str_replace('%cat%', $catinfo->name, $this->lang->delcat_descr),
								'id'		=> $id,
								'options'	=> $categories);
								
				$this->html = $this->screen->return_html('admin_forums_deletecat', $html);
			}
			elseif ($do == 'delete')
			{
				//de1337
				$this->db->delete_category($id);
				$this->cache->reset();
				
				//return
				header('Location: admin.php?act=forums');
				exit();
			}
			elseif ($do == 'move')
			{
				//move to the selected forum
				$this->db->move_category_contents($id, $move);
				
				//and unlink the forum
				$this->db->delete_category($id);
				$this->cache->reset();
				header('Location: admin.php?act=forums');
				exit();
			}
			
		}
		elseif ($cat->topics == '0')
		{
			//reaaally sure?
			if ($confirm != 'yes')
			{
				$this->html 		= admin_confirm(str_replace('%cat%', $catinfo->name, $this->lang->delcat_descr_notopics), array($this->lang->delete_category => 'admin.php?act=forums&amp;cmd=deletecat&amp;id=' . $id . '&amp;confirm=yes', $this->lang->abort_delete => 'admin.php?act=forums'));
			}
			elseif ($confirm == 'yes')
			{
				//de1337
				$this->db->delete_category($id);
				$this->cache->reset();
				
				//return
				header('Location: admin.php?act=forums');
				exit();
			}
		}
	}
	
	/**
	 * Update and resynchronize the post/topic-stats
	 * for a specified forum
	 *
	 */
	function resyncForum()
	{
		
		$forumid = $_GET['id'];
		
		//get the REAL number of posts
		$post	=	$this->db->get_posts_in_forum($forumid);
		$post	=	$post->total;
		
		//and the REAL number of topics
		$topics =	$this->db->get_topics_in_forum($forumid);
		$topics =	$topics->total;
		
		//and check if we need to update the post/topic-stats
		$stats 	=	$this->db->get_forum_stats($forumid);
		
		//update
		if (($stats->stat_posts != $post) OR ($stats->stat_threads != $topics))
		{
			$this->db->update_forum_stats($forumid, $topics, $post);
		}
		
		//and then let us get back to where we were
		$this->cache->reset();
		header('Location: admin.php?act=forums');
		exit();
	}
	
	/**
	 * Lists all forums and categories
	 *
	 */
    function listForums() 
    {

		global $user;
			
		//Fetch and loop over categories
		$categories = $this->cache->query('get_forum_categories');

		$output = '';	
		foreach ($categories as $category) 
		{

			$html['name']   =   $category->name;
			$html['id']     =   $category->id;
			$html['edit']   =   $this->lang->edit;
			$html['delete'] =   $this->lang->delete;
			$html['resync']	=	$this->lang->resync;
			$html['move']   =   $this->lang->move;
			$html['new']    =   $this->lang->new;
			$html['img_set'] =	$user->skin_set;
			
			$output 		.=  $this->screen->return_html('admin_forums_cat', $html);
			unset($html);
			
			//Then loop over forums in this category
			$forums =   $this->cache->query('get_forums_in_category', array($category->id));
			
			foreach ($forums as $forum)
			{
				$html['name']   =   $forum->name;
				$html['edit']   =   $this->lang->edit;
				$html['delete'] =   $this->lang->delete;
				$html['move']   =   $this->lang->move;
				$html['resync'] =   $this->lang->resync;
				$html['descr']	=	$forum->descr;
				$html['topics']	=	$forum->stat_threads;
				$html['posts']	=	$forum->stat_posts;
				$html['img_set']	=	$user->skin_set;
				$html['id']		=	$forum->id;
				
				$output 		.=  $this->screen->return_html('admin_forums_forums', $html);
				unset($html);
			}
			
			$output .= $this->screen->return_html('admin_forums_endcat', array());
		}


		//Fetch the "wrapper" for the forum management
		$html['content'] =   $output;
		$html['createCategory']	=	$this->lang->createCategory;
		$html['createForum']	=	$this->lang->createForum;
        $this->html  	=   $this->screen->return_html('admin_forums_main', $html);
	}

}
?>