<?php

/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.1b
*
* $Id: templates.php 828 2006-06-29 19:49:13Z jorgenboard $
*
*/

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}


class admin {

	/**
	 * Class loaded, this is called by the main admin page script.
	 * This whole script handles management of themplates
	 * 
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 * 
	 * @return bool
	 */
    function admin($screen, $cache, $db, $config) {

        //Set langauge
        $this->lang = new lang_admin_templates();
        $this->screen= $screen;
        $this->cache = $cache;
        $this->db    = $db;
        $this->config= $config;
        
        //what to do?
        switch ($_GET['cmd'])
        {
            case "editor":
            $this->html = $this->editor();
            break;
            
            case "newcode":
            $this->html = $this->newCodeForm();
            break;
            
            case "addNewCode":
            $this->html = $this->addNewCode();
            break;

			case "addcategory":
            $this->html = $this->addCatForm();
            break;

			case "addNewCategory":
            $this->html = $this->saveNewCat();
            break;
            
            default:
        	$this->html = $this->show_template_sets();
        	break;
        }
        
        //Return content
        return $this->html;
    }

    //======================= 
    //  Show a "new category" form
    //=======================
    function addCatForm() {
		//Get language
        $lang 			=	$this->lang;
        $html['info']   =   $lang->newCategoryInfo;
        $html['name']   =   $lang->newCatName;
        $html 			=	$this->screen->return_html('admin-tpl_addcategory', $html);
    	return $html;
	}

    //=======================
    //  Save a new category
    //=======================
    function saveNewCat() {
		if($_POST['catName'] !="") {

			//Add to DB
			$this->db->add_template_category($_POST['catName']);
			
			//Drop cache (it will magicly be recached)
			$this->cache->reset();
			
			//Redirect user
			header("Location:admin.php?act=templates");
  		} else {

			//Else show an error message (if we dont have a name)
            $lang = $this->lang;
			error_msg($lang->missing_data, 1);
		}
	}

	//======================= 
    //  Save a new template to the database and make it usable
    //=======================
    function addNewCode() {

		//make shure we have all that we need
		if($_POST['content'] !="" && $_POST['tagName'] !="" && $_POST['niceName'] !="") {
			$this->db->add_template_tag($_POST['tagName'], $_POST['niceName'], $_POST['content'], $_POST['category']);
			header("Location:admin.php?act=templates");
  		} else {
            $lang = $this->lang;
			error_msg($lang->missing_data, 1);
		}

	}

	//=======================
    //  Add template code form
    //=======================
    function newCodeForm() {

		//Get language
        $lang = $this->lang;
        
        //Add text to the output
        $html['info']   =   $lang->newCodeInfo;
        $html['html']   =   $lang->codeContent;
        $html['niceName']=  $lang->niceName;
        $html['tagName']=   $lang->tag;
        $html['cat']    =   $lang->cat;
        
        //Fetch some categories
        $categories		=	$this->cache->query('get_template_categories');
		foreach($categories as $row) {
			$html['dropDown']   .=  '<option value="'.$row->id.'">'.$row->name.'</option>';
  		}

		//show the form
        $html = $this->screen->return_html('admin-tpl_addcode', $html);
    	return $html;

	}
    
    
    //=======================
    //  Show a editor
    //=======================
    function editor() {

        //Get language
        $lang = $this->lang;
        
        //Update content?
        if($_POST['html']) {

			//Make good code
			$htmlCode   =   $_POST['html'];
			#$htmlCode   =   str_replace("'", "\\'", $htmlCode);
			#echo  $htmlCode; die;
			
			//Update database
			$category   =   $_POST['category'];
			$this->db->update_template_code($_GET['id'], $htmlCode, $category);

			//Drop cache
			global $config;
			//      =   md5("template name    - set id - template name")
			$md5sum =   md5("get_template{$config->def_tpl}{$_POST['systemName']}");
			$this->cache->reset($md5sum);
			$md5sum =   md5("get_template_from_id{$_GET['id']}");
			$this->cache->reset($md5sum);
			
			//Redirect back
			header("Location:admin.php?act=templates&cmd=editor&id={$_GET['id']}");
		}
        

        //Fetch the template to work with now
        $tplInfo[]  =   $_GET['id'];     //Template id
        $templateInfo = $this->cache->query('get_template_from_id', $tplInfo);
        $templateInfo = $templateInfo[0];

        //Build a category list
        $toDrop['name']     =   "category";
        $dropDown   =   $this->screen->return_html('dropdown_start', $toDrop);
        $categories =   $this->cache->query('get_template_categories');
        foreach($categories as $category) {
			$content['value']   =   $category->id;
			$content['name']    =   $category->name;
			if($category->id == $templateInfo->cat ) {
				$content['selected']=   "selected";
			} else {
				$content['selected']=   "";
			}
            $dropDown   .=   $this->screen->return_html('dropdown_option', $content);
		}
        $dropDown   .=   $this->screen->return_html('dropdown_end', $toDrop);
        
        //Define template tags for the editor (content);
        $html['templateId'] =   $_GET['id'];
        $html['niceName']   =   $templateInfo->nice_name;
        $html['systemName'] =   $templateInfo->name;
        $html['category']   =   $dropDown;
        $html['html']       =   htmlentities($templateInfo->code);
        
        //Get the template to show the editor
        $html = $this->screen->return_html('admin-tpl_editor', $html);
    	return $html;
    }

    
    //=======================
    //  Just show all the template sets
    //=======================
    function show_template_sets($screen, $cache, $db) {

        //Get language
        $lang = $this->lang;

    	//Get template sets
    	$sql = $this->cache->query('get_template_sets');

        //Loop over them
        foreach($sql as $row) {

            //Mark the unactive as unactive
            if($row->active == 0) {
                $name   =   "{$lang->unactive}{$row->name}";
            } else {
                $name   =   $row->name;
            }

			//add some html
            $set['name']=   $name;
            $set['id']	=   $row->id;
            $sets		.=  $this->screen->return_html('admin_tpl_listset', $set);
            
			//is this the active set?
			//Then show the categories :D
			if($row->id == $_GET['active']) {
				$thisCat[]= $row->id;
				$catSQL =   $this->cache->query('get_template_categories');
				foreach($catSQL as $thisCat) {
					$cat['name']    =   $thisCat->name;
                    $sets   .=  $this->screen->return_html('admin-tpl_listcat', $cat);
                    
                    //For each category, find templates in the category
                    $getTpl[]=  $row->id;       //setID
					$getTpl[]=  $thisCat->id;	//catID
                    $tplSQL =   $this->cache->query('get_templates_in_set_and_cat', $getTpl);
                    foreach($tplSQL as $thisTPL) {
						$tpl['name']    =   $thisTPL->nice_name;
						$tpl['id']      =   $thisTPL->id;
                        $sets   .=  $this->screen->return_html('admin-tpl_listtpl', $tpl);
			  		}
			  		unset($getTpl);
				}
				
				//Also add "unspesified as a category"
				$cat['name']    =   "Undefined template bits";
    			$sets   .=  $this->screen->return_html('admin-tpl_listcat', $cat);

				$getTpl[]=  $row->id;	//setID
				$getTpl[]=  0;			//catID
    			$tplSQL =   $this->cache->query('get_templates_in_set_and_cat', $getTpl);
   				foreach($tplSQL as $thisTPL) {
					$tpl['name']    =   $thisTPL->nice_name;
					$tpl['id']      =   $thisTPL->id;
     				$sets   .=  $this->screen->return_html('admin-tpl_listtpl', $tpl);
	  			}
		  		unset($getTpl);
	  		}
    	}
    	
    	//Add html to output
    	$html['info']              =   $lang->info;
    	$html['listtemplatesets']  =   $sets;
        $html = $this->screen->return_html('admin_tpl_main', $html);
    	return $html;
    }
    
}
?>
