<?php

/**
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @author Robin Aaberg
* @author Marius Pedersen Taule <marius@vikingboard.com>
* @author Jørgen Tellnes <jorgis@jorgis.com>
* @version 0.1.1
*
* $Id: user.php 966 2006-09-18 19:31:40Z jorgenboard $
*/

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin
{

	/**
	 * Class loaded, this is called by the main admin page script.
	 * User management in Admin CP
	 * 
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 */
	function admin($screen, $cache, $db,  $config)
	{
		global $user;

		// Setting a few variables
		$this->screen	=	$screen;
		$this->cache	=	$cache;
		$this->db		=	$db;
		$this->config	=	$config;
		$this->user		=	$user;
		$this->lang		=	new lang_admin_user();

		//Determinating what to do
		switch ($_GET['cmd'])
		{
			case 'add':
			$this->add_user();
			break;

			case 'add_data':
			$this->add_user_data();
			break;

			case 'edit':
			$this->edit_user();
			break;

			case 'edit_data':
			$this->edit_user_data();
			break;
			
			case 'delete':
			$this->delete_user();
			break;

			case 'manage_ban':
			$this->manage_ban();
			break;
			
			case 'ban':
			$this->ban_user();
			break;
			
			default:
			$this->add_user();
		}
	}


	/**
	 * Add user
	 * Displays the form that let's an admin add a user
	 *
	 * @return void
	 * 
	 */
	function add_user()
	{
		
		// Get all user groups and display in the dropdown
		$groups			=	$this->db->get_groups();
		$options		=	'';
		
		while ($group = $groups->row())
		{
			// Is this group the default one?
			if ($group->id == $this->config->reg_group)
			{
				$selected	=	'selected="selected"';
			} 
			else 
			{
				$selected	=	'';
			}

			$option	=	array(
				'value'		=>	$group->id,
				'selected'	=>	$selected,
				'name'		=>	$group->g_name,
			);

			$options	.=	$this->screen->return_html('dropdown_option', $option);
		}

		
		//construct the rest of the form
		$html	=	array(
			'title'			=>	$this->lang->add_title,
			'submit_btn'	=>	$this->lang->add_btn,
			'name'			=>	$this->lang->add_name,
			'password'		=>	$this->lang->add_password,
			'cpassword'		=>	$this->lang->add_cpassword,
			'email'			=>	$this->lang->add_email,
			'group'			=>	$this->lang->add_group,
			'options'		=>	$options,
		);
		
		//have we already added a user?
		if ($_GET['u'])
		{
			$html['notice'] = str_replace('%user%', $_GET['u'], $this->lang->add_added);
		}
		
		//output the form
		$this->html	=	$this->screen->return_html('admin-tpl_usermanage_add', $html);
	}


	/**
	 * Add user
	 * Adds the new user to the database
	 *
	 * @return void
	 * 
	 */
	function add_user_data()
	{
		
		//extra language bits
		$lang_register = new lang_register();
		
		//input
		$username	=	$_POST['name'];
		$password	=	$_POST['password'];
		$cpassword	=	$_POST['cpassword'];
		$email		=	$_POST['email'];
		$group		=	$_POST['group'];

		//check for various invalid inputs
		if(!$username)
		{
			error_msg($this->lang->add_error_username, 1);
		}

		if($password != $cpassword)
		{
			error_msg($this->lang->add_error_pwnomatch, 1);
		}

		if(!is_valid_email_address($email))
		{
			error_msg($this->lang->add_error_nonvalidemail, 1);
		}

		//Do we allow multible registrations from the same mail adress?
		if (!$this->config->multi_reg)
		{
			$multimail	=	$this->db->get_num_emails($email);
			
			if ($multimail->rows !=0)
			{
				error_msg($lang_register->add_error_multimail, 1);
			}
		}

		//check for "wrong" input
		$username	=	htmlentities($username);
		$username	=	strip_tags($username);
		
		//check the minimum length for the password
		if (strlen($password) < $this->config->password_length)
		{
			error_msg($lang_register->too_short_password . $this->config->password_length, 1);
		}

		//check for the minimum password complexity
		if (password_strength($password) < $this->config->password_strength)
		{
			error_msg($lang_register->too_simple_password, 1);
		}

		//check for minimum username length
		if (strlen($username) < $this->config->username_length)
		{
			error_msg($lang_register->too_short_username . $this->config->username_length, 1);
		}

		// Checking the username to make sure we don't get any clones :D
		$usr_numcheck	=	$this->db->get_username_from_name($username);
		$usr_numcheck   =   $usr_numcheck->row();

		if($usr_numcheck->id)
		{
			error_msg($lang_register->name_taken, 1);
		}

		// Update stats (we love stats!)
		$this->db->update_global_stats('users');

		// Adding the user.. 
		$this->db->insert_new_user_data($username, md5($password), $email, $group);

		// Adding user to member_extra
		$new_id	=	$this->db->get_latest_user();
		$new_id	=	$new_id->id;

		$this->db->insert_extra_user_data($new_id);

		//And returns to the form again
		header('Location: admin.php?act=user&cmd=add&u=' . $username);
		exit();

	}


	/**
	 * Edit user
	 * Displays the edit user form
	 *
	 * @todo It should be possible to search for a user, based on parts of the username
	 * @return void
	 * 
	 */
	function edit_user()
	{
		//display the form/search
		if (!$_POST['user'])
		{
			$html	=	array(
					'title'			=>	$this->lang->edit_title,
					'desc'			=>	$this->lang->edit_desc,
					'user'			=>	$this->lang->edit_user,
					'submit_btn'	=>	$this->lang->edit_submit_name);
	
			$this->html	=	$this->screen->return_html('admin_edit_user_frontpage', $html);
		}
		else
		{
			//get user info
			$u = $_POST['user'];
			
			if(is_numeric($u))
			{
				$user = $this->db->select_user_from_id((int)$u);
			}
			else 
			{
				$user = $this->db->select_user_from_name($u);
			}
			
			//is there no user to match?
			if (!$user)
			{
				error_msg($this->lang->edit_error_user_no_exists, 1);
			}
			
			/**
			 * A list of all available editable fields, to be easily traversed
			 * 
			 * 0 = textfield
			 * 1 = password
			 * 2 = textarea
			 * 3 = select (custom code needed)
			 */
			
			$fields = array(
				'name' => 0, 
				'new_password' => 1,
				'new_cpassword' => 1, 
				'email' => 0,
				'lang' => 3,
				'skin_set' => 3,
				'group' => 3,
				'signature' => 2,
				'avatar' => 0,
				'location' => 0,
				'homepage' => 0,
				'interests' => 0,
				'blog' => 0,
				'real_name' => 0,
				'birthday' => 0,
				'im_msn' => 0,
				'title' => 0,
				'warnlevel' => 0);
				
			//looping over all the fields, and setting the templates	
			foreach ($fields as $nameTag => $type) 
			{
				switch($type) 
				{
					case 1:
					$type	=	'password';
					$tpl	=	'admin-tpl_user_input';
					break;
				
					case 2:
					$type	=	'textarea';
					$tpl	=	'admin-tpl_user_textarea';
					break;
					
					case 3:
					$type	=	'select';
					$tpl	=	'admin-tpl_user_select';
					break;
			
					default:
					$type	=	'text';
					$tpl	=	'admin-tpl_user_input';
					break;
				}
				
				//is this a photo field?
				unset($photo);
				
				if ($nameTag == 'avatar') 
				{
					if (!empty($user->avatar)) 
					{
						$photo = $this->screen->return_html('framed_image', array('src' => $user->avatar, 'alt' => ''));
					}
				}
				
				//a select-field?
				if ($type == 'select') 
				{
					
					// Unsetting
					unset($options);
					unset($temp_select);
					
					//a select needs custom code
					switch($nameTag) 
					{
						case 'group':
							$opt_name = 'g_name';
							$opt_value = 'id';
							$table = 'group';
							$order = 'ASC';
						break;
						
						case 'skin_set':
							$opt_name = 'name';
							$opt_value = 'id';
							$table = 'template_sets';
							$order = 'ASC';
						break;
						
						case 'lang':
							$opt_name 	= 'language';
							$opt_value 	= 'id';
							$table 		=	'languages';
							$order		=	'ASC';
						break;
					}
					
					//do the custom query
					$temp_select = $this->db->select_get($opt_name, $table, $order);	
					
					//and then construct the options
					while ($row = $temp_select->row()) 
					{
						//Make the users choice the default value
						if ($row->{$opt_value} == $user->{$nameTag})
						{
							$selected = 'selected="selected"';
						}
						else 
						{
							$selected = '';
						}
						
						$options .= '<option value="' . $row->{$opt_value} . '" ' . $selected . ' >' . $row->{$opt_name} . '</option>';
					}
				}
				
				
				//label
				$label = 'edit_user_label_' . $nameTag;
				
				//field content
				$field_fills = array(
					'type' => $type,
					'value' => $user->{$nameTag},
					'name' => $nameTag,
					'options' => $options,
				);
		
				//all fields
				$fills = array(
					'for' => $nameTag,
					'label' => $this->lang->{$label},
					'field' => $this->screen->return_html($tpl, $field_fills),
					'photo_preview' => $photo	
				);
				
				
				$wooe .= $this->screen->return_html('admin-tpl_user_edit_field', $fills);
				
			}
				
				
					
			//display edit form
			$html = array('title'		=>	$this->lang->edit_user_form_title,
						'desc'			=>	$this->lang->edit_user_form_descr,
						'submit_btn'	=>	$this->lang->edit_user_submit_btn,
						'id'			=>	$user->id,
						'fields'		=>	$wooe);
			
			$this->html = $this->screen->return_html('admin_user_edit', $html);
			
		}
		
		
	}


	/**
	 * The actual user editing is done here, by order of the edit_user() function
	 *
	 * @return unknown
	 * 
	 */
	function edit_user_data()
	{
		
		$id = $_POST['id'];
		
		if (is_numeric($id))
		{
			$user = $this->db->select_user_from_id($id);
		}
		else 
		{
			error_msg("no_username", 1);
		}
		
		// new password ?
		if (!empty($_POST['new_password']) && !empty($_POST['new_cpassword']))
		{
			if ($_POST['new_password'] == $_POST['new_cpassword'])
			{
				$_POST['password']	=	md5($_POST['new_password']);
			}
			else
			{
				error_msg($this->lang->edit_error_new_pass_no_match, 1);
			}
		}
		//====================
		// Validation
		//====================

		// validating email
		if (!is_valid_email_address($_POST['email']) && !empty($_POST['email']))
		{
			error_msg($this->lang->add_error_nonvalidemail, 1);
		}

		// Do we allow multiply email ?
		if (!$this->config->multi_reg && $user->email != $_POST['email'])
		{
			$multimail	=	$this->db->get_num_emails($_POST['email']);

			if (!empty($multimail->id))
			{
				error_msg(str_replace('%s', $_POST['email'], $this->lang->add_error_multimail), 1);
			}
		}
		
		// No multiply name entries in the db thankyou.
		if ($user->name != $_POST['name'])
		{
			$usr_numcheck	=	$this->db->get_username_from_name($_POST['name']);
			$usr_numcheck	=	$usr_numcheck->row();
			
			if($usr_numcheck->id) 
			{
				error_msg(str_replace('%s', $_POST['name'], $this->lang->add_error_nameistaken), 1);
			}
		}

		//remove invalid POST-values
		unset($_POST['new_cpassword']);
		unset($_POST['new_cpassword']);
		unset($_POST['new_password']);
		unset($_POST['new_password']);
		
		//loop over the fields, and update if necessary
		$i = 0;
		foreach ($_POST as $column => $datas)
		{
			if ($datas != $user->{$column})
			{
			  $i++;
			  $this->db->update_user($id, $column, $datas);
			}
		}

		if ($i == 0 )
		{
			error_msg($this->lang->edit_error_no_change, 1);
		}

		//returning the the edit thingy
		header('Location: admin.php?act=user&cmd=edit');
		die();
	}

	
	/**
	 * Delete user
	 * Let an admin delete a user
	 *
	 * @todo Search instead of precise input
	 * 
	 * Both for this and edit user, it could be possible to make ONE search for user-form (with search backend), 
	 * and just replace some labels to make it "custom". 0.2-material, I think.
	 * 
	 */
	function delete_user()
	{
		// Do we have a user to delete ? If not, print html
		if ($_POST['name'] || $_POST['id'] || $_GET['id'])
		{
			
			$id 	= $_POST['id'];
			$name	= $_POST['name'];
			
			//from the ban thingy
			if (!empty($_GET['id']))
			{
				$id = $_GET['id'];
			}
			
			//if we don't know the ID, let's find it
			if (empty($id) && !empty($name))
			{
				$id = $this->db->get_id_from_name($name);
				$id = $id->id;
			}
			
			//and let's get the name, for good measure
			if (empty($name) && !empty($id))
			{
				$name = $this->db->select_user_from_id($id);
				$name = $name->name;
			}
			
			// Just so some dumbass won't delete himself:
			if ($id == $this->user->id) 
			{
				error_msg($this->lang->drop_error_selfdrop, 1);
			}

			//do the dropping
			$this->db->drop_user_from_id($id);
	
			//from the ban thingie
			if ($id == $_GET['id'])
			{
				header('Location: admin.php?act=user&cmd=ban');
				exit();
			}
			
			//return, and notify that we did it
			header("Location: admin.php?act=user&cmd=delete&notice=" . str_replace('%s', $name, $this->lang->drop_deleted_name));
			exit();	
		
		}
		
		
		//output the form and stop execution
		$fills	=	array(
				'title'			=>	$this->lang->drop_title,
				'submit_btn'	=>	$this->lang->drop_btn,
				'id'			=>	$this->lang->drop_id, 
				'name'			=>	$this->lang->drop_name,
				'notice'		=>	strip_tags(htmlentities($_GET['notice'])),
				'or'			=>	$this->lang->drop_or,
				'drop_desc'		=>	$this->lang->drop_desc
			);

		$this->html	=	$this->screen->return_html('admin-tpl_usermanage_drop', $fills);
		
	}

	/**
	 * Ban user
	 * 
	 * Let an admin ban a user
	 *
	 */
	function ban_user()
	{
		if (!empty($_GET['unban']))
		{
			$id		=	$_GET['unban'];
			$user	=	$this->db->select_user_from_id($id);

			// Do you exist?
			if (empty($user->id))
			{
				error_msg($this->lang->ban_error_unban_nouser);
			}

			// OK then, welcome back.
			$this->db->unban($id);
		}
		
		
		// Decided which user to ban yet ? if not, html.
		if (empty($_POST['id']) && empty($_POST['name']))
		{
			// wanna ban someone ?
			$fills	=	array(
				'title'			=>	$this->lang->ban_title,
				'desc'			=>	$this->lang->ban_desc,
				'ban_name'		=>	$this->lang->ban_by_name,
				'ban_id'		=>	$this->lang->ban_by_id,
				'id'			=>	$this->lang->ban_id,
				'unban'			=>	$this->lang->ban_action,
				'name'			=>	$this->lang->ban_name,
				'delete'		=>	$this->lang->ban_delete,
				'submit_btn'	=>	$this->lang->ban_submit_btn,
				'banlist_title'	=>	$this->lang->ban_banlist_title,
			);

			//Adding the banned list
			$banned	=	$this->db->get_banlist();

			$ban_list = '';
			
			while ($row = $banned->row())
			{
				$list_fills	=	array(
					'id'	=>	$row->id,
					'name'	=>	$row->name,
				);

				$ban_list	.=	$this->screen->return_html('admin-tpl_user_ban_list', $list_fills);
			}
			
			//is there no banned users?
			if (empty($ban_list))
			{
				$ban_list	.=	$this->screen->return_html('empty_row', array('colspan' => '4', 'empty_row' => $this->lang->ban_no_banned));
			}
			
			$fills['ban_list']	=	$ban_list;

			// Printing the screen hallelujah.
			$this->html	=	$this->screen->return_html('admin-tpl_user_ban', $fills);
		}
		else
		{
			$user = '';
			
			// Finding the user to ban
			
			//by id
			if (!empty($_POST['id']))
			{
				$user	=	$this->db->select_user_from_id($_POST['id']);
			}
			//or name
			elseif (!empty($_POST['name']))
			{
				$user	=	$this->db->select_user_from_name($_POST['name']);
			}

			// Banning a nonexisting user is not legal!
			if (empty($user->id))
			{
				error_msg($this->lang->ban_error_nouser, 1);
			}

			// Haha, dumbass! Trying to ban yourself are yah?
			if ($user->id == $this->user->id)
			{
				error_msg($this->lang->ban_error_selfban, 1);
			}

			// Banning the user
			$this->db->ban_user($user->id);

			// He's been banned ;)
			header('Location: admin.php?act=user&cmd=ban');
			exit();
		}

		
	}

	
	
	/**
	 * The following is more modularized and more feature-ish 0.2-stuff, I presume?
	 *
	 */
	
	
	function manage_ban()
	{
		$userid	=	$_POST['id'];
		$action	=	$_POST['action'];

		switch($action)
		{
			case 'add':
			$this->add_user_ban($userid, $bantime, $reason);
			break;

			case 'remove':
			$this->remove_user_ban($userid);
			break;
		}
	}


	/**
	 * Add user ban
	 *
	 * @param int userid
	 * @param int bantime
	 * @param string reason
	 */
	function add_user_ban($userid, $bantime, $reason)
	{
		if ($userid != $this->user->id)
		{
			$this->db->add_user_ban($userid);
			return true;
		}
		else
		{
			return false;
		}
	}


	/**
	 * Remove user ban
	 *
	 * Removes ban from a user
	 * @param int userid
	 * @return bool
	 */
	function remove_user_ban($userid)
	{
		if ($userid != $this->user->id)
		{
			$this->db->remove_user_ban($userid);
			return true;
		}
		else
		{
			return false;
		}
	}
}

?>