<?PHP

/**
*
* This is the Vikingboard main SQL file
* 
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.1
* @copyright Copyright (c) 2004-2006 The Vikingboard Project
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.vikingboard.com
* 
* $Id: sql_MySQL.php 1092 2006-10-28 15:06:26Z jorgenboard $


/*
	DATABASE TYPE:	MySQL
	INFO: Database Abstraction Layer (Contains all the queries in the forum)
*/


/*
	A Brief howto guide:
	BELOW THE FUNCTION GET`S ALL ROWS FROM THE QUERY
	function blablabla(something)
	{
		
		$this->database->query("SELECT * FROM table LIMIT 200");
		$this->queries++;
		return $this->database;
	}
	BELOW THE FUNCTION THAT ONLY RETURNS ONE (1) (EN) ROW FROM THE QUERY!
	function blablabla2(something) 
	{
		
		$this->database->query("SELECT * FROM table LIMIT 1");
		$this->queries++;
		return $this->database->row();
	}

	REMEMBER!
	Please remember that the function don`t need to return anything when you are doing a update / delete command	
*/

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

//Zeh datAfilE(t) (yummy).
if (!include_once('driver_MySQL.php'))
{
	error_msg('<br /><b>Critical error:</b> Could not load database driver!', 0); 
}

/**
 * SQL class
 * 
 */

class sql
{

	//Set up some neede variables first
	
	var $queries	=	0; 	//zeroes out the query count
    var $database   =   "";	//set up a database connection
    var $prefix		=	"";	//Table name prefix


	/**
	 * SQL class constructor
	 *
	 * @return none
	 * 
	 */
	function sql() {
		global $config;
		$this->database =	new database;
		$this->prefix	=	$this->database->db_prefix;
	}
		

	/**
	 * the following may be stupid, but hey, somebody have to supply the stupidity :) (added by jørgen, ofcourse)
	 *
	 * @return object
	 * 
	 */	
	function obj($dbd)
	{
		return mysql_fetch_object($dbd->db_result);
	}
	
	
	//=====================
	//Get the forum/site`s configuration
	//=====================
	function get_forum_config()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT * FROM {$this->prefix}config
				WHERE site_host = '".$_SERVER['HTTP_HOST']."' LIMIT 1");
	
		$this->queries++;
		return $dbd;
	}


	/**
	 * Getting some user info for use in PM view
	 *
	 * @param int $user_id
	 * @return object $database
	 */
	function get_user_stuff($user_id)
	{
		$this->database->query("SELECT `signature`, `avatar`, `registred`, `location`, `posts`, `name`, `title` FROM {$this->prefix}member WHERE id ='$user_id' LIMIT 1");
	
		$this->queries++;
		
		return $this->database->row();
	}
	
	//=====================
	// Gets the avatar and member photo info
	//=====================
	function get_user_avatar($user_id)
	{
		$dbd = $this->database;
		$dbd->query("SELECT `avatar`, `user_photo` FROM {$this->prefix}member WHERE id = '$user_id' LIMIT 1");
		$this->queries++;
		
		return $dbd->row();
	}
	
	
	//=====================
	// Updates the user avatar
	//=====================
	
	
	//=====================
	// Gets the signature info
	//=====================
	function get_user_signature($user_id)
	{
		$dbd = $this->database;
		$dbd->query("SELECT `signature` FROM {$this->prefix}member WHERE id = '$user_id' LIMIT 1");
		$this->queries++;
		
		return $dbd;
	}
	
	//=====================
	//Getting the user config for sending a pm (show smileys, signature, etc)
	//=====================
	function get_user_choices($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT posts, use_smiley, use_sig FROM {$this->prefix}member WHERE id ='$user_id' LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Creating a new user under registration
	//=====================
	function insert_new_user_data($username, $password, $email, $group)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}member (`name`, `password`, `email`, `registred`, `group`) 
				VALUES ('$username', '$password', '$email', '".forumtime()."', '$group')");	 	
		$this->queries++;
	}

	//=====================
	// Checking a username to make shure that we dont register a user width double names.
	//=====================
	function get_username_from_name($username)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}member WHERE name ='$username'");	 
	
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// if the user already know what user to send the message to, we finds the name.
	//=====================
	function get_username_from_id($user_id)
	{
		$dbd	=	$this->database;
		$this->database->query("SELECT name FROM {$this->prefix}member WHERE id='$user_id' LIMIT 1");	 
	
		$this->queries++;
		return $this->database;
	}
	
	//=====================
	// Connecting email address to user id.
	//=====================
	function get_userid_from_email_address($email)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}member WHERE email ='$email'");

		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Add confirmation  to the database.
	//=====================
	function insert_confirmation_key($user_id, $conf_key)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member_extra SET conf_key='$conf_key' WHERE mid='$user_id' LIMIT 1");
		$this->queries++;
	}

	//=====================
	// Get confirmation code based on user id
	//=====================
	function get_confirmation_key($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT conf_key FROM {$this->prefix}member_extra WHERE mid='$user_id' LIMIT 1");
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Get group based on user id
	//=====================
	function get_user_group($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT `group` FROM {$this->prefix}member WHERE id='$user_id' LIMIT 1");
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Remove confirmation key when user has changed the password
	//=====================
	function remove_confirmation_key($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member_extra SET conf_key='' WHERE mid='$user_id' LIMIT 1");
		$this->queries++;
	}

	//=====================
	// Change a users group
	//=====================
	function change_user_group($user_id, $group)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET `group` = '$group' WHERE id='$user_id' LIMIT 1");
		$this->queries++;
	}

	//=====================
	// Update password
	//=====================	
	function update_password($user_id, $password)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET password='$password' WHERE id='$user_id' LIMIT 1");
		$this->queries++;
	}

	//=====================
	//Mothafucka large Query that gets all the data about the user.
	//=====================
	function get_user_info($session)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT s.uid, s.time AS updateTime, m.*, g.*
				FROM {$this->prefix}sessions s, {$this->prefix}member m, {$this->prefix}group g
				WHERE s.sid = '".$session."' AND m.id = s.uid AND g.id=s.group LIMIT 1");
	
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	//The holy template fetcher SQL (please rise for the king & queen!)
	//=====================
	function get_template($template_set, $template_name)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT code FROM {$this->prefix}template WHERE set_id='$template_set' AND name='$template_name' LIMIT 1;");	 

		$this->queries++;
		return $dbd;
	}

	/**
	*
	*	CATEGORY AND FORUM QUERIES
	*	------------------------------
	*	All the queries that are dealing with forums and categories are here
	*
	*/

	//=====================
	//Get the main category
	//=====================
	function get_category($cat)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT * FROM {$this->prefix}category WHERE id = '$cat' LIMIT 1");	 
							
		$this->queries++;
		
		return $dbd;
	}

	function get_categories()
	{
		$this->database->query("SELECT * FROM {$this->prefix}category ORDER BY `order` ASC");
		$this->queries++;
		
		return $this->database;
	}
	//=====================
	//Get other categories
	//=====================
	function get_other_categories($not_cat)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, descr FROM {$this->prefix}category 
	 			WHERE id !='$not_cat' ORDER BY `order` ASC");
   		
		$this->queries++;
		return $dbd;
	}

	
	//=====================
	//Get the forums inside a spesified category
	//=====================
	function get_forums_in_category($cat)
	{
	 	$dbd	=	$this->database;
	 	$dbd->query("SELECT id, name, descr, lpost_title, lpost_tid, lpost_pid,
	     			lpost_uid, lpost_name, lpost_time, stat_threads, stat_posts 
				FROM {$this->prefix}forum WHERE cat = '$cat' ORDER BY `order` ASC");	 

		$this->queries++;
	 	return $dbd;
	}

	
	//=====================
	//Get information about a spesific forum
	//=====================
	function get_forum_info($forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, cat, stat_threads FROM {$this->prefix}forum 
				WHERE id ='$forumid' LIMIT 1");	 
   	
		$this->queries++;
		return $dbd;
	}


	/**
	 * Get forum subscription info
	 *
	 * 
	 * @param int forumid
	 * @return object dbd
	 */
	function get_forum_subscr_info($forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, cat, lpost_title, lpost_tid, lpost_pid, lpost_uid, lpost_time, lpost_name, stat_threads, stat_posts 
				FROM {$this->prefix}forum 
				WHERE id ='$forumid' LIMIT 1");	 
   	
		$this->queries++;
		return $dbd;
	}


	//=====================
	//Get topics in a forum
	//=====================
	function get_topics_from_forum($forumid, $show_from, $maxtopics, $prune_days)
	{
		#$dbd	=	$this->database;
		$this->database->query("SELECT *
			FROM {$this->prefix}topic WHERE forum ='{$forumid}'
			AND started < '".forumtime()."'
			AND started > '".(forumtime() - ($prune_days * 86400))."'
			ORDER BY lpost_time DESC LIMIT $show_from,$maxtopics");	 
	
		$this->queries++;
		return $this->database;
	}


	/**
	*
	*	TOPIC AND POST QUERIES
	*	------------------------------
	*	All the queries that are dealing with topics and posts are here
	*
	*/
	
	//=====================
	// Finding the owner of a post
	//=====================
	function get_post_owner($post_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT author_id FROM {$this->prefix}post WHERE id='$post_id' LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Getting information around a post, topic name etc
	//=====================
	function get_post_information($post_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT p.post, p.author_id, p.author_name, p.use_sig, t.id, t.title, t.forum, t.cat, p.tid
					FROM {$this->prefix}post p, {$this->prefix}topic t 
					WHERE t.id=p.tid AND p.id='$post_id' LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	//Update the topic read count
	//=====================
	function update_topic_view_counter($topic_id)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}topic SET views =(views +1) WHERE id ='$topic_id' LIMIT 1");	 
	
		$this->queries++;
	}

	//=====================
	//Getting information about a topic
	//=====================
	function get_topic_information($topic_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT t.id, t.title, t.status, t.started, f.lpost_pid,  
					t.replys, f.id fid, f.name fname, c.id catid, c.name catname
				FROM {$this->prefix}topic t, {$this->prefix}forum f, {$this->prefix}category c
			       	WHERE t.id ='$topic_id' AND f.id = t.forum AND f.cat = c.id
			       	LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}	


	/**
	 * Get topic subscription info
	 *
	 * @param int topic_id
	 * @return object dbd
	 */
	function get_topic_subscr_info($topic_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT t.id, t.title, f.lpost_pid, f.lpost_uid, f.lpost_name, f.lpost_time, t.replys, t.views, c.id
					FROM {$this->prefix}topic t, {$this->prefix}forum f, {$this->prefix}category c
			       	WHERE t.id ='$topic_id' AND f.id = t.forum AND f.cat = c.id
			       	LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}


	//=====================
	//Getting post ID`s from a topic
	//=====================
	function get_postID_in_topic($topic_id, $startpost, $maxposts)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id FROM {$this->prefix}post p WHERE p.tid =  '$topic_id'
	       			AND p.queued = 0 LIMIT $startpost,$maxposts;");	 
		$this->queries++;
		return $dbd;
	}

	//=====================
	//Getting the posts in a topic (or at least some of them)
	//=====================
	function get_posts_in_topic($post_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id, p.author_name, p.author_id, p.posted, p.post, p.ip, p.use_sig,   
				m.avatar, m.posts, m.registred, m.location, m.title, m.signature, 
				g.g_name FROM {$this->prefix}post p 
				LEFT JOIN {$this->prefix}member m ON (p.author_id = m.id)
				LEFT JOIN {$this->prefix}group g ON (m.group = g.id) 
				WHERE p.id IN ($post_id)  
				ORDER BY p.id ASC");	 
		$this->queries++;
		return $dbd;
	}
	
	//====================
	// Gets the very first post in topic
	//====================
	function first_post_in_topic($topic)
	{
		$dbd = $this->database;
		$dbd->query("SELECT `id` FROM `{$this->prefix}post` WHERE `tid` = '$topic' ORDER BY `id` ASC LIMIT 1");
		$this->queries++;
		return $dbd->row();
	}
	
	/**
	 * Gets the last post in a topic
	 *
	 * @param int $topic
	 * @return obj $dbd
	 */
	function get_last_post($topic)
	{
		$this->database->query("SELECT * FROM {$this->prefix}post p, {$this->prefix}topic t WHERE p.tid = '{$topic}' AND t.id = p.tid ORDER BY p.id DESC LIMIT 1");
		$this->queries++;
		return $this->database->row();
	}
	
	/**
	 * Updates the last-post for a specific topic
	 *
	 * @param int $topic
	 * @param int $forum
	 * @param string $author
	 * @param int $id
	 * @param int $uid
	 * @param int $time
	 */
	function update_last_post($topic, $forum, $author, $id, $uid, $time)
	{
		$this->database->query("UPDATE `{$this->prefix}topic` SET `lpost_name` = '{$author}', `lpost_id` = '{$id}', `lpost_uid` = '{$uid}', `lpost_time` = '{$time}' WHERE `id` = '{$topic}' ");
		$this->queries++;
		$this->database->query("UPDATE `{$this->prefix}forum` SET `lpost_pid` = '{$id}', `lpost_uid` = '{$uid}', `lpost_time` = '{$time}', `lpost_name` = '{$author}' WHERE `id` = '{$forum}'");
		$this->queries++;
	}
	
	function get_last_topic($forum)
	{
		$this->database->query("SELECT * FROM `{$this->prefix}topic` WHERE `forum` = '{$forum}' ORDER BY `lpost_time` DESC LIMIT 1");
		$this->queries++;
		return $this->database->row();
	}
	/**
	 * Updates the lastpost for a forum, on eg. topic deletion
	 *
	 * @param int $forum
	 * @param string $title
	 * @param int $tid
	 * @param int $pid
	 * @param int $uid
	 * @param int $time
	 * @param string $name
	 */
	function update_last_topic($forum, $title, $tid, $pid, $uid, $time, $name)
	{
		$this->database->query("UPDATE `{$this->prefix}forum` SET `lpost_title` = '{$title}', `lpost_tid` = '{$tid}', `lpost_pid` = '{$pid}', `lpost_uid` = '{$uid}', `lpost_time` = '{$time}', `lpost_name` = '{$name}' WHERE `id` = '{$forum}'");
		$this->queries++;
	}
	
	//====================
	// Deletes all posts in a topic
	//====================
	function delete_posts_in_topic($topic, $forum, $num=0)
	{
		$dbd = $this->database;
		$dbd->query("DELETE FROM `{$this->prefix}post` WHERE `tid` = '$topic' LIMIT 0");
		$this->queries++;

		if(is_numeric($forum)) {
			$dbd->query("UPDATE {$this->prefix}forum SET stat_posts = ( stat_posts - {$num}) WHERE id='{$forum}' LIMIT 1");
			$this->queries++;
		}
	}
	
	//====================
	// Counts all posts in a topic
	//====================
	function count_posts_in_topic($topic)
	{
		$dbd = $this->database;
		$dbd->query("SELECT COUNT(*) AS total FROM `{$this->prefix}post` WHERE `tid` = '$topic'");
		$this->queries++;
		return $dbd->row();
	}
	
	/**
	*
	*	SESSION AND LOGIN QUERIES
	*	------------------------------
	*	All the queries that are dealing with user sessions and logins are here
	*
	*/
	
	//=====================
	//Logging out a user
	//=====================
	function update_sessions_logout_user()
	{
		$dbd	=	$this->database;
		global $user;
		$dbd->query("UPDATE {$this->prefix}sessions SET uid ='1', time='".forumtime()."', 
					stayin='0', hide='0', `user`='', `group`=6
					WHERE sid ='".$user->session()."' LIMIT 1");	 
	
		$this->queries++;
	}

	//=====================
	//Deleting old sessions
	//=====================
	function delete_remove_old_sessions()
	{
		$dbd	=	$this->database;
		$dbd->query("DELETE FROM {$this->prefix}sessions 
					WHERE (time < '".(forumtime() - 432000)."' 
					AND stayin ='0') 
					OR time < '(".forumtime()." - 1296000)' 
					LIMIT 100");	 
					
		$this->queries++;
	}
	
	//=====================
	//SQL for updating the sessions table
	//=====================
	function session_updater($session_id)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}sessions SET time ='".forumtime()."', 
	 			ip ='".$_SERVER['REMOTE_ADDR']."' 
				WHERE sid ='".$session_id."' LIMIT 1"); 

		$this->queries++;
	}

	
	//=====================
	//SQL for inserting into the sessions table
	//=====================
	function session_inserter($session_id)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}sessions (sid, uid, time, ip)
	 			VALUES ('".$session_id."', '1', '".forumtime()."',
				'".$_SERVER['REMOTE_ADDR']."')");	 
								
		$this->queries++;
	}
	
	//=====================
	//Trying to get information about a username within a login
	//=====================
	function get_finduser_login($username)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, `group`, posts FROM {$this->prefix}member WHERE name = '$username' LIMIT 1");	 
	
		$this->queries++;
		return $dbd->row();
	}


	//=====================
	//Getting the user that is logging in
	//=====================
	function get_info_about_userloggingin($username, $password)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT `id`, `name`,`group` FROM {$this->prefix}member WHERE password = '$password' AND name='$username' LIMIT 1");
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	//Logging in a user :D (wooho, welcome DUDE :D)
	//=====================
	function update_loginuser($ID=1, $group, $name, $login_hide, $login_remember,$session_id)
	{
		$dbd	=	$this->database;
		global	$user;
		
		$dbd->query("UPDATE `{$this->prefix}sessions` SET `uid` = '$ID', `time` = '".forumtime()."', `stayin` = '$login_remember',
					`hide` = '$login_hide', `ip` = '".$_SERVER['REMOTE_ADDR']."', `user` = '$name', `group` = '$group' 
					WHERE `sid` ='$session_id' LIMIT 1");	 
		
		$this->queries++;
		
		return $dbd;
	}

	//=====================
	// Getting smileys :D :woot: :blush: :wee: :mad: :tomanysmileys: :RTFM: :lol:
	//=====================
	function get_smileys()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, url, code FROM {$this->prefix}smiley WHERE {$this->prefix}smiley.show ='1'");	 
	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Getting the bloddymothafucking bad words
	//=====================
	function get_badwords()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT * FROM {$this->prefix}badword");	 
	
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Getting information about a forum
	//=====================
	function get_config_from_forum($forum_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, cat FROM {$this->prefix}forum WHERE id ='$forum_id' LIMIT 1");
	
		$this->queries++;
		return $dbd;
	}


	/**
	*
	*	NEW TOPICS/POSTS QUERIES
	*	------------------------------
	*	All the queries that are dealing with creating new topics or posts are here
	*
	*/
	
	//=====================
	// Inserting a new topic
	//=====================
	function insert_newtopic($forum_id, $cat_id, $title, $userid, $username)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}topic (forum, cat, title, status, replys,
					views, sticky, starter_id, starter_name, started, lpost_name,
					lpost_id, lpost_uid, lpost_time) VALUES ($forum_id, $cat_id, '$title', 
					 '1', '0', '0', '0', '$userid', '$username', '".forumtime()."',
					'$username', '$userid', '$userid', '".forumtime()."')");	 
	
		$this->queries++;
	}

	//=====================
	// Finding the newest topic id from user
	//=====================
	function get_newest_topicid_from_user($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}topic WHERE starter_id ='$user_id' ORDER BY ID DESC LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Inserting a new post
	//=====================
	function insert_newpost($topic_id, $username, $userid, $text, $signature, $ip)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}post (tid, author_name, author_id, posted, post, use_sig, ip, queued)
					VALUES ('$topic_id', '$username', '$userid', '".forumtime()."', 
					'$text', '$signature', '$ip', '0')");	 
	
		$this->queries++;
	}

	//=====================
	// Updating a users post count
	//=====================
	function update_user_postcount($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET posts = (posts +1) WHERE id ='$user_id' LIMIT 1");	 
	
		$this->queries++;
	}
	
	
	//=====================
	// Fetching total number of post in forum
	//=====================
	function forum_total_posts()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT count(id) AS id FROM {$this->prefix}post");
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Fetching the users postcount
	//=====================
	function get_user_postcount($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT posts FROM {$this->prefix}member WHERE id ='$user_id' LIMIT 1");
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Finding the newest post id from a topic
	//=====================
	function get_new_post_id($user_id, $topic_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, tid FROM {$this->prefix}post WHERE author_id ='$user_id' AND tid ='$topic_id' ORDER BY id DESC LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Inserting a new post on topic reply
	//=====================
	function insert_new_post($topic_id, $user_name, $user_id, $text, $use_sig, $ip)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}post (tid, author_name, author_id, posted, post, use_sig, ip, queued)
					VALUES ('$topic_id', '$user_name', '$user_id', '".forumtime()."', 
					'$text', '$use_sig', '$ip', '0')");	 
	
		$this->queries++;
	}

	//=====================
	// Updating the lastpost / stats on a forum on new post posting.
	//=====================
	function update_forum_stats_on_reply($forumid, $lpost_topic_id, $lpost_post_id, $lpost_author, $lpost_userid, $topic_title)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}forum SET lpost_tid='$lpost_topic_id', lpost_pid='$lpost_post_id',
			lpost_time='".forumtime()."', lpost_name='$lpost_author', lpost_uid='$lpost_userid', lpost_title = '{$topic_title}',
			stat_posts=(stat_posts + 1)
			WHERE id ='$forumid' LIMIT 1");

		$this->queries++;
	}
	/**
	 * Get topic title from topic ID
	 *
	 * @param int $topicID
	 * @return obj $database
	 */
	function get_topic_title_from_id($topicID)
	{
		$this->database->query("SELECT `title` FROM `{$this->prefix}topic` WHERE `id` = '{$topicID}'");
		return $this->database->row();
	}
	
	//=====================
	// Updating the lastpost / stats on a a topic ID on new reply
	//=====================
	function update_topic_stats_on_reply($topicid, $postid, $username, $userid)
	{
		$this->database->query("UPDATE {$this->prefix}topic SET replys=(replys +1), lpost_name='$username', lpost_id='$postid', lpost_uid='$userid', lpost_time='".forumtime()."' WHERE id='$topicid' LIMIT 1;");

		$this->queries++;
	}

	//=====================
	// Updating the lastpost / stats on a forum on new topic posting
	//=====================
	function update_stats_on_newtopic($forumid, $title, $lpost_topic_id, $lpost_post_id, $lpost_author, $lpost_userid)
	{
		$dbd	=	$this->database;
		//forum table
		$dbd->query("UPDATE {$this->prefix}forum SET lpost_title ='$title', lpost_pid='$lpost_post_id', 
					lpost_tid='$lpost_topic_id', lpost_uid='$lpost_userid', 
					lpost_time='".forumtime()."', lpost_name='$lpost_author',   
					stat_threads=(stat_threads + 1), stat_posts=(stat_posts + 1) 
					WHERE id ='$forumid' LIMIT 1");	 	
		$this->queries++;
		
		//topic table
		$dbd->query("UPDATE {$this->prefix}topic SET lpost_name='$lpost_author', lpost_id='$lpost_post_id', 
				lpost_uid='$lpost_userid', lpost_time='".forumtime()."' WHERE id='$lpost_topic_id' LIMIT 1");	 	
		$this->queries++;
	}

	/**
	*
	*	PM QUERIES
	*	------------------------------
	*	All the queries that are dealing with PMs are here
	*
	*/
	
	 
	/**
	 * Finding out how many messages a user got in his inbox
	 *
	 * @param int $user_id
	 * @return class database
	 */
	function get_num_messages_inbox($user_id)
	{
		//$dbd	=	$this->database;
		$this->database->query("SELECT COUNT(p.id) as number FROM {$this->prefix}pm p WHERE p.belongs_to='$user_id' AND p.in_folder = 'inbox'");	 
	
		$this->queries++;
		return $this->database;
	}
	
	/**
	 * Getting the messages from the inbox
	 *
	 * @param int $to
	 * @return class database
	 */
	function get_messages_inbox($to)
	{
		//$dbd = $this->database;
		$this->database->query("SELECT * FROM {$this->prefix}pm p WHERE p.belongs_to='$to' AND p.in_folder = 'inbox' ORDER BY 'id' DESC");
		
		$this->queries++;
		return $this->database;
	}
	
	/**
	 * Get number of unread messages in inbox
	 *
	 * @param int $user_id
	 * @return class database
	 */
	function get_new_messages_inbox($user_id)
	{
		//$dbd	=	$this->database;
		$this->database->query("SELECT COUNT(p.id) number FROM {$this->prefix}pm p WHERE p.belongs_to='$user_id' AND p.in_folder = 'inbox' AND p.read = '0'");	 
	
		$this->queries++;
		return $this->database;
	}
	
	/**
	 * Get the traced PMs
	 * 
	 * @param int $user_id
	 * @return object database
	 */
	function get_traced_pms($user_id)
	{
		$this->database->query("SELECT * FROM {$this->prefix}pm p WHERE p.from_id = '{$user_id}' AND p.trace = '1' AND p.belongs_to != '{$user_id}' ORDER BY p.date");
		$this->queries++;
		return $this->database;
	}
	/**
	 * Fetch a single PM
	 *
	 * @param int $pm_id
	 * @return class database
	 */
	function get_pm_content($pm_id)
	{
		$this->database->query("SELECT * FROM {$this->prefix}pm_data pm LEFT JOIN {$this->prefix}pm p ON pm.id = p.msg_id  WHERE p.id = '$pm_id' LIMIT 1");
		$this->queries++;
		return $this->database->row();
		
	}
	
	/**
	 * We've read this, move along!
	 *
	 * @param int $pm_id
	 * @param int $date
	 * @param int $uid
	 * @return object database
	 */
	function mark_pm_read($pm_id, $date, $uid)
	{
		$this->database->query("UPDATE `{$this->prefix}pm` SET `really_read` = '1',
																`read_date` = '$date',
																 `read` = '1'
								WHERE `id` = '$pm_id' LIMIT 1");
		$this->queries++;
		
		$this->database->query("UPDATE `{$this->prefix}member` SET `new_pms` = (`new_pms` - '1') WHERE `id` = '$uid' LIMIT 1");
		$this->queries++;
		
		return $this->database;
	}
	
	
	/**
	 * Can we read this PM?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 * @return object database
	 */
	function can_read_pm($pm_id, $userid)
	{
		$this->database->query("SELECT d.author_id, d.content, d.date, p.title, p.belongs_to FROM `{$this->prefix}pm_data` d, `{$this->prefix}pm` p WHERE d.id=p.msg_id AND d.id='$pm_id' AND p.belongs_to = '$userid' LIMIT 1");	 
		$this->queries++;
		
		return $this->database;
	}
	
	/**
	 * Are we allowed to read it?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 * @return object database
	 */
	function allowed_to_read_pm($pm_id, $userid)
	{
		$this->database->query("SELECT belongs_to FROM `{$this->prefix}pm` WHERE id='$pm_id' AND belongs_to = '$userid'");
		$this->queries++;
		
		return $this->database;
	}
	/**
	 * Deletes a PM
	 *
	 * @param int $pm_id
	 * @param int $uid
	 */
	function delete_pm($pm_id, $uid)
	{
		$this->database->query("DELETE FROM {$this->prefix}pm WHERE id = '$pm_id' LIMIT 1");
		
		$this->database->query("UPDATE `{$this->prefix}member` SET `new_pms` = (`new_pms` - '1') WHERE `id` = '$uid' LIMIT 1");
		
		$this->queries = $this->queries + 2;
	}
	/**
	 * Are we allowed to recall this PM?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 * @return object database
	 */
	function allowed_to_recall_pm($pm_id, $userid)
	{
		$this->database->query("SELECT `trace` FROM `{$this->prefix}pm` WHERE `from_id` = '{$userid}' AND `id` = '{$pm_id}' AND `read` = '0'");
		$this->queries++;
		
		return $this->database;
	}
	
	/**
	 * Let's remove this PM (in unread state) from the recipients mailbox
	 *
	 * @param int $pm_id
	 * @return void
	 */
	function recall_pm($pm_id)
	{
		$this->database->query("DELETE FROM `{$this->prefix}pm` WHERE `id` = '{$pm_id}'");
		$this->queries++;
	}
	
	/**
	 * Marks a pm with read flag
	 *
	 * @param int $pm_id
	 */
	function mark_pm_as_read($pm_id)
	{
		$this->database->query("UPDATE `{$this->prefix}pm` SET `read` = '1' WHERE `id` = '{$pm_id}' LIMIT 1");
		$this->queries++;
	}
	
	/**
	 * Marks a pm as unread
	 *
	 * @param int $pm_id
	 */
	function mark_pm_unread($pm_id)
	{
		$this->database->query("UPDATE `{$this->prefix}pm` SET `read` = '0' WHERE `id` = '{$pm_id}' LIMIT 1");
		$this->queries++;
	}
	//
	//
	//
	//
	//
	// The queries below are not adjusted to the new pm tables, and will be discarded when new versions has been made.
	//
	//
	//
	//
	
	//=====================
	// Finding out how many messages a user got in his outbox
	//=====================
	function get_num_messages_outbox($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT COUNT(p.id) number FROM {$this->prefix}pm p WHERE p.from='$user_id'");	 
	
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Getting a spesified number of messages from a users inbox
	//=====================
	function get_messages_in_inbox($user_id, $num, $maxmessages)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id, p.from, p.title, p.read, p.sendtdate, m.name
	       			FROM {$this->prefix}pm p, {$this->prefix}member m  
				WHERE p.to='$user_id' AND m.id=p.from 
				ORDER BY p.id DESC LIMIT $num,$maxmessages");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Getting a spesified number of messages from a users outbox
	//=====================
	function get_messages_in_outbox($user_id, $num, $maxmessages)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id, p.from, p.title, p.read, p.sendtdate, m.name 
				FROM {$this->prefix}pm p, {$this->prefix}member m 
				WHERE p.from='$user_id' AND m.id=p.to 
				ORDER BY p.id DESC LIMIT $num,$maxmessages");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Getting a spesific PM based on ID
	//=====================
	function get_pm_from_id($pm_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT d.author_id, d.content, d.date, p.title, p.belongs_to FROM `{$this->prefix}pm_data` d, `{$this->prefix}pm` p WHERE d.id=p.msg_id AND d.id='$pm_id'");	 
	
		$this->queries++;
		return $dbd;
	}	
	

	//=====================
	// Inserting anti spam data under registration
	//=====================
	function insert_register_antispam_data($ip, $browser)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}reg_antispam (ip, browser, time) VALUES ('$ip', '$browser', '".forumtime()."')");	 
	
		$this->queries++;
	}

	//=====================
	// Getting anti spam data under registration
	//=====================
	function get_register_antispam_data($ip, $browser)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}reg_antispam WHERE time > '".(time() - 36000)."' AND ip='$ip' AND browser='$browser' LIMIT 2");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Getting the number of users that have been online the last x minutes
	//=====================
	function get_online_users($cut_time)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT COUNT(sid) users FROM {$this->prefix}sessions WHERE time >='$cut_time'");	 
		
		$this->queries++;
		return $dbd->row();
	}


	//=====================
	// Fetch help page, rules page, or another info-page from the database
	//=====================
	function get_help_topics($what="help")
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT * FROM {$this->prefix}help WHERE location='$what' LIMIT 1");
	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Fetching profile data
	//=====================
	function get_profile_data($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, email, signature, avatar, posts, registred, 
						location, interests, homepage, blog, real_name, birthday, user_photo, im_msn, title
						FROM {$this->prefix}member WHERE id='$user_id' LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}
	
	//======================
	// Updating profile data
	//======================
	function update_profile_data($user_id, $homepage, $blog, $real_name, $im_identity, $birthday, $location, $interests)
	{
		$dbd = $this->database;
		$dbd->query("UPDATE `{$this->prefix}member` SET `homepage` = '$homepage', `blog` = '$blog', `real_name` = '$real_name', `im_msn` = '$im_identity',
					`birthday` = '$birthday', `location` = '$location', `interests` = '$interests' WHERE `id` = '$user_id' LIMIT 1");
		
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Fetching a spesified PM
	//=====================
	function get_pm($message_id, $user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT m.id, m.from, m.to, m.title msgtitle, m.message, m.read, 
				m.sendtdate, m.show_sig, u.name, u.signature, 
				u.avatar, u.registred, u.title usertitle, u.posts 
				FROM {$this->prefix}pm m, {$this->prefix}member u 
				WHERE m.id='$message_id' AND m.to='$user_id'  
				AND u.id=m.from LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Getting info about what a user want to se in a message
	//=====================
	function get_userspecs_for_pm_view($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT show_sig, show_avatars, show_smileys FROM {$this->prefix}member WHERE id ='$user_id' LIMIT 1");	 
	
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Saving a post to the DB on edit
	//=====================
	function update_post_data($post_id, $text)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}post SET post='$text' WHERE id='$post_id' LIMIT 1");	 	
		$this->queries++;
	}
	


	//=====================
	// Running 2 update quieries that updates a users email and "pauses" the account.
	//=====================
	function update_user_email($user_id, $email)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET email='$email' WHERE id='$user_id' LIMIT 1");	 	
		$this->queries++;
		$dbd->query("UPDATE {$this->prefix}member SET group='4' WHERE id='$user_id' LIMIT 1");	 	
		$this->queries++;
	}


	//=====================
	// Updating a users avatar
	//=====================
	function update_user_avatar($user_id, $avatar)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET avatar='$avatar' WHERE id='$user_id' LIMIT 1");	 	
		$this->queries++;
		return true;
	}	

	//=====================
	// Updating a users signature
	//=====================
	function update_user_signature($user_id, $signature)

	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET signature='$signature' WHERE id='$user_id' LIMIT 1");	 	
		$this->queries++;
	}

	//=====================
	// Getting a users id from the name
	//=====================
	function get_userid_from_name($username)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}member WHERE name='$username' LIMIT 1");	 	
		$this->queries++;
		return $dbd;
	}	

	/**
	 * Constructs a new PM object
	 *
	 * @param int $msg_id
	 * @param string $title
	 * @param int $from_id
	 * @param int $to_id
	 * @param string $in_folder
	 * @param int $trace
	 * @param int $belongs_to
	 */
	function create_new_pm($msg_id, $title, $date, $from_id, $to_id, $in_folder, $trace, $belongs_to)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO `{$this->prefix}pm` 
					VALUES ('', '$msg_id', '$date', '$title', '$from_id', '$to_id', '$in_folder', '0', 'NULL', '0', '$trace', '$belongs_to')");
		$this->queries++;
		
		$dbd->query("UPDATE `{$this->prefix}member` SET `new_pms` = (`new_pms` + '1'), `done_pmpopup` = '0' WHERE `id` = '$to_id' LIMIT 1");	
		$this->queries++;
		
	}
	
	/**
	 * Constructs a new PM object, without notifying about 
	 * "You have new PM", as we are only putting it in
	 * sent elements.
	 *
	 * @param int $msg_id
	 * @param string $title
	 * @param int $from_id
	 * @param int $to_id
	 * @param string $in_folder
	 * @param int $trace
	 * @param int $belongs_to
	 */
	function move_new_pm($msg_id, $title, $date, $from_id, $to_id, $in_folder, $trace, $belongs_to)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO `{$this->prefix}pm` 
					VALUES ('', '$msg_id', '$date', '$title', '$from_id', '$to_id', '$in_folder', '0', 'NULL', '0', '$trace', '$belongs_to')");
		$this->queries++;
	}
	
	/**
	 * Insert PM data
	 * 
	 * @param string $message
	 * @param int $author_id
	 * @param string $cc_to
	 * 
	 * @return int AUTO_INCREMENT_ID
	 */
	function create_new_pm_data($message, $date, $author_id, $cc_to)
	{
		$dbd = $this->database;
		$dbd->query("INSERT INTO `{$this->prefix}pm_data` (date, content, author_id, cc_to) 
					VALUES ('$date', '$message', '$author_id', '$cc_to')");
		
		$this->queries++;
	
		return mysql_insert_id();
	}
	
	//function get_msg_id();
	//=====================
	// Creating a user activation key
	//=====================
	function insert_new_update_key($user_id, $act_key)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member_extra SET act_key='$act_key' WHERE mid='$user_id' LIMIT 1");
		$this->queries++;
	}

	//=====================
	// Finding the newest ID/name in the member table
	//=====================
	function get_latest_user()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name FROM {$this->prefix}member ORDER BY id DESC LIMIT 1");
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Adding a ID to the member_extra table
	//=====================
	function insert_extra_user_data($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}member_extra (mid) VALUES ('$user_id')");
		$this->queries++;
	}

	//=====================
	// Getting some information based om member id that is used to send a mail with
	//=====================
	function get_users_mailinfo_from_id($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT name, email, lang FROM {$this->prefix}member WHERE id='$user_id' LIMIT 1");
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Stores a email that could not be sendt in the DB
	//=====================
	function save_problem_email($to, $title, $headers, $mail)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}mail_queue(to_email, title, message, headers) 
					 VALUES ('$to', '$title', '$mail', '$headers')");
		$this->queries++;
	}
	
	//=====================
	// Doing a check to se if somebody is using the email adress
	//=====================
	function get_num_emails($email)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}member WHERE email='$email' LIMIT 1");
		$this->queries++;
		return $dbd;

	}
	
	//=====================
	// Cheking a activation key
	//=====================
	function get_check_regkey($key)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT mid FROM {$this->prefix}member_extra WHERE act_key='$key' LIMIT 1");
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Who the F! 0wnz this key?
	//=====================
	function get_key_owner($key)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT mid FROM {$this->prefix}member_extra WHERE act_key='$key' LIMIT 1");
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Activating a user based on a activation key
	//=====================
	function update_activate_user($user_id, $key)
	{
		$dbd	=	$this->database;
		$dbd->query("UPDATE {$this->prefix}member SET `group`='3' WHERE id='$user_id' LIMIT 1");
		$this->queries++;
		$dbd->query("UPDATE {$this->prefix}member_extra SET act_key='' WHERE mid='$user_id' LIMIT 1");
		$this->queries++;
	}



	//=====================
	// Creating a new user under registration
	//=====================
	function add_user_to_adminvalidation($user_id)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}member_extra(mid, admin_act_vaiting) VALUES ('$user_id', '1')");	 	
		$this->queries++;
	}

	//=====================
	// Getting all sites that uses the forum
	//=====================
	function get_sites()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, forum_url FROM {$this->prefix}config WHERE active=1");	 	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Logging task work
	//=====================
	function insert_tasklog_data($time, $ip, $task)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}log_tasks (time, ip, task) VALUES ('$time', '$ip', '$task')");	 	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// Getting the total board stats
	//=====================
	function get_forum_stats()
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT * FROM {$this->prefix}stats LIMIT 1");	 	
		$this->queries++;
		return $dbd;
	}


	//=====================
	// User have a forum subscriptions
	//=====================
	function get_usersubscr_in_forum($userid, $forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id FROM {$this->prefix}subscr_forum WHERE uid='$userid' and fid='$forumid' LIMIT 1");	 	
		$this->queries++;
		return $dbd->row();
	}
	
	//=====================
	// Get all subscriptions from a forum
	//=====================
	function get_subscriptions_in_forum($forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT uid FROM {$this->prefix}subscr_forum WHERE fid=$forumid");	 	
		$this->queries++;
		return $dbd;
	}
	

	/**
	 * Get forum subscriptions
	 *
	 * Gets all the forums a user subscribes to
	 * @param int userid
	 * @return object db
	 */
	function get_forum_subscriptions($userid)
	{
		$db	=	$this->database;
		$db->query("SELECT fid FROM {$this->prefix}subscr_forum WHERE uid = '$userid' ORDER BY id DESC");
		$this->queries++;
		return $db;
	}


	//=====================
	// Add a forum subscription
	//=====================
	function insert_new_usersub_forum($userid, $forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}subscr_forum (uid, fid) VALUES ('$userid', '$forumid')");	 	
		$this->queries++;
	}


	/**
	 * Remove forum subscriptions
	 *
	 * Removes selected forum subscriptions
	 * @param int userid
	 * @param array forums
	 * @return void
	 */
	function remove_forum_subscriptions($userid, $forums)
	{
		// Start making the query
		$query	=	"DELETE FROM {$this->prefix}subscr_forum WHERE uid = $userid AND fid = ";

		$i	=	0;
		foreach($forums as $forum)
		{
			// First forum
			if($i == 0)
			{
				$query	.=	$forum;
				$i++;
			}
			// The other forums
			else
			{
				$query	.=	" OR " . $forum;
			}
		}

		$db	=	$this->database;
		$db->query($query);
		$this->queries++;
	}


	/*
	 * Get topic information
	 * Gets information about a topic
	 * @param int topicid
	 * @return void
	 */
	function get_topic_info($forumid)
	{
		$dbd	=	$this->database;
		$dbd->query("SELECT id, name, cat, lpost_title, lpost_tid, lpost_pid, lpost_uid, lpost_time, lpost_name, stat_threads, stat_posts FROM {$this->prefix}forum 
				WHERE id ='$forumid' LIMIT 1");	 
   	
		$this->queries++;
		return $dbd;
	}

	/**
	 * Get topic subscription
	 *
	 * 
	 * @param int user
	 * @param int topic
	 * @return int
	 */
	function get_topic_subscription($user, $topic)
	{
		$db	=	$this->database;
		$db->query("SELECT id FROM {$this->prefix}subscr_topic WHERE uid = $user AND tid = $topic LIMIT 1");
		$this->queries++;
		return $db->row();
	}

	/**
	 * Get topic subscriptions
	 *
	 * 
	 * @param int user
	 * @return int
	 */
	function get_topic_subscriptions($user)
	{
		$db	=	$this->database;
		$db->query("SELECT tid FROM {$this->prefix}subscr_topic WHERE uid = $user");
		$this->queries++;
		return $db;
	}
	
	/**
	 * Get topic subscriptions
	 *
	 * 
	 * @param int topicID
	 * @return int
	 */
	function get_topic_subscribers($topicID)
	{
		$db	=	$this->database;
		$db->query("SELECT uid FROM {$this->prefix}subscr_topic WHERE tid = '$topicID'");
		$this->queries++;
		return $db;
	}

	/**
	 * New topic subscription
	 *
	 * 
	 * @param int user
	 * @param int topic
	 * @return void
	 */
	function new_topic_subscription($user, $topic)
	{
		$db	=	$this->database;
		$db->query("INSERT INTO {$this->prefix}subscr_topic (uid, tid) VALUES ('$user', '$topic')");
		$this->queries++;
	}

	/**
	 * Remove topic subscriptions
	 *
	 * Removes selected topic subscriptions
	 * @param int userid
	 * @param array forums
	 * @return void
	 */
	function remove_topic_subscriptions($userid, $topics)
	{
		// Start making the query
		$query	=	"DELETE FROM {$this->prefix}subscr_topic WHERE uid = $userid AND tid = ";

		$i	=	0;
		foreach($topics as $topic)
		{
			// First topic
			if($i == 0)
			{
				$query	.=	$topic;
				$i++;
			}
			// The other topics
			else
			{
				$query	.=	" OR " . $topic;
			}
		}

		$db	=	$this->database;
		$db->query($query);
		$this->queries++;
	}


	/**
	 * Insert new report
	 *
	 * @param int post_id
	 * @param int user_id
	 * @param string message
	 */
	function insert_new_report($post_id, $user_id, $message)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}reported (pid, uid, time, status, message) VALUES ('$post_id', '$user_id', '" . time() . "', '1', '$message')");
		$this->queries++;
	}

	//=====================
	// "Deletes" a post
	//=====================
	function delete_post($id, $topic, $forum)
	{
		$dbd	=	$this->database;
		$dbd->query("DELETE FROM {$this->prefix}post WHERE id='{$id}' LIMIT 1");
		$this->queries++;
		
		if(is_numeric($topic)) {
			$dbd->query("UPDATE {$this->prefix}topic SET replys = replys - 1 WHERE id='{$topic}' LIMIT 1");
			$this->queries++;
		}
		
		if(is_numeric($forum)) {
			$dbd->query("UPDATE {$this->prefix}forum SET stat_posts = stat_posts - 1 WHERE id='{$forum}' LIMIT 1");
			$this->queries++;		
		}
	}
	
	//=====================
	// "Deletes" a whole topic
	//=====================
	function delete_topic($id, $forum)
	{
		$dbd	=	$this->database;
		$dbd->query("DELETE FROM `{$this->prefix}topic` WHERE `id` = '$id' LIMIT 1");
		$this->queries++;
		
		if(is_numeric($forum)) {
			$dbd->query("UPDATE {$this->prefix}forum SET stat_threads = stat_threads - 1 WHERE id='{$forum}' LIMIT 1");
			$this->queries++;		
		}
	}
	
	//=====================
	// Insert new poll question
	//=====================
	function insert_new_poll_title($TopicId, $Question)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}poll (tid, name) VALUES ('{$TopicId}', '{$Question}')");
		$this->queries++;
		$dbd->query("UPDATE {$this->prefix}topic SET has_poll = 1 WHERE id={$TopicId} LIMIT 1");
	}
	
	//=====================
	// Insert new poll answer
	//=====================
	function insert_new_poll_question($TopicId, $Answer)
	{
		$dbd	=	$this->database;
		$dbd->query("INSERT INTO {$this->prefix}poll_choices (pid, question) VALUES ('{$TopicId}', '{$Answer}')");
		$this->queries++;
	}
	
	//=====================
	// Update global stats
	//=====================
	function update_global_stats($type="topics") {
        $dbd	=	$this->database;
        if($type=="topics") {
			$dbd->query("UPDATE {$this->prefix}stats SET total_topics = (total_topics +1) LIMIT 1");
            $this->queries++;
		}
		if($type =="posts") {
			$dbd->query("UPDATE {$this->prefix}stats SET total_posts = (total_posts +1) LIMIT 1");
            $this->queries++;
		}
		if($type =="users") {
			$dbd->query("UPDATE {$this->prefix}stats SET total_users = (total_users +1) LIMIT 1");
            $this->queries++;
		}
	}
			
	//=====================
	// Get members
	//=====================
	function get_member_list($order, $desc, $showfrom, $total)
	{
		$this->database->query("SELECT m.`id`, m.`name`, m.`posts`, m.`registred`, m.`homepage`, m.`title`, m.`group`, g.`g_name` 
							FROM {$this->prefix}member m, {$this->prefix}group g WHERE g.`id` = m.`group` 
							ORDER BY m.`{$order}` {$desc} LIMIT {$showfrom},{$total}");
		$this->queries++;
		return $this->database;
	}
	
	//=====================
	// Get members last visit time (if there)
	//=====================	
	function get_member_status($id)
	{
		$this->database->query("SELECT time 
					FROM {$this->prefix}sessions
					WHERE uid={$id}
					ORDER BY time DESC LIMIT 1");
								
		$this->queries++;
		return $this->database;		
	}

	//=====================
	// Get the post IDs from the last posts
	//=====================
	function getLastPosts($start, $stop) {
    	$dbd	=	$this->database;
        $dbd->query("SELECT p.id, p.post, p.posted, p.tid, p.author_name,
						p.author_id, f.name AS forumName, f.id AS forumId,
						t.title AS topicTitle
						
						FROM {$this->prefix}post p,
							{$this->prefix}forum f, {$this->prefix}topic t
						
						WHERE queued =0
						AND t.id = p.tid
						AND f.id = t.forum
						
						ORDER BY p.posted DESC
						LIMIT {$start} , {$stop}");
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Perform a search
	//=====================
	function runSearch($words=array(), $limit=0, $max=25) {

		//First, construt a match SQL
		$points = -1;
		
		$sql   =  " MATCH (p.post) AGAINST ('";
		foreach($words as $row) {
		  	$points++;
			$sql	.=	"{$row}";
		}
		$sql   .=  "' IN BOOLEAN MODE) AS relevance";
	
	
		//Calculate min relevance "points"
		if($points != 0) {
			$points--;
		}
		$points	=	"{$points}.99";
	
		//then, the main thing
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id, p.post, p.posted, p.author_name, p.tid,
					p.author_id, f.name AS forumName, f.id AS forumId,
					t.title AS topicTitle,

					{$sql}

					FROM {$this->prefix}post p, {$this->prefix}forum f, {$this->prefix}topic t
					WHERE queued =0
					AND t.id = p.tid
					AND f.id = t.forum
					HAVING relevance > {$points}
					ORDER BY relevance DESC LIMIT {$limit} , {$max}");

		$this->queries++;
		return $dbd;
 	}

	//=====================
	// Find number of search-results
	//=====================
	function runSearchCalculation($words, $userId) {
		
		//First, construt a match SQL
		$points = -1;
		
		$sql   =  " MATCH (p.post) AGAINST ('";
		foreach($words as $row) {
		  	$points++;
			$sql	.=	"{$row}";
		}
		$sql   .=  "' IN BOOLEAN MODE)";
	
	
		//Calculate min relevance "points"
		if($points != 0) {
			$points--;
		}
		$points	=	"{$points}.99";

		//Also search for a user?
		if(is_numeric($userId)) {
			$userSQL	=	" AND p.author_id={$userId}";
		}

		//then, the main thing
		$dbd	=	$this->database;
		$dbd->query("SELECT COUNT( p.id ) as totals
					FROM {$this->prefix}post p
					WHERE 
					
                  	{$sql}
					
					 >{$points} {$userSQL}");
					 
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Find the newest topics
	//=====================
	function getLastTopics($start=0, $end=25) {

		//First part of the query
		$sql	=	"SELECT t.id, t.title, f.name FROM {$this->prefix}topic t, {$this->prefix}forum f WHERE t.forum = f.id ORDER BY started ASC LIMIT {$start},{$end}";

		
		//then, the main thing
		$dbd	=	$this->database;
		$dbd->query($sql);
		
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Perform a topic search
	//=====================
	function runTopicSearch($words=array(), $limit=0, $max=25) {

		//First part of the query
		$sql	=	"SELECT t.id, t.title, f.name FROM {$this->prefix}topic t, {$this->prefix}forum f WHERE ";

		//First, construt a match SQL
		foreach($words as $word) {
			$sql	.=	" t.title LIKE '%{$word}%' AND";
		}
		
		//Continue the query
		$sql	.=	" t.forum = f.id";
		
		//then, the main thing
		$dbd	=	$this->database;
		
		$dbd->query($sql);
		
		$this->queries++;
		return $dbd;
 	}



	//=====================
	// Find topics from a user
	//=====================
	function get_users_topics($userId, $start=0, $max=25) {

		//First part of the query
		$sql	=	"SELECT t.id, t.title, f.name FROM {$this->prefix}topic t, {$this->prefix}forum f WHERE starter_id={$userId} AND t.forum = f.id
					ORDER BY t.id DESC LIMIT {$start},{$max}";

	
		//then, the main thing
		$dbd	=	$this->database;
		
		$dbd->query($sql);
		
		$this->queries++;
		return $dbd;
	}

	//=====================
	// Find posts from a user
	//=====================
	function get_users_posts($userId, $start=0, $max=25) {
		$dbd	=	$this->database;
		$dbd->query("SELECT p.id, p.post, p.posted, p.author_name, p.tid,
					p.author_id, f.name AS forumName, f.id AS forumId,
					t.title AS topicTitle 
					FROM {$this->prefix}post p, {$this->prefix}forum f, {$this->prefix}topic t
					WHERE queued =0
					AND p.author_id = {$userId}
					AND t.id = p.tid
					AND f.id = t.forum
					ORDER BY posted DESC LIMIT {$start} , {$max}");
		
	
		$this->queries++;
		return $dbd;
	}
	
	//=====================
	// Count number of posts from a user (since postcount isnt correct always)
	//=====================
	function count_users_posts($userId) {
		$dbd	=	$this->database;
		
		$dbd->query("SELECT COUNT(p.id) AS totals FROM {$this->prefix}post p WHERE p.author_id = {$userId}");
		
	
		$this->queries++;
		return $dbd->row();
	}
	
	//=====================
	// Find total posts within a time-period
	//=====================
	function calculateLastPosts($time=86400) {
		$dbd	=	$this->database;
		$dbd->query("SELECT COUNT( p.id ) as totals FROM {$this->prefix}post p
					 WHERE p.posted > ".(time() - $time)."");
		
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Find the name of a group ID
	//=====================	
	function groupIdToName($id) {
		$dbd    =   $this->database;
		$dbd->query("SELECT g_name FROM {$this->prefix}group WHERE id='$id'");
		$this->queries++;
		return $dbd->row();
	}

	//=====================
	// Update board stats on visitor record
	//=====================	
	function update_max_users_online($users, $time) {
		$dbd    =   $this->database;
		$dbd->query("UPDATE {$this->prefix}stats SET max_users_online='{$users}', max_users_date='{$time}' LIMIT 1");
		$this->queries++;
	}
}

?>