<?PHP

////////////////////////////////////////
//	system : VikingBoard
//  	version: 0.1 alpha
//	author : Tor Henning Ueland
//	website: www.vikingboard.com
//
////////////////////////////////////////


/*

	CACHESYSTEM FOR VIKINGBOARD, THIS HOLDS THE DIFFERENT CLASSES WITCH
	TAKES CARE OF THE WORK OF GETTING, SAVING AND WORKING WITH DATA WE
	ARE USING OFTENLY.

*/

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class cache
{

	//==========================================
	//	Lets initialize everything :)
	//==========================================
	function cache() {
	
		//Make some global
		global $config_global, $db;
		
		//Set it to this class
		$this->config = $config_global;
		$this->db	=	$db;
		
		//Set domain name
		$this->site =   str_replace(":", "_", $_SERVER['HTTP_HOST']);
	
	}

	//==========================================
	//	DROP CACHE
	//==========================================
	function reset($thatMd5sum) {

		//Remove a single cache file
		if(isset($thatMd5sum)) {
			$path = "./cache/{$this->site}/{$thatMd5sum}.php";
			unlink($path);
  		
		  } else {
   		
   			//Loop over a complete cache folder and delete the files
			if (is_dir("./cache/{$this->site}/")) {
			   if ($dh = opendir("./cache/{$this->site}/")) {
					while (($file = readdir($dh)) !== false) {
			         	if($file !="." && $file !="..") {
						   	if(unlink("./cache/{$this->site}/{$file}") == false) {
								echo "<b>Vikingboard error:</b> failed unlinking ./cache/{$this->site} (Permission denied perhaps?)<br />\n";
							}
						}
			    	}
			    	closedir($dh);
				}
			}
		}
 	}

	//==========================================
	//	SQL CACHE SYSEM (FUNCTION)
	//==========================================
	function query($query, $extra_variables=array()) {
		
		
		//=========================
		//	Define variables (t'is nasty, i know)
		//=========================

		if (!isset($extra_variables[2]))
		{
			$extra_variables[2] = "";
			
			if(!isset($extra_variables[1])) 
			{
				$extra_variables[1] =   "";
				
				if(!isset($extra_variables[0])) 
				{
                	$extra_variables[0] =   "";
				}
			}
		}		
		$md5sum =   md5("{$query}{$extra_variables[0]}{$extra_variables[1]}{$extra_variables[2]}");

		$cache_file	=	"./cache/{$this->site}/{$md5sum}.php";
		
		//=========================
		//	Start debugging if asked
		//=========================
		if(isset($_GET['debug']) && $_GET['debug'] == "1") {
			$cachetimer = new Timer;
		}

		//=========================
		//	Make shure we have a folder
		//=========================
		if(!is_dir("./cache/{$this->site}")) {
			mkdir("./cache/{$this->site}", 0777);
			chmod("./cache/{$this->site}", 0777);
		}
		
		//=========================
		//	Are we going to send extra variables to the query?
		//=========================
		/*	Author`s note: This was intended to work (doh!) but it caused SQL errors, jusing a nastyer way for now, $extra_variables[0] etc..
		if(is_array($extra_variables)) {
			foreach($extra_variables as $row) {
				$query_variables	.=	"$row, ";
				echo "adding $row<br>";
			}
			$query_variables	.=	" ''";
			echo $query_variables;
		}
		*/
		
		//A fix to remove notices sinc the above code does not work
		$toCheck    =   "4";
		while($toCheck !=0) {
			if(!isset($extra_variables[$toCheck])) {
				$extra_variables[$toCheck]  =   "";
			}
			$toCheck--;
		}
		
		//=========================
		//	Use file cache if set to it
		//=========================
		if($this->config->cache_active =="1") {
			
			if(!include("$cache_file")) {
				$handle		=	fopen($cache_file, "w+");
				$to_cache	=	$this->db->$query($extra_variables[0], $extra_variables[1], $extra_variables[2], $extra_variables[3], $extra_variables[4]);
				while($obj = $to_cache->row())
				{
					$tmp[] = $obj;
				}
				$to_cache	=	serialize($tmp);
				$cache_data	=	$to_cache;
				$to_cache	=	$this->cleanIt($to_cache);
				$to_cache	=	"<?php \n //====$query====// \n\n \$cache_data = '".$to_cache."';\n\$cache_date = '".forumtime()."';\n\n?>";

				if(fwrite($handle, $to_cache) === FALSE) {
					die('<h1>Cache error</h1>Could not save data to the cache file, <br>please try again later.');
				}
				
				//include("$cache_file");
			}
			
			//==========================================
			//	Is the result to old? (in such cases, update it).
			//==========================================
			else {
			
				if($cache_date < (forumtime() - $this->config->cache_lifetime)) {
					
					//Get data from the database
					$to_cache	=	$this->db->$query($extra_variables[0], $extra_variables[1], $extra_variables[2], $extra_variables[3], $extra_variables[4]);
					while($obj = $to_cache->row())
					{
						$tmp[] = $obj;
					}
					$to_cache	=	serialize($tmp);
					$to_cache	=	$this->cleanIt($to_cache);

					//make it "nice"
					$to_cache	=	"<?php \n //====$query====// \n\n \$cache_data = '".$to_cache."';\n\$cache_date = '".forumtime()."';\n\n?>";

					//Open file and save the new query
					$handle	=	fopen($cache_file, 'w+');
					if(fwrite($handle, $to_cache) === FALSE) {
						die('<h1>Cache error</h1>Could not save data to the cache file, <br>please try again later.');
					}
					//read file again
					include("$cache_file");
				}
			}
			
			//==========================================
			//	unserialize the result.
			//==========================================
			$data	=	$this->ReCleanIt($cache_data);
			$data	=	unserialize($data);
			
			/*
			Music to listen to when you are working with the cache system:
			"Weird Al Yankowic, live!" out in the stores now ;) (dig it!)
			(yeah, really useful information...)
			*/
		}
		//=========================
		//	Ignore cache and get data straight from DB if we dont use cache
		//=========================
		else
		{
			//==========================================
			//	Actually fetch data (not much to do...)
			//==========================================
			$tmp = $this->db->$query($extra_variables[0], $extra_variables[1], $extra_variables[2], $extra_variables[3], $extra_variables[4]);
			while($obj = $tmp->row())
			{
				$data[] = $obj;
			}

		}

		//==========================================
		//	Print some debug data if requested
		//==========================================
		if (isset($_GET['debug']) && $_GET['debug'] == "1")
		{
			global $debug;
			$debugtime	=	$cachetimer->stop_and_display(5);
			$debug_ms	=	$debugtime * 1000;
			if ($query != 'get_template')
			{
				$debug->debugdata[] .=  '<table border="0" width="100%">
  				<tr>
    					<td bgcolor="#7EADFA">
					<strong>Cache request:</strong><br />
    					<strong>Query:</strong><em> ' . $query . ' </em><strong>Variables: </strong><em>'.$extra_variables[0].', '.$extra_variables[1].'</em>
					</td>
  				</tr>
  				<tr>
    					<td bgcolor="#C5E4FE">
					Request time: <em> ' . $debugtime . ' seconds, ' . $debug_ms . ' ms</em>
					</td>
  				</tr>
			     </table>';
			}
			else
			{
				$debug->debugdata[] .= '<table border="0" width="100%">
  					<tr>
    						<td bgcolor="#5CDC8C">
						<strong>Cached template request:</strong><br />
    						<strong>Template:</strong> <em>' . $extra_variables[1] . '</em>
						</td>
  					</tr>
  					<tr>
    						<td bgcolor="#7EFEAE">
						Request time: <em> ' . $debugtime . ' seconds, ' . $debug_ms . ' ms</em>
						</td>
  					</tr>
			    	 </table>';
			}
			
			$debug->cachetime = ($debug->cachetime + $debugtime);
		}
		//==========================================
		//	Then return some
		//==========================================
		return $data;
	}
	
	//==========================================
	//	Then return some
	//==========================================
	function cleanIt($input) {
		$input = str_replace("'", "\'", $input);
		return $input;
	}
	function ReCleanIt($input) {
		$input = str_replace("\'", "'", $input);
		return $input;
	}
}
?>