<?php
/**
*
* This is the Vikingboard template handler file
* 
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.1
* @copyright Copyright (c) 2004-2006 The Vikingboard Project
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.vikingboard.com
* 
* $Id: screen.php 964 2006-09-17 22:49:39Z PaiTrakt $
*/
	
//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class screen
{

	//	Start with nothing (doh)
	var $html_body		=	'';	//Data within the wrapper
	var $html_wrapper	=	'';	//Wrapper to the forum
	var $cached         =   array(); //html cache
	var $cachedHTML     =   array(); //html actual cache


	/**
	 * Returns a parsed template
	 * 
	 * @return bool
	 */
	function return_html($templatename, $data) {
		global $config, $cache;
		
		//	Load in templates to function	
		//got a template?
		if(!$templatename) {
			echo "The template system was activated but did not get any templates to load in.\n<br />";
		}
			
		//Check if we have the template in memory already
		if(isset($this->cached[$templatename])) {
			$html[0]->code   =   $this->cachedHTML[$templatename];
  		} else {

			//get it from cache
			$html = $cache->query('get_template', array($config->def_tpl, $templatename));

			//put it in memory
			$this->cached[$templatename] 		=   true;
			$this->cachedHTML[$templatename]    =   $html[0]->code;
	    }
	    
		//really got it?
		if($html[0]->code =="") {
			echo "Vikingboard Error: The template named \"{$templatename}\" does not exist!.\n<br />";
		}
		//yeah
		$html = str_replace('"', '\"', $html[0]->code);
		
		
		//	Parse tags and return it
		$return_it = '';
		eval("\$return_it =\"$html\";");
		return $return_it;	
	}

	/**
	 * Parse a template and add the content to output buffer
	 * 
	 * @return bool
	 */	
	function add_html($templatename, $data) {
		global $config, $cache;
		
		//	Load in templates to function
		//got a template?
		if(!$templatename) {
			echo "The template system was activated but did not get any templates to load in.\n<br />";
		}
		
		//Check if we have the template in memory already
		if(isset($this->cached[$templatename])) {
			$html[0]->code   =   $this->cachedHTML[$templatename];
  		} else {
			
			//get it from cache
			$html = $cache->query('get_template', array($config->def_tpl, $templatename));
			
			//put it in memory
			$this->cached[$templatename] 		=   true;
			$this->cachedHTML[$templatename]    =   $html[0]->code;
	    }
	    
		//really got it?
		if($html[0]->code == "") {
			echo "Vikingboard Error: The template named \"{$templatename}\" does not exist!.\n<br />";
		}	
	
		//yup
		$html = str_replace('"', '\"', $html[0]->code);
		#$html	=	$html[0]->code;
		
		//add to template
		eval("\$this->html_body .=\"$html\";");
	}

	/**
	 * Add the main forum menu to the output buffer
	 * 
	 * @return none
	 */
	function add_menu()
	{
		global $user;
		$lang_header	=	new lang_header;
	

		//  Menu for a guest that is not logged in
		if ($user->group =="6" || $user->group =="5" || $user->group =="4" ||  !$user->group)
		{

			// Create an array of words to use here
			$words = array( 
					"frontpage" => $lang_header->menu_frtpage, 
					"register" => $lang_header->menu_register, 
					"login" => $lang_header->menu_login,
					"members" => $lang_header->menu_members, 
					"search" => $lang_header->menu_search, 
					"help" => $lang_header->menu_help, 
					"rules" =>$lang_header->menu_rules,
					"guidelines" => $lang_header->menu_guidelines,
					"active_posts" => $lang_header->menu_active);		
		

			// add template to output
			return $this->return_html('mainmenu_guest', $words);
		}
		else
		{
			//  Boink menu for a logged in user


			//Power links?
			if($user->g_is_mod =="0")
			{
				$staff_link = '';
			}
			else
			{
				$staff_link = $lang_header->menu_staff;
			}

			// Create an array of words to use here
			$words = array( 
					"frontpage" => $lang_header->menu_frtpage, 
					"logout" => $lang_header->menu_logout, 
					"usercp" => $lang_header->menu_cp,
					"members" => $lang_header->menu_members, 
					"search" => $lang_header->menu_search, 
					"help" => $lang_header->menu_help, 
					"rules" => $lang_header->menu_rules,
					"newPMs" => $user->new_pms.' '.$lang_header->menu_newpm, 
					"guidelines" => $lang_header->menu_guidelines,
					"active_posts" => $lang_header->menu_active, 
					"Staff" => "$staff_link");		
		

			// add template to output	
			return $this->return_html('mainmenu_member', $words);
		}
	}


	/**
	 * Add the admin menu to the output buffer
	 * 
	 * @return none
	 */
	function add_admin_menu()
	{
		$lang	=	new lang_admin_global;

		// Create an array of words to use here
		$words	=	array( 
			'template_manager'	=>	$lang->template_manager,
			'admin_index'		=>	$lang->admin_index,
			'forum_index'		=>	$lang->forum_index,
			'templates'			=>	$lang->templates,
			'general'			=>	$lang->general,
			'forums'			=>	$lang->forums,
			'users'				=>	$lang->users,
			'system'			=>	$lang->system,
			'global_config'		=>	$lang->global_config,
			'site_config'		=>	$lang->site_config,
			'cache_manager'		=>	$lang->cache_management,
			'manage_forums'		=>	$lang->manage_forums,
			'word_censor'		=>	$lang->word_censor,
			'reported'			=>	$lang->reported,
			'task_log'			=>	$lang->tasklog,
			'email_queue'		=>	$lang->email_queue,
			'logs'				=>	$lang->logs,
			'language'	 		=>	$lang->language,
			'user_home'			=>	$lang->user_home,
			'add_user'	 		=>	$lang->add_user,
			'edit_user'	 		=>	$lang->edit_user,
			'delete_user'		=>	$lang->delete_user,
			'ban_user'			=>	$lang->ban_user,
			'help'				=>	$lang->help,
			'backup'			=>	$lang->backup,
			'add_forum'			=>	$lang->add_forum,
			'add_category'		=>	$lang->add_cat
		);		

		// add template to output
		return $this->return_html('adminmenu', $words);
	}

	/**
	 * Adds a admin wrapper to output buffer, used in admin CP
	 * 
	 * @return none
	 */
	function add_admin_wrapper($htmlCode)
	{
		$templatename ="adminwrapper";
		global $config, $cache, $user;

		$template = $cache->query('get_template', array($config->def_tpl, $templatename));
		$template = str_replace('"', '\"', $template[0]->code);
		
		//Debug info is nice :)
        global $timer, $db;
        if ($_SERVER['QUERY_STRING'])
        {
        	$qstring = '?' . str_replace('&', '&amp;', $_SERVER['QUERY_STRING']) . '&amp;debug=1';
        }
        else 
        {
        	$qstring = '?debug=1';
        }

		$stats	=	'Run time was ' . $timer->stop_and_display(3) . ' seconds, used <a href="' . $_SERVER['PHP_SELF'] . $qstring . '">' . $db->queries . '</a> queries.';

		//Show copyright information
		$copyright	=	'Powered by <a href="http://vikingboard.com/">Vikingboard</a> (' . $config->version . ')';

		//show debug?
		if($config->show_debuginfo && $_GET['debug'])
		{
			global $debug;
			$debugdata = '';
			foreach($debug->debugdata as $row)
			{
				$debugdata	.=	$row;
			}
		}
		
        //define array witch contains global wrapper variables
		$data = array(
			'title'		=> 'Vikingboard Admin CP',
			'menu'		=> $this->add_admin_menu(),
			'body'		=> $htmlCode,
			'copyright'	=> $copyright,
			'stats'		=> $stats,
			'debugdata'	=> $debugdata,
		);

        //and run the code
		eval("\$this->html_body =\"".$template."\";");
    }
	
	/**
	 * Adds a forum wrapper to the main forum pages, which again is added to output buffer.
	 * 
	 * @return none
	 */
	function add_wrapper($title, $nav=array())
	{
		$templatename ="wrapper";
		global $config, $cache, $user;
		
		//language
		$lang_frtpage	=	new lang_frtpage;
		$lang_global	=	new lang_global;
		
		//get it!, good doggie :)
		$template = $cache->query('get_template', array($config->def_tpl, $templatename));
		$template = str_replace('"', '\"', $template[0]->code);


		//	Create a navigation line
		//Define $navigation
		$navigation = '';
		//Start of navigation
		$navigation			=	$navigation .= $this->return_html('navigation_start', array("forumname" => $config->forum_name));
		
		//The navigation links
		foreach($nav as $row => $value) {
			$thisRow['url']	= $row;
			$thisRow['name']= $value;
			$navigation .= $this->return_html('navigation_link', $thisRow);
		}
		
		// Commented since it's now defined in the template wrapper
		// $navigation .= $this->return_html('navigation_end', $thisRow);
		
		//	Parse the body template and add in needed thingies

		
		//show run time and queries?
		if ($config->exec && $user->g_is_admin)
		{			
			global $timer, $db;
			if ($_SERVER['QUERY_STRING'])
        	{
        		$qstring = '?' . str_replace('&', '&amp;', $_SERVER['QUERY_STRING']) . '&amp;debug=1';
        	}
        	else 
        	{
        		$qstring = '?debug=1';
        	}
			$runtime = 'Run time: ' . $timer->stop_and_display(3) . ' seconds';
			$queries = 'Queries: <a href="' . $_SERVER['PHP_SELF'] . $qstring . '">' . $db->queries . '</a>';
			$acp_link = '<p><a href="admin.php">Admin CP</a></p>';
		}
		elseif ($user->g_is_admin)
		{
			$acp_link = '<p><a href="admin.php">Admin CP</a></p>';
		}
		else 
		{
			$runtime = '';
			$queries = '';
		}

		//show debug?
		if($config->show_debuginfo && (isset($_GET['debug'])) && $user->g_is_mod)
		{
			global $debug;
			$debugdata = '';
			foreach($debug->debugdata as $row)
			{
				$debugdata	.=	$row;
			}
		}

		//Show copyright information
		$copyright	=	'Powered by <a href="http://vikingboard.com/">Vikingboard</a> (' . $config->version . ')';

		if(!isset($acp_link))
		{
			$acp_link = '';
		}
		if(!isset($debugdata))
		{
			$debugdata = '';
		}
		
		//define array witch contains global wrapper variables
		$data	=	array(  
			'title' 		=>	$title . ' - ' . $config->forum_name,
			'forumname'		=>	$config->forum_name,
			'navigation'	=>	$navigation,
			'search_value'	=>	$lang_frtpage->search_value,
			'search_button'	=>	$lang_frtpage->search_button,
			'body' 			=>	$this->html_body,
			'menu' 			=>	$this->add_menu(), 
			'runtime' 		=>	$runtime,
			'queries' 		=>	$queries,
			'acp_link' 		=>	$acp_link,
			'debugdata'		=>	$debugdata, 
			'copyright'		=>	$copyright,
			'to_top'		=>	$lang_global->to_top,
		);

		eval("\$this->html_body =\"".$template."\";");
		#$this->html_body ="".$template."";
	}
	
	/**
	 * Flushes output buffer to the webclient
	 * 
	 * @return none
	 */
	function print_page()
	{
		echo $this->html_body;
		$this->html_body = '';
		flush();
	}
}

?>