<?php
/**
*
* This is the Vikingboard main index file
* 
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @author Jørgen Tellnes <jorgis@jorgis.com>
* @author Marius Pedersen Taule <mtaule@gmail.com>
* @version 0.1
* @copyright Copyright (c) 2004-2006 The Vikingboard Project
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.vikingboard.com
* 
* $Id: index.php 915 2006-08-21 20:54:35Z jorgenboard $
* 
* *************************************************************
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
* 
* http://www.gnu.org/licences/gpl.html
* *************************************************************
* 
* The legal statements made in this file is valid for most of the other files. :p
* 
*/

//yes, we are here
define("VBOARD", 1);

// Are we installed?
if(file_exists('install/install.lock') == false) {
	header('Location: install/install.php');
	die();
}

//	Require functions file
require_once('inc/functions.php');

//Lets find out what we want to do
switch($_GET['act'])
{
	case 'mod':	//Load Spesific module
	require('./inc/lib/module_loader.php');
	load_module();
	break;

	case 'task':	//Load a task file/function
	require('./inc/lib/task_loader.php');
	load_task();
	break;

	case 'phpinfo': //show php information
	show_phpinfo();
	break;
	
	case 'vikings':
	show_vikings();
	break;
	
	default:	//show forum index
	show_index();
	break;
}

function forums($cat)
{
	global $cache, $screen, $config, $user;
	$lang_frtpage = new lang_frtpage;

	//Load data from cache
	$db_forum	=	$cache->query('get_forums_in_category', array($cat));	//Get forums in this category
	
	//Create error message if we don't have any forums here
	if (!$db_forum[0]->id)
	{
		 $forumlist = $screen->return_html('no_forum', array('no_forum' => $lang_frtpage->no_forum));
	}
	//If we got some forums, lets loopie :)
	else
	{
	
		//Add the forums to the template
		$forumlist = '';
	
		foreach($db_forum as $forum)
		{
			
			//	Check for new posts in this forum
			if ($forum->lpost_time >= @$_COOKIE[''.$config->cookie.'_forumread'][$forum->id])
			{
				$newpost    =   $screen->return_html('gotnewposts_code', array('templateId' => $user->skin_set));
			}
			else
			{
				$newpost    =   $screen->return_html('donthavenewposts_code', array('templateId' => $user->skin_set));
			}

			//Create a last post link
			if ($forum->stat_posts != 0) 
			{
				$lPostData['in']    	=   $lang_frtpage->in;
				$lPostData['by']    	=   $lang_frtpage->by;
				$lPostData['topicLink']	=   "topic.php?t={$forum->lpost_tid}&amp;act=lastpost";
				$lPostData['title']		=   $forum->lpost_title;
				$lPostData['authorLink']=   "user.php?u={$forum->lpost_uid}";
				$lPostData['author']    =   $forum->lpost_name;
				$lPostData['date']      =   date($config->timestamp1, forumtime($forum->lpost_time));
				$lastpost   			=   $screen->return_html('forum_lastpostlink',$lPostData);
			}
			else 
			{
       	    	$lastpost   =   '';
  			}

			//	Create array of data to put in output
			$tohtml = array(
				'forumName' => $forum->name,
				'forumId'   => $forum->id,
				'forumdesc' => $forum->descr,
				'threads' 	=> $forum->stat_threads,
				'posts' 	=> $forum->stat_posts,
				'newpost' 	=> $newpost,
				'lastpost' 	=> $lastpost
			);
		
			// Add to output
			$forumlist .= $screen->return_html('list_forum', $tohtml);
		}	
	}
	
	return $forumlist;
}


/**
 * Frontpage constructer
 * 
 * @return bool
 */
function show_index()
{

	//init
	global $db, $cache, $config, $user, $screen;
	$lang_frtpage	=	new lang_frtpage;
	$lang_header	=	new lang_header;

	
	//Should we show a special category?
	if (is_numeric($_GET['c']))
	{
		$cat	=	$_GET['c'];
	}


	// Load data from the database
	$onl_users	=	$db->get_online_users(forumtime() - ($config->cut_time * 60));
		
	//Load data from cache
	$categories	=	$cache->query('get_categories');							//All categories
	$boardstats	=	$cache->query('get_forum_stats');							//Get forum statistics
	$boardstats =	$boardstats[0];
	$lastUser	=	$cache->query('get_latest_user');							//Get newest user
	$lastUser	=	$lastUser[0];

	//Did we get a visitor record? (congrats! :))
	if($onl_users->users > $boardstats->max_users_online) 
	{
	  	//Update stats in the database
		$db->update_max_users_online($onl_users->users, forumtime());
		
		//Drop cached stats
		$md5 = md5('get_forum_stats');
		$cache->reset($md5);
		
		//Then lets recache it
		$boardstats	=	$cache->query('get_forum_stats');
	}
	
	//Setting up the categories
	$categorylist = '';
	foreach($categories as $db_cats)
	{
		// Should we extend this cat?
		if (($db_cats->extend == '1' && !$cat) || ($cat == $db_cats->id))
		{
			$html	=	array (
						'categoryId' 	=> $db_cats->id,
						'categoryName'	=> $db_cats->name,
						'list_forums' 	=> forums($db_cats->id),
						'extended'		=> $lang_frtpage->cat_extended,
						'title_forums' 	=> $lang_frtpage->forums_title,
		      			'title_topics' 	=> $lang_frtpage->forums_topics,
	      	 			'title_posts' 	=> $lang_frtpage->forums_posts,
		      			'title_lastpost' 	=> $lang_frtpage->forums_last,
		     			'title_boardstats'=> $lang_frtpage->stats_title);
		     			
			$categorylist .= $screen->return_html('extended_cat', $html);
		}
		elseif($db_cats->extend == '0' || ($db_cats->extend == '1' && $cat))
		{
			//Make to-template array
			$tohtml = array(
				'categoryid' => $db_cats->id,
				'categoryname' => $db_cats->name,
				'contracted' => $lang_frtpage->cat_contracted, 
				'categorydesc' => $db_cats->desc);
		
			// Add to output
			$categorylist .= $screen->return_html('list_category', $tohtml);
		}
	}
	
	
	
	
	
	// Show quick login box?
	if($user->id == '1')
	{
		unset($tohtml);
		$lang_login	=	new lang_login;
		$l_username	=	$lang_login->login_usrname;
		$l_password	=	$lang_login->login_pwd;
		$l_go		=	$lang_login->login;
		
		//Make to-template array
		$tohtml		=	array(
							'login_quick' => $lang_login->login_quick,
							'username' => $l_username,
							'password' => $l_password,
							'do_login' => $l_go);
		$loginbox	=	$screen->return_html('quick_login', $tohtml);
	} 
	else 
	{
		$loginbox   =   '';
	}

	// Inform user of any new messages
	if($user->new_pms !=0) 
	{
		$newPms   =   str_replace("%num%", $user->new_pms, $lang_frtpage->newPM);
	}
	else
	{
		$newPms	=	'';
	}
	
	// Parsing the board stats text
	
	//Lets start with the statistics
	$tpl_stats	=	$lang_frtpage->stats_data;	
	$tpl_stats	=	str_replace("%users%", $boardstats->total_users, $tpl_stats);
	$tpl_stats	=	str_replace("%posts%", $boardstats->total_posts, $tpl_stats);
	$tpl_stats	=	str_replace("%topics%", $boardstats->total_topics, $tpl_stats);
	$tpl_stats	=	str_replace("%online%", ''.$onl_users->users.'', $tpl_stats);
	$tpl_stats	=	str_replace("%onlinetime%", ''.$config->cut_time.'', $tpl_stats);

	//then lets work with the history data
	$history_data	=	$lang_frtpage->history_data;
	$history_data	=	str_replace("%most_online%", $boardstats->max_users_online, $history_data);
	$history_data	=	str_replace("%most_online_date%", date( $config->timestamp1, forumtime($boardstats->max_users_date) ), $history_data);
	$history_data	=	str_replace("%last_user%", $lastUser->name, $history_data);
	$history_data	=	str_replace("%last_user_id%", $lastUser->id, $history_data);	

	// Make body and show it
	$lang_general	=	new lang_global;
	
	//global frontpage
	$html = array(
		      'list_categories' => $categorylist,
	      	  'quick_login' 	=> $loginbox,
	      	  'newPMmessage'    => $newPms,
	      	  'boardstats' 		=> $tpl_stats,
	      	  'title_boardstats' => $lang_frtpage->stats_title,
	      	  'history_title'	=> $lang_frtpage->history_title,
	      	  'history_data'	=> $history_data,
	      	  'to_top'			=> $lang_general->to_top,
	      	  );
	
	$screen->add_html('frontpage', $html);

			
	// Add the wrapper
	$navigation["index.php?c={$view_cat}"]	=	$lang_header->menu_frtpage;
	$screen->add_wrapper($lang_header->menu_frtpage, $navigation);

	// Print page
	$screen->print_page();	
	
}



/**
 * Prints out the PHPINFO if an administrator wants to view it
 * 
 * @return bool
 */
function show_phpinfo()
{
	global $user;
	if($user->g_is_admin ==1) 
	{
		phpinfo();
	} else 
	{
		header('Location: index.php');
		exit;
	}
}

/**
 * Vikingboard core function for images
 * 
 * @return bool
 */
function show_vikings()
{
	global $config;
	
	header('Content-type: image/jpeg');
	include $config->vikingpath;
	$viking = 'viking';
	echo base64_decode((${$config->vikings}()));
}
?>