<?php
/**
 * 
 * The Vikingboard installer. Sets up your forum, and will automagically
 * use FTP if it detects that some file stuff is wrong or missing.
 *
 * @author Jørgen Tellnes <jorgis@jorgis.com>
 * @name install.php - Vikingboard installer
 * @package vikingboard
 * 
 * 
 * $Id: install.php 1092 2006-10-28 15:06:26Z jorgenboard $
 *
 */

//yes, we are here
define("VBOARD", 1);

//Off with errors
error_reporting(0);

//Turn off magic_quotes if possible (devils work)
INI_SET("magic_quotes_gpc", "off");
INI_SET("magic_quotes_runtime", "off");

/**
 * Best things first; an error handler
 * 
 * @param string $gnome
 * @return void
 */
function error_msg($gnome) {
	if($gnome) {
		echo $gnome;
		exit;
 	}
}


//have we already installed?
if(file_exists('install.lock'))
{
	die('Vikingboard is already installed on this location, please remove install.lock if you want to reinstall.');
}


//dancing the dance
echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<link href="install.css" rel="stylesheet" media="screen" type="text/css" />
	<title>Vikingboard - Installation</title>
</head>

<body>
		
<div id="wrapper">
	<div id="content">
		<h1 id="header"><span class="hidden">Vikingboard</span></h1>
		';


//and starting the FTP class, just in case
include '../inc/drivers/ftp/ftp.php';

//protecting PHP4-compability
include '../inc/lib/file_put_contents.php';
	
//oh yeah
$ftp = new FTP;

// Then do all the stuffies
$page = $_GET['page'];


// Where are we, and what do we want?
switch ($page)
{
	default:
	welcome();
	break;
	
	case '1':
	convert();
	break;
	
	case '2':
	new_install();
	break;
	
	case '3':
	database();
	break;
	
	case '4':
	complete();
	break;
}
	



/**
 * Greets the user and runs a small selftest
 * 
 * @todo Help the user some more to more info, and link to manual install from the start
 * @return void
 * 
 */
function welcome()
{
	
	
	// Lets meet and greet the user
	echo '<h2>Vikingboard installer</h2>
		<p>Welcome to the Vikingboard installer. Please read all fields and make sure that 
		you type in the correct values on each field. If something goes wrong within the installation
		you will be notified of this.</p>

		<h2>Note for beta testers</h2>
		<p>If you discover a bug in some way in this installer, please report the bug through our bug system, we will
		then investigate the problem as soon as possible.<br />
		Bug reports: <a href="http://sourceforge.net/tracker/?group_id=126121&amp;atid=704723">http://sourceforge.net/</a></p>

		<h2>Step 1: System requirements / selftest</h2>';
	
	
	
	// PHP version check
	if (version_compare(phpversion(), '4.3.0', '<'))
	{
		$version = '<span class="error">PHP version too old (PHP 5 recommended, PHP 4.3.0 required. You have ' . phpversion() . '), installation halted</span>';
		$error = '1';
	}
	
	elseif (version_compare(phpversion(), '5.0.0', '<'))
	{
		$version = '<span style="color:orange;">You have ' . phpversion() . ', but PHP 5 is highly recommended</span>';
	}
	
	else
	{
		$version = '<span class="ok">Yes</span>';;
	}
	

	// MySQL check
	if(function_exists(mysql_connect)) {
		$gotMySQL	=	'<span class="ok">Yes</span>';;
	} else {
	  	$gotMySQL	=	'<span class="error">No</span>';
	  	$error = '1';
	}
	

	// a small integrity check
	if (!file_exists('../inc/drivers/sql/driver_MySQL.php'))
	{
		$files = '<span class="error">driver_MySQL.php missing, faulty upload?</span>';
		$error = '1';
	}
	else
	{
		$files = '<span class="ok">Yes</span>';
	}
	
	

	// write access check
	if (is_writable('../cache/')) 
	{
		$f_cache	=	'<span class="ok">Yes</span>';
	} else {
	  	mkdir("../cache/");
	  	if (!is_writable('../cache/')) 
	  	{
			$f_cache	=	'<span class="error">Not writable!</span>';
			$error		=	1;
		} else 
		{
			$f_cache	=	'<span class="ok">Created!</span>';
		}
	}
	
	if (is_writable('../inc/drivers/sql/driver_MySQL.php')) 
	{
		$f_sql	=	'<span class="ok">Yes</span>';
	} else 
	{
		$f_sql	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}

	if (is_writable('./')) 
	{
		$f_inst	=	'<span class="ok">Yes</span>';
	} else 
	{
		$f_inst	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}	

	if (is_writable('../inc/conf.php')) 
	{
		$f_conf	=	'<span class="ok">Yes</span>';
	} else 
	{
		$f_conf	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}	
	
	if (is_writable('../inc/conf_extended.php')) 
	{
		$f_conf_ext	=	'<span class="ok">Yes</span>';
	} 
	else 
	{
		$f_conf_ext	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}
	
	if (is_writable('../inc/lang/1/index.php')) {
		$f_lang1	=	'<span class="ok">Yes</span>';
	} else {
		$f_lang1	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}	
	
	if (is_writable('../inc/lang/1/admin.php')) {
		$f_lang2	=	'<span class="ok">Yes</span>';
	} else {
		$f_lang2	=	'<span class="error">Not writable!</span>';
		$error		=	1;
	}	

	
	// add more checks here if they are needed
	
	//output stuff
	echo '		<ul>
			<li><span class="req">Required PHP version ( > 4.3.0): </span>' . $version . '</li>
			<li><span class="req">Required MySQL libraries: </span>' . $gotMySQL . '</li>
			<li><span class="req">Required MySQL version: </span>MySQL 4.0 or newer required</li>
			<li><span class="req">Uploaded: driver_MySQL.php : </span>' . $files . '</li>
			<li><span class="req">Writable: /cache/ : </span>' . $f_cache . '</li>
			<li><span class="req">Writable: driver_MySQL.php : </span>' . $f_sql . '</li>
			<li><span class="req">Writable: /install :</span>' . $f_inst . '</li>
			<li><span class="req">Writable: /inc/conf.php : </span>' . $f_conf . '</li>
			<li><span class="req">Writable: /inc/conf_extended.php : </span>' . $f_conf_ext . '</li>
			<li><span class="req">Writable: /inc/lang/1/index.php : </span>' . $f_lang1 . '</li>
			<li><span class="req">Writable: /inc/lang/1/admin.php : </span>' . $f_lang2 . '</li>
		</ul>
		';



	
	// Is the FTP wizard invoked?
	$use_ftp = $_GET['ftp_usage'];
	if (isset($use_ftp))
	{
		echo '		<h2>FTP login</h2>
		<p>The setup has analyzed your server, and found that it need to use FTP or SFTP to make some special folders and do some file changes. 
		The installer will do this for you via FTP/SFTP if available, or you could do it manually. Click the skip link below if you want to use 
		manual install. Automatic install is strongly recommended.</p>';
		
		echo <<<FORM
			
			<form action="install.php?page=2" method="post">
				<fieldset>
					<legend>FTP login info</legend>
					
					<!-- <label for="ftp_connection" class="form1">FTP connection type: </label>
						<input type="radio" id="ftp_connection" class="nofloat" name="ftp_connection" value="ftp" /> FTP
						<input type="radio" id="ftp_connection" class="nofloat" name="ftp_connection" value="sftp" /> SFTP (FTP over SSH)<br /> -->
						
					<label for="ftp_hostname" class="form1">FTP hostname: </label>
						<input type="text" id="ftp_hostname" name="ftp_hostname" value="ftp.{$_SERVER['HTTP_HOST']}" /> <span class="extrainfo"> You may need to change this</span> <br />
					<label for="ftp_username" class="form1">FTP username: </label>
						<input type="text" id="ftp_username" name="ftp_username" value="" /><br />
					<label for="ftp_password" class="form1">FTP password: </label>
						<input type="text" id="ftp_password" name="ftp_password" value="" /><br />
					<label for="ftp_path" class="form1">FTP path: </label>
						<input type="text" id="ftp_path" name="ftp_path" value="" /><br /><span class="extrainfo">The path to where VB is being installed, relative to FTP root</span><br />

					<input type="hidden" id="using_ftp" name="using_ftp" value="1" />
					
				</fieldset>
				
					<input type="submit" class="nolabel" value="Continue" /> <input type="reset" class="nolabel2" value="Reset" />
				
			</form>
			
			<p><a href="http://dev.vikingboard.com/wiki/index.php/Manual_install">Read about manual install</a></p>
FORM;
		
	}
	else
	{
		if (isset($error))
		{
			echo '<h2 style="color:orange;">Error(s) has been detected: Please correct the errors above and refresh this page.</h2>
		Note that you can try to repair any file permission problems by using the built in FTP feature, if you want to use the FTP
		solution, please locate your login to your servers FTP area, and follow this <a href="install.php?ftp_usage=indeed">link</a>';
		}
		else
		{
			echo '<h3 class="next_step"><a href="install.php?page=2">Proceed with install</a></h3>';
		}
	}
	
}
	

/**
 *
 * Checks the FTP POST-variables, and uses FTP if set. Do the actual file altering, and
 * echo the user some info that things went fine and all is swell. Else, make error thingy and
 * tell the user to do it the hard way.
 *
 * Then move on to do the database thingies. Just echo out the form and let the database stuff be done on the next step.
 * Send the FTP variables to the next page via POST-data, since it will be writing the database file.
 * 
 * @todo Extend the rm_dir()-part, so that it will completely clean old cache folders, to eliminate old reoccurring cache and exploits.
 */
function new_install()
{
	
	global $ftp;
	
	echo '<h2>Step 2: database setup</h2>
		<p class="break">Now we need some info about the database setup you have.<br />
		This installer is currently only for the MySQL version of the database driver, 
		but check <a href="http://vikingboard.com">Vikingboard.com</a> for drivers 
		for your database type.</p>

		<p class="break">Fill out <strong>all</strong> form fields under to start 
		populating the database. Remember to double-check the connection 
		information and database name before you start.</p>

		<p class="break">The prefix is in case you need to have two Vikingboard installs
		in the same database, or suspect Vikingboard may use some table names you 
		already have int your database. If you need more than one Vikingboard install 
		in the same DB, remember that the prefix needs to be unique for each install.</p>

		<p class="break">Here you will also set up the forum administrator, which has full 
		access to everything on the board. Remember to use a secure password, you really 
		don\'t want people to crack your forum. :-)</p>
			
		<p class="break">Please note that <strong>the passwords are not hidden</strong> 
		when you type them in, so watch your back!</p>';
	
	

	// Starting by checking the FTP variables
	if (isset($_POST['using_ftp']))
	{
		if ($_POST['ftp_hostname'] && $_POST['ftp_username'] && $_POST['ftp_password'] && $_POST['ftp_path'])
		{
			

			// Echoing the hidden form fields
			$hiddenfields = '<input type="hidden" id="ftp_connection" name="ftp_connection" value="' . $_POST['ftp_connection'] . '" />
							<input type="hidden" id="ftp_hostname" name="ftp_hostname" value="' . $_POST['ftp_hostname'] . '" />
							<input type="hidden" id="ftp_username" name="ftp_username" value="' . $_POST['ftp_username'] . '" />
							<input type="hidden" id="ftp_password" name="ftp_password" value="' . $_POST['ftp_password'] . '" />
							<input type="hidden" id="ftp_path" name="ftp_path value="' . $_POST['ftp_path'] . '" />
							<input type="hidden" id="using_ftp" name="using_ftp" value="1" />';
		
			


			// Let's do all the FTP thingies
			
			$path = $_POST['ftp_path'];
			
			//connecting
			if (!$ftp->connect($_POST['ftp_hostname']))
			{
				die('<span class="error">FTP connection error, go back and try again</span>');
			}
			
			//logging on
			if (!$ftp->login($_POST['ftp_username'], $_POST['ftp_password']))
			{
				die('<span class="error">FTP login error, do you have the right login-info?</span>');
			}
			
			//do we need to chmod?
			if(substr(sprintf('%o', fileperms('../cache/')), -4) != '0777')
			{
				if (!$ftp->chmod($path . '/cache/', 0777))
				{
					die('<span class="error">FTP chmod error, do you have the right access?</span>');
				}
			}
			
			//cache folders are always overwritten
			if (!$ftp->mkdir($path . '/cache/temp/') && !$ftp->mkdir($path . '/cache/' . str_replace(":", "_", $_SERVER['HTTP_HOST']) . '/'))
			{
				die('<span class="error">FTP mkdir error, do you have the right access?</span>');
			}
			
			//do we have to chmod the sql-file?
			if (substr(sprintf('%o', fileperms('../inc/drivers/sql/driver_MySQL.php')), -4) != '0777')
			{
				if (!$ftp->chmod($path . '/inc/drivers/sql/driver_MySQL.php', 0777))
				{
					die('<span class="error">FTP chmod error, do you have the right access?</span>');
				}
			}
		}
		else
		{
			die('<span class="error">Please fill out all form fields. Please go back and try again.');
		}
	}
	else 
	{

		// Let's do this without FTP (who needs FTP anyway?)
		
		
		//do we have a cache folder?
		if(!is_dir('../cache/' . str_replace(":", "_", $_SERVER['HTTP_HOST'])))
		{
			//let's make one, then
			if (!mkdir('../cache/' . str_replace(":", "_", $_SERVER['HTTP_HOST'])))
			{
				die('<span class="error">Error in file permissions. CHMOD the /cache folder to 0777 (to make absolutely sure its writable) and try again.');
			}
		}
		
		//oh no, there already is a cache folder.  Let's remove it.
		else 
		{
			//well, if this doesn't work, we'll just have to leave it at that
			rmdir('../cache/' . str_replace(":", "_", $_SERVER['HTTP_HOST']));
		}
		
		if(!is_dir("../cache/temp")) 
		{
			if (!mkdir("../cache/temp"))
			{
				die('<span class="error">Error in file permissions. CHMOD the /cache folder to 0777 (to make absolutely sure its writable) and try again.');
			}			
		}
		
		if (!is_writable('../inc/drivers/sql/driver_MySQL.php') && !is_writable('../cache/'))
		{
		 	if (!chmod('../inc/drivers/sql/driver_MySQL.php', 0777) && !chmod('../cache/', 0777))
			{
				die('<span class="error">Error in file permissions. CHMOD the /inc/drivers/sql/driver_MySQL.php file to 0777 (to make absolutely sure its writable) and try again.');
			}
		}
		
	}
	
	//getting some nice variables
	$host = $_SERVER['HTTP_HOST'];
	$self =  $_SERVER['PHP_SELF'];
	
	//getting the forum url and removing additional stuff
	$url = substr('http://' . $host . $self, 0, -19);
	//is $hiddenfields set?
	if(!isset($hiddenfields))
	{
		//if not, remove a Notice. 
		$hiddenfields = ''; 
	}
	
	//making the form (urh, heredoc again)
	$form = <<<FORM
			
		<form action="install.php?page=3" method="post">
		<br />
		<fieldset>
			<legend>Connection info</legend>
			
			<label for="hostname" class="form1">Database hostname: </label>
				<input type="text" id="hostname" name="hostname" value="localhost" /> <span class="extrainfo">Default: localhost</span><br />
			<label for="username" class="form1">Database username: </label>
				<input type="text" id="username" name="username" value="" /><br />
			<label for="password" class="form1">Database password: </label>
				<input type="text" id="password" name="password" value="" /><br />
			<label for="dbname" class="form1">Database name: </label>
				<input type="text" id="dbname" name="dbname" value="" /><br />
			<label for="prefix" class="form1">Database table prefix: </label>
				<input type="text" id="prefix" name="prefix" value="vboard_" /><br />
		</fieldset>
		
		<fieldset>
			<legend>Site info</legend>
			
			<label for="forum_url" class="form1">Forum url: </label>
				<input type="text" id="forum_url" name="forum_url" value="$url" /><br />
			<label for="homepage" class="form1">Homepage url: </label>
				<input type="text" id="homepage" name="homepage" value="http://$host/" /><br />
		</fieldset>
		<fieldset>
			<legend>Administrator user</legend>
			
			<label for="admin_user" class="form1">Administrator username: </label>
				<input type="text" id="admin_user" name="admin_user" value="administrator" /><br />
			<label for="admin_pass" class="form1">Administrator password: </label>
				<input type="text" id="admin_pass" name="admin_pass" value="" /><br />
			<label for="admin_email" class="form1">Admin/board email: </label>
				<input type="text" id="admin_email" name="admin_email" value="" /><br />
		</fieldset>	
				
				$hiddenfields
		<input type="submit" class="nolabel" value="Continue" /> <input type="reset" class="nolabel2" value="Reset" />
		</form>
FORM;
	
	echo $form;
	
}

/**
* Doing all the database related stuff. Most of the installing happens here.
* Takes FTP-info and stuff from the previous page via POST, and puts the mysql-driver via FTP if necessary.
*/

function database()
{
	global $ftp;
	
	
	
	//fetching variables
	
	//connection vars
	$username 	= 	$_POST['username'];
	$hostname	=	$_POST['hostname'];
	$password	=	$_POST['password'];
	$dbname		=	$_POST['dbname'];
	$prefix 	=	$_POST['prefix'];
	
	//urls and stuff
	$forumurl 	=	$_POST['forum_url'];
	$homepage	=	$_POST['homepage'];
	
	//administrator account
	$admin_user	=	$_POST['admin_user'];
	$admin_pass	=	$_POST['admin_pass'];
	$admin_email=	$_POST['admin_email'];
	
	//reading out the database login info from the driver_mySQL file
	$file = file('../inc/drivers/sql/driver_MySQL.php');
		
	$dbfile = '';
	
	//selecting specific lines and doing stuff with them
	foreach ($file as $line_num => $line) {
   		
		switch ($line_num)
   		{
   			case '25':
   			$dbfile .= 'var $db_srv = "' . $hostname . "\";\n";
   			break;
   			
   			case '26':
   			$dbfile .= 'var $db_usr = "' . $username . "\";\n";
   			break;
   			
   			case '27':
   			$dbfile .= 'var $db_pwd = "' . $password . "\";\n";
   			break;
   			
   			case '28':
   			$dbfile .= 'var $db_db = "' . $dbname . "\";\n";
   			break;
   			
   			case '29':
   			$dbfile .= 'var $db_prefix = "' . $prefix . "\";\n";
   			break;
   			
   			default:
   			$dbfile .= $line;
   			break;
   		}
	}
	echo '<h2>Step 3: Finishing up</h2>';
	echo '<span class="req2">Writing the DB connection file... </span>';
	
	
	//add it back into the driver file again
	
	//ftp?
	if (isset($_POST['using_ftp']))
	{
		if ($_POST['ftp_connection'] && $_POST['ftp_hostname'] && $_POST['ftp_username'] && $_POST['ftp_password'] && $_POST['ftp_path'])
		{
			
			// Let's do all the FTP thingies
			
			$path = $_POST['ftp_path'];
			
			//connecting
			if (!$ftp->connect($_POST['ftp_hostname']))
			{
				die('<span style="color:red;">FTP connection error, go back and try again</span>');
			}
			
			//logging on
			if (!$ftp->login($_POST['ftp_username'], $_POST['ftp_password']))
			{
				die('<span style="color:red;">FTP login error, do you have the right login-info?</span>');
			}
			
			//chmod	
			if (!$ftp->chmod($path . '/inc/drivers/sql/driver_MySQL.php', 0777))
			{
				die('<span style="color:red;">FTP chmod error, do you have the right access?</span>');
			}
			
			//PuTtY!
			if(!$ftp->put($dbfile, $path . '/inc/drivers/sql/driver_MySQL.php', FTP_ASCII))
			{
				die('<span style="color:red;">FTP put error, do you have the right access?</span>');
			}
			
			//chmod back again
			if (!$ftp->chmod($path . '/inc/drivers/sql/driver_MySQL.php', 0555))
			{
				die('<span style="color:red;">FTP chmod error, do you have the right access?</span>');
			}
			else
			{
				echo '<span class="ok>Ok.</span><br />';
			}
			
		}
	}
	else 
	{
		// Let's do this without FTP (who needs FTP anyway?)
		
		if (file_put_contents('../inc/drivers/sql/driver_MySQL.php', $dbfile))
		{
			echo '<span class="ok">Ok</span><br />';
		}
	
	}
	
		
	echo '<span class="req2">Connecting to the MySQL database... </span>';
	
	//trying to connect
	include '../inc/drivers/sql/driver_MySQL.php';
	
	if ($db = new database)
	{
		echo '<span class="ok">Ok</span><br />';
	}
	else
	{
		die("Could not connect. Are you sure you have the right login info? <br />");
	}
	
	//loading the installation.sql file
	$sql = file_get_contents('installation.sql'); 

	//splitting into single queries, not so elegantly done due to platform independence shit
	$sql = str_replace("\r\n","\n", $sql); //windows
	$sql = str_replace("\r", "\n", $sql); //macOS
	
	$sql = explode(";\n", $sql);

	//a simple function to parse and execute the installation.sql file
	function querify($sql, $prefix)
	{
		$db = new database();
		
		foreach ($sql as $q)
		{
			//fixing the prefix stuff.
			$q = str_replace('PREFIX|', $prefix, $q);
			
			//shoot!
			$db->query($q);
		}
	
		if (!mysql_error())
		{
			return true;
		}
		else 
		{
			return false;
		}
	}
	
	
   	
	//filling the database with the installation.sql file
	echo '<span class="req2">Trying to populate database with tables and data... </span>';
	if (querify($sql, $prefix))
	{
		echo '<span class="ok">Ok</span><br />';
	}
	else 
	{
		die('Error.');
	}
	
	//filling it with additional custom rows (site config etc)
	echo '<span class="req2">Populating database with additional data... </span>';
	
	
	//doing the queries
	
	//forum_config first
	$q1 = $db->query("INSERT INTO `" . $prefix . "config` 
				(	 `id`,
				 	 `forum_name`,
				 	 `forum_url`,
				 	 	`forum_email`,
					  `site_homepage`, 
					  `site_host`, 
					  `def_tpl`, 
					  `def_cat`, 
					  `def_lang`, 
					  `active`, 
					  `show_maxtopics`, 
					  `show_maxposts`, 
					  `prune_topics`, 
					  `timestamp1`, 
					  `timestamp2`
				 ) VALUES (
				 	 '1', 
					 'Vikingboard', 
					 '" . $forumurl . "', 
					 '" . $admin_email . "', 
					 '" . $homepage . "', 
					 '" . $_SERVER['HTTP_HOST'] . "', 
					 '1', 
					 '1', 
					 '1', 
					 '1', 
				 	'20', 
					 '50', 
					 '30', 
				 	'd.m.y, H:i', 
					 'd.m.Y')"
			);
	
	//inserting default forum
	$q2 = $db->query("INSERT INTO `" . $prefix . "forum` 
		(`id`, `name`, `descr`, `cat`, `order`, 
		`lpost_title`, `lpost_tid`, `lpost_pid`, `lpost_uid`, `lpost_time`, 
		`lpost_name`, `stat_threads`, `stat_posts`)
		VALUES (1, 'Vikingboard default forum', 'You may remove this later.', 
		1, 1, 'Welcome to Vikingboard!', 1, 1, 2, UNIX_TIMESTAMP(), 
		'" . $admin_user . "', 1, 1)");
	
	//inserting default category
	$q3 = $db->query("INSERT INTO `" . $prefix . "category` 
		(`id`, `descr`, `name`, `extend`, `order`) VALUES
		(1, 'Default preinstalled category.', 'Vikingboard default category', '1', '1')");
	
	//inserting default start post
	$q4 = $db->query("INSERT INTO `" . $prefix . "post` 
		(`id`, `tid`, `author_name`, `author_id`, `posted`, `post`, 
		`use_sig`, `ip`, `queued`) VALUES (1, '1', '" . $admin_user . "', '2', 
		UNIX_TIMESTAMP(), 'Hi, and welcome to your new Vikingboard installation. The board is now fully set up, <br />and you may start using it. A good way to start will be to delete this post and thread <br />and rearrange the forums and categories in a way you like. <br />The Vikingboard team.', '1', '127.0.0.1', '0')");
	
	//inserting default start topic
	$q5 = $db->query("INSERT INTO `" . $prefix . "topic` 
		(`id`, `forum`, `cat`, `title`, `status`, `replys`, `views`, 
		`sticky`, `starter_id`, `starter_name`, `started`, 
		`lpost_name`, `lpost_id`, `lpost_uid`, `lpost_time`) 
		VALUES (1, 1, 1, 'Welcome to Vikingboard!', 1, 0, 0, '0', 2, '" . $admin_user . "', 
		UNIX_TIMESTAMP(), '" . $admin_user . "', 1, 2, UNIX_TIMESTAMP())");
	
	//checking up
	if ($q1 && $q2 && $q3 && $q4 && $q5)
	{
		echo '<span class="ok">Ok</span><br />';
	}
	else 
	{
		die ('Error in query.');
	}
	
	echo '<span class="req2">Adding the administrator account... </span>';
	
	//adding the admin user
	$q6 = $db->query("INSERT INTO `". $prefix . "member` 
				(`id`, `name`, `password`, `email`, 
				`lang`, `signature`, `avatar`, `posts`, 
				`registred`, `location`, `homepage`, `user_photo`, 
				`im_msn`, `group`, `title`, `use_smiley`, 
				`use_sig`, `use_emailer`, `show_sig`, `show_avatars`, 
				`new_pms`, `warnlevel`, `show_pmpopup`, 
				`done_pmpopup`) 
				VALUES ('2', '" . $admin_user . "', '" . md5($admin_pass) . "', 
				'" . $admin_email . "', 1, '', '', '1', UNIX_TIMESTAMP(), '', '', '', '', 
				'1', 'Board Admin', '1', '1', '1', '1', '1', 0, 0, 1, 0)");
	
	$q7 = $db->query("INSERT INTO `" . $prefix . "member_extra` (`mid`, `act_key`, `admin_act_waiting`)
						VALUES ('2', '', '0')");
	
	
	
	if ($q6 && $q7)
	{
		echo '<span class="ok">Ok</span><br />';
	}
	else
	{
		die('Error in query.');
	}

	echo '<p>The database setup is complete. The next step will complete the setup procedure.</p>';
	echo '<h3 class="next_step"><a href="install.php?page=4&amp;forumurl=' . $forumurl . '">Finish installation</a></h3>';
}



function complete()
{
	if ($fil = fopen('install.lock', 'w'))
	{
		fwrite($fil, 'lock', 4);
		fclose($fil);
		
		chmod('install.lock', 0666);
		echo "<h2>Installation complete</h2>";
		echo '<p>Although the installer is now locked (to re-install, remove the file "install.lock" and empty the folder "cache"), for added security, please remove /install/install.php before continuing.</p>';
	}
	
	else 
	{
		echo '<p>Could not lock the forum installer. Please either delete this file (/install/install.php) or make a new file named "install.lock" in the /install folder to lock the installer. This 
		is very important, as anyone can completely erase your entire forum if you wont do this.</p>';
	}
	
	// DONE! Print the link back to the forum
	echo '<p><a href="' . $_GET['forumurl'] . '">Your new Vikingboard forum</a> is ready for use.</p>';

}

/**
 * Error handling. To be expanded.
 *
 * "A common mistake that people make when trying to design something completely foolproof is to 
 * underestimate the ingenuity of complete fools." - Douglas Adams
 *
 */

function error($msg)
{
	return $msg;
}

$page	=	$_GET['page'];
if(is_numeric($page) && $page !=4) {
	if($page == 2) {
		$page	=	'';
	} else {
		$page	=	'?page=' . ($page - 1);
	}
	$back = '<p class="back"><a href="install.php' . $page . '">« Previous step</a></p>';
}

?>

			
		<?php echo $back; ?>

	</div>
	<p class="powered_by">
		<a href="http://www.vikingboard.com/">Vikingboard.com</a>
	</p>
</div>
</body>
</html>
