<?php
/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.1
*
* $Id: login.php 955 2006-09-13 23:13:56Z ueland $
*
*/

//yes, we are here
define("VBOARD", 1);

//====================================
//	Login page, nice to have if we want our guests to be able to login ;)
//====================================


//	Require "kernel" file
require_once('inc/functions.php');


//	What mode to go in..
switch($_GET['t'])
{
	case '01':	//Log in a user
	login();
	break;

	case '02':	//Log out a user
	logout();
	break;
	
	case '04':	//Multi-login function
	multi_login($_GET['site'], $_GET['i']);
	break;
	
	default:	//Show login page
	login_page();
	break;
}


/*
 * Logout function, simply logs out a user
 *
*/
function logout()
{
	
	global $db, $config; 
	
	//changing the sessions record to a guest only state
	$db->update_sessions_logout_user();
	
	//Make shure that we dont have username and password stored
	setcookie("{$config->cookie}_username", "", time()-10);
	setcookie("{$config->cookie}_password", "", time()-10);	
	setcookie("{$config->cookie}_hideme", "", time()-10);
			
	//We need to empty the sessions table sometimes, and we are doing that here.
	$db->delete_remove_old_sessions();
		
	//If the board contains several sites, we need to log out from all of them.
	if($config->use_multi_login) {
			
			global $cache;
			
      //Get sites and loop through them
			$db_sites	=	$cache->query('get_sites');
			$db_sites	=	$db_sites[0];
			
			//multi-logging out!
			multi_logout($db_sites->id);
			
  } else {
    //Login complete
    header("Location:index.php");
  }
}


/*
 * Login function, checks login data and logs the user in if everything
 * is good to go. 
 *
 */  
function login()
{
	global $db, $config, $user, $cache;
	$lang_login	=	new lang_login;
    
	//getting form data
	$login_usrname     =	$_POST['username'];
	$login_pwd         =	$_POST['password'];
	$login_remember    =	$_POST['remember'];
	$login_hide        =	$_POST['hideme'];
	
	if($login_remember == '') {
        $login_remember =   0;
 	}



	//did the user put in the needed stuff?
	if (!$login_usrname)
	{
		$login_error	=	$lang_login->login_wrtusr;
	}	
	if (!$login_pwd)
	{
		$login_error	=	$lang_login->login_wrtpwd;
	}

	if (!$login_error)
	{
		//doing a quick check to see if the username exists in the database
		
		$db_logincheck	=	$db->get_finduser_login($login_usrname);
		if (!is_numeric($db_logincheck->id))
		{
			$login_error	=	$lang_login->login_nousr;
		}

        //Well, we found a user, then let`s see if the user got the correct password :-)
		else if(!$login_error)
		{

			$db_login	=	$db->get_info_about_userloggingin($db_logincheck->name, md5($login_pwd));

			//The password does not seem correct
			if ($db_login === false)
			{
				$login_error	=	$lang_login->login_nopwd;
			}


			//print error in case we are in a "wrong" group.
			switch($db_login->group)
			{
				case '6':
				$login_error	=	$lang_login->login_notreg;
				break;

				case '5':
				$login_error	=	$lang_login->login_validat;
				break;

				case '4':
				$login_error	=	$lang_login->login_banned;
				break;
			}				
		}
	}
	
	// Now we are going to either show a error to the user or log him totaly in
	if ($login_error)
	{
		error_msg($login_error, 1);
	}
	else
	{
		//===================
		//	Logging in a user
		//==================

		//Updating sessions table
		$db->update_loginuser($db_login->id, $db_login->group, $db_login->name, $login_hide, $login_remember, $user->session());
				
		//===================
		//If we are using global-site-login we are to send the user around while we are setting cookies
		//===================

		if($config->use_multi_login)
		{
			//Get sites and loop through them
			$db_sites	=	$cache->query('get_sites');
			$db_sites	=	$db_sites[0];
			
			//multi-logging in
			multi_login($db_sites->id, $user->session, $login_usrname, $login_pwd, $login_hide);
		}

		//===================
		//if we dont use global logins, just do the simple (boring?) routine.
		//===================
		else
		{
			//I am in a good mood today so here, take a cookie :) (free cookies, for everybody!)
			if($login_remember == 1)
			{ 
			  		
				//The user wants to be remebered, lets save the username and password
				setcookie("{$config->cookie}_username", $login_usrname, time()+31536000);
				setcookie("{$config->cookie}_password", md5($login_pwd), time()+31536000);
				//Also set a hide me cookie?
				if($login_hide) {
					setcookie("{$config->cookie}_hideme", 1, time()+31536000);
				}
			}

			//well, that`s all, let`s send the user to the main page again	
			header("Location:index.php");
		}
	}
}
	
//====================================
//	Login form functions
//====================================

function login_page()
{
	//====================================
	//	Init variables to use
	//====================================
	global $db, $config, $user, $screen;

	// Lets forward users that are already logged in to the frontpage.
	if($user->id != '1')
	{
		header('Location: index.php');
		exit;
	}

	$lang_login	=	new lang_login;

	//====================================
	//	Create a list of words to use in the template (array)
	//====================================
	$tohtml = array(
						"login"			=>	$lang_login->login,
	                	"login_title"   =>	$lang_login->login_title,
						"username"		=>	$lang_login->login_usrname,
						"password"		=>	$lang_login->login_pwd,
						"hideme"		=>	$lang_login->login_hide,
						"remember_login"=>	$lang_login->login_rmbr,
						"do_login"		=>	$lang_login->login,
						"link_lostpwd"	=>	'<a href="lostpass.php">'.$lang_login->login_fgot.'</a>',
						"link_newuser"	=>	'<a href="register.php">'.$lang_login->login_nusr.'</a>');

    //====================================
    //      Add to output
    //====================================
	$screen->add_html('login', $tohtml);

    //====================================
    //      Add a navigation line
    //====================================
	$navigation = '<a href="index.php">'.$config->forum_name.'</a> -> <a href="index.php?c='.$view_cat.'">'.$lang_login->login.'</a>';
	$screen->add_wrapper($lang_login->login, $navigation);

	//====================================
	// Print page
	//====================================
	$screen->print_page();
}


/**
 * Multi-site login function. Redirects the user in a frenzy across
 * the different login domains and sets cookies in all directions.
 * 
 * If this breaks, you have no chance if fixing it, and your career
 * has just ended. Now you should just hide under your desk for the
 * rest of your life and/or commit kamikaze and take the server with you.
 * If not, the universe will implode, and we wouldn't want that, would we?
 *
 * @param int $siteid
 * @param string $_SID
 * @param string $_name
 * @param string $_pwd
 * @param int $_hide     
 */
function multi_login($siteid, $_SID, $_name, $_pwd, $_hide) {

	global $user, $config, $cache;
	
	//vars
	$SID	=	$_GET['SID'];
	$name	=	$_GET['name'];
	$pwd	=	$_GET['pwd'];
	$hide	=	$_GET['hide'];
		
	//got a starter?
	if(!$siteid)
	{
		$lang_login	=	new lang_login;
		error_msg($lang_login->login_error);
	}

	//Passport check!
	if(!$SID)
	{
		$SID	=	$user->session();
	}

	//Stop if no SID
	if(!$SID)
	{
		$lang_login	=	new lang_login;
		error_msg($lang_login->login_error, 1);
	}

	
	//Get the forum-sites
	$togo	=	$cache->query('get_sites'); 
	
	//now we will loop through all the sites (foreach is needed, but, like, you know, whateva')
	$round = 0;
	$start = $_GET['site'];
	
	if(!is_numeric($start)) {
		  
		$data = $togo[0];
		$url = $data->forum_url;
		header("Location: {$url}login.php?t=04&site=".($round + 1)."&SID={$_SID}&ref={$config->forum_url}&name={$_name}&pwd={$_pwd}&hide={$_hide}");
		continue;
		
	} else {
	  	
		// Give cookie to user on this site.
		// This needs to be before the redirect, so if redirects are not supported
		// it will at least log in on the originating site.	
		//The user will be remebered, lets save the username and password
		
		ob_start(); //A hack to make shure cookies are really set
		setcookie("{$config->cookie}_username", $name, time()+31536000);
		setcookie("{$config->cookie}_password", md5($pwd), time()+31536000);
			
		//Hide user?
		if($hide) {
			setcookie("{$config->cookie}_hideme", 1, time()+31536000);
		}

		
		//Loop over the forum websites	  
		foreach ($togo as $data)
		{

			//work if this is the site we are asked to cookie
			if($round == $start) {
		  	
				$round++;
			
				//Move along to next site
				$url = $data->forum_url;
				header("Location: {$url}login.php?t=04&site={$round}&SID={$SID}&ref={$_GET['ref']}&name={$name}&pwd={$pwd}&hide={$hide}");
				ob_end_flush();
				
				//If not, check if this is the last site, in so case we are returned back to start
			} else {
				$round++;
				if($round == count($togo)) {
					setcookie("{$config->cookie}_SESSION", $SID, time()+31536000);
					//If we got here, we gotta be finished :)
					header("Location: {$_GET['ref']}");
				}
			}
		}
	}
}
	
	
/**
 * Multi-site logout function, makes shure that a user gets
 * logged out on all the sites in the forum network. 
 *   
 * @param int $siteId 
 */
function multi_logout($siteId) {
	
	global $db, $config, $cache, $user;

	//changing the sessions record to a guest only state
	$db->update_sessions_logout_user();
	
	//Make shure that we dont have username and password stored
	setcookie("{$config->cookie}_username", "", time()-10);
	setcookie("{$config->cookie}_password", "", time()-10);	
	setcookie("{$config->cookie}_hideme", "", time()-10);	

	//got a starter?
	if(!$siteId)
	{
		$lang_login	=	new lang_login;
		error_msg($lang_login->login_error);
	}

	$SID	=	$user->session();

	//Stop if no SID
	if(!$SID)
	{
		$lang_login	=	new lang_login;
		error_msg($lang_login->login_error, 1);
	}

	//Get the forum-sites
	$togo	=	$cache->query('get_sites'); 
	
	//now we will loop through all the sites (foreach is needed, but, like, you know, whateva')
	$round = 0;
	$start = $_GET['site'];
	
	if(!is_numeric($start)) {
		  
		$data = $togo[0];
		$url = $data->forum_url;
		header("Location: {$url}login.php?t=02&site=".($round + 1)."&SID={$_SID}&ref={$config->forum_url}&name={$_name}&pwd={$_pwd}&hide={$_hide}");
		continue;
		
	} else {
	  	
		//Loop over the forum websites	  
		foreach ($togo as $data)
		{

			//work if this is the site we are asked to cookie
			if($round == $start) {
		  	
				$round++;
			
				//Move along to next site
				$url = $data->forum_url;
				header("Location: {$url}login.php?t=02&site={$round}&SID={$SID}&ref={$_GET['ref']}&name={$name}&pwd={$pwd}&hide={$hide}");
				ob_end_flush();
				
				//If not, check if this is the last site, in so case we are returned back to start
			} else {
				$round++;
				if($round == count($togo)) {
					//If we got here, we gotta be finished :)
					header("Location: {$_GET['ref']}");
				}
			}
		}
	}	
}
?>
