<?PHP 

/**
 * lostpass.php - Allows a user to choose a new password if the old one is forgotten.
 * @package Vikingboard
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @version 0.1
 * @todo This does not work when $config->multi_reg is true.
 *
 * $Id: lostpass.php 868 2006-07-24 21:31:09Z PaiTrakt $
 */

//yes, we are here
define("VBOARD", 1);

require_once('inc/functions.php');

// What to do?
$mode = $_GET['mode'];

switch($mode)
{
	// Validating email address and sending it a confirmation key
	case '01':
	send_key();
	break;

	// Validating confirmation key and letting the user choose a new password
	case '02':
	new_password();
	break;

	// Validating password and adding it to the database
	case '03':
	update_password();
	break;

	// Displaying input form allowing user to start the process of getting a new password
	default:
	index();
	break;
}


/**
 * Lost password
 *
 * Displays the first step in the password retrieval process.
 *
 * @return void
 */
function index()
{
	global $screen;


	// Get the text and put it in the template.
	$lang_lp	=	new lang_lostpass;

	$html	=	array(
					'title'	=> $lang_lp->lostpass,
					'email'	=> $lang_lp->email,
					'go'	=> $lang_lp->go,
				);

	$screen->add_html('lostpass_frontpage', $html);

	// Navigation and output.
	$navigation	=	array('lostpass.php' => $lang_lp->lostpass);

	$screen->add_wrapper($lang_lp->lostpass, $navigation);
	$screen->print_page();	
	
	return true;
}


/**
 * Send confirmation key
 * 
 * Checks email and sends confirmation key.
 *
 * @return void
 */
function send_key()
{
	global $config, $db, $screen;

	// Did anyone stumble in here by accident? Let's stop em then.
	if($_POST) 
	{
		// Get the text.
		$lang_lp		=	new lang_lostpass;
		$lang_email		=	new lang_emails;
		$lang_global	=	new lang_global;

		// Checking input...
		$email	=	$_POST['email'];

		// User typed in email?
		if (!$email) {
			notify($lang_lp->email_null, 'lostpass.php', $lang_global->back);
		}

		// Is it valid?
		if (!is_valid_email_address($email))
		{
			notify($lang_lp->unvalid_email, 'lostpass.php', $lang_global->back);
		}

		// Do we really have a user registered with the email address provided?
		$user_id	=	$db->get_userid_from_email_address($email);
		$user_id	=	$user_id->id;
		if (!$user_id)
		{
			$lang_global	=	new lang_global;
			notify($lang_lp->failed_email, 'lostpass.php', $lang_global->back);
		}

		// Creating and inserting the confirmation key as well as the reactivation group.
		$conf_key	=	md5(forumtime() . $user_id . $email);
		$db->insert_confirmation_key($user_id, $conf_key);

		// Compose the mail which will be informing the user about the password changing attempt.
		$mail_title	=	str_replace("%forumname%", $config->forum_name, $lang_email->tit_lostpass);
		$mail_body	=	str_replace("%forumname%", $config->forum_name, $lang_email->lostpass_act);
		$mail_body	=	str_replace("%url%", $config->forum_url . 'lostpass.php?mode=02&key=' . $conf_key, $mail_body);

		emailer($user_id, $mail_title, $mail_body);

		// Output text.
		notify($lang_lp->success_email, 'lostpass.php', $lang_global->back);
	}
	else
	{
		// Stumbled indeed! Move along, nothing to see here.
		header('Location: lostpass.php');
		exit;
	}

	return true;
}

/**
 * New password
 *
 * Checks confirmation key, asks user to input email and password * 2
 *
 * @return void
 */
function new_password()
{
	global $config, $screen;

	// Do we have a confirmation key, and is it 32 chars (md5's are always 32 chars long) long?
	$conf_key	=	$_GET['key'];
	if($conf_key && strlen($conf_key) == 32)
	{
		// Get the text and put it in the template.
		$lang_lp	=	new lang_lostpass;

		$html	=	array(
			'title'				=> $lang_lp->lostpass,
			'email'				=> $lang_lp->email,
			'new_password'		=> $lang_lp->new_password,
			'retype_password'	=> $lang_lp->retype_password,
			'confirmation_key'	=> $conf_key,
			'go'				=> $lang_lp->go,
		);

		$screen->add_html('lostpass_new_pass', $html);

		// Navigation and output.
		$navigation	=	array('lostpass.php' => $lang_lp->lostpass);

		$screen->add_wrapper($lang_lp->lostpass, $navigation);
		$screen->print_page();	

	}
	else
	{
		// No confirmation key, or it is not 32 chars long.
		header('Location: lostpass.php');
		exit;
	}

	return true;
}


/**
 * Update password
 *
 * Update the users password in the database
 * 
 * @return void
 */
function update_password()
{
	global $config, $db;

	// Did anyone stumble in here by accident? Let's stop em then.
	if($_POST)
	{
		// Get the text.
		$lang_lp		=	new lang_lostpass;
		$lang_global	=	new lang_global;

		// Checking input...
		$conf_key			=	$_POST['conf_key'];
		$email				=	$_POST['email'];
		$new_password		=	$_POST['newpass'];
		$retype_password	=	$_POST['retypepass'];

		// Is there still a confirmation key, and does it have the correct lenght?
		if (!$conf_key || strlen($conf_key) != 32 )
		{
			notify($lang_lp->conf_key_null, 'lostpass.php?mode=02', $lang_global->back);
		}

		// User typed in an email?
		if (!$email)
		{
			notify($lang_lp->email_null, 'lostpass.php?mode=02', $lang_global->back);
		}

		// Is it valid?
		if (!is_valid_email_address($email))
		{
			notify($lang_lp->unvalid_email, 'lostpass.php?mode=02', $lang_global->back);
		}

		// Do we really have a user registered with the email address provided?
		$user_id	=	$db->get_userid_from_email_address($email);

		if (!$user_id->id)
		{
			notify($lang_lp->failed_email, 'lostpass.php?mode=02', $lang_global->back);
		}

		// User typed in password in both fields?
		if (!$new_password || !$retype_password)
		{
			notify($lang_lp->no_passwd, 'lostpass.php?mode=02', $lang_global->back);
		}

		// User typed in the same password in both fields?
		if ($new_password != $retype_password)
		{
			notify($lang_lp->passwd_un, 'lostpass.php?mode=02', $lang_global->back);
		}

		// Does the confirmation key match user id?
		$user_id	=	$user_id->id;
		$db_key		=	$db->get_confirmation_key($user_id);
		$db_key		=	$db_key->conf_key;
		if ($conf_key != $db_key)
		{
			notify($lang_lp->failed_email_key, 'lostpass.php?mode=02', $lang_global->back);
		}

		// Update to new password, remove confirmation key, and then tell the user all about it :)
		$password	=	md5($new_password);
		$db->update_password($user_id, $password);
		$db->remove_confirmation_key($user_id);

		notify($lang_lp->success_update, 'index.php', $lang_lp->back_to_index);

	}
	else
	{
		// Stumbled indeed! Move along, nothing to see here.
		header('Location: lostpass.php');
		exit;
	}

	return true;
}

?>