<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Hotstian <hotstian@users.sourceforge.net>
 * @version 0.1
 * 
 * $Id: members.php 1012 2006-09-25 19:55:46Z jorgenboard $
 */

//yes, we are here
define("VBOARD", 1);

//============
// Get the kernel file
//============
require_once('./inc/functions.php');


//=================
//  What to do?
//=================

switch(isset($_GET['act'])) {
	
	case 'online':
	print_list(TRUE);
	break;
	
	default:
	print_list();
	break;
}



//=================
//  Just print out the members list
//=================
function print_list($online = FALSE)
{
	//global vars and language files
	global $db, $cache, $screen, $config, $user;
	$lang = new lang_members;
	
	//default values
	$orderby = 'registred';
	
	//ordering
	$orderby_list = array('id', 'name', 'posts', 'registred', 'homepage', 'title', 'group'); 
	
	if (!empty($_POST['orderby'])) 
	{
		if (in_array($_POST['orderby'], $orderby_list))
		{
			$orderby = $_POST['orderby'];
		}
	}
	
	if (empty($_POST['order']))
	{
		$DESC = 'DESC';
	}
	else
	{
		$DESC = $_POST['order'];
	}
	
	
	
	//what page is requested?
	if (!is_numeric($_GET['s']))
	{
		$showfrom = 0;
	}
	else 
	{
		$showfrom = $_GET['s'];
	}
	
	define(PAGEBREAK, 25);
	
	//fetch members
	if (!$online)
	{
		$list = $db->get_member_list($orderby, $DESC, $showfrom, PAGEBREAK);
	}
	elseif ($online == TRUE)
	{
		$list = $db->get_member_list($orderby, $DESC, $showfrom, 10000);
	}
	$memberlist = '';
	
	
	
	//loop and add members to list
	$i = 0;
	while ($row = $list->row()) 
	{
		
		//formatting registred date
		$registered = date($config->timestamp2, $row->registred);
		
		//is this a guest? In that case, do not show on list
		if ($row->id == '1')
		{
			continue;
		}
		
		// Check sessions to see when user session was last updated
		$status = $cache->query('get_member_status', array($row->id));
		$status = $status[0];
		
		//online or offline?
		if ($status->time >= forumtime() - ($config->cut_time * 60)) 
		{
			$current_status = $lang->online;
		}
		else 
		{
			$current_status = $lang->offline;
			
			//are we only showing online users?
			if ($online)
			{
				continue;
			}
		}
			
		$userData = array(  'id'		 => $row->id,
						   'name' 	     => $row->name,
						   'posts' 	     => $row->posts,
						   'reg' 	     => $registered,
						   'homepage'    => $row->homepage,
						   'title' 	     => $row->title,
						   'group' 	     => $row->g_name,
						   'status'      => $current_status
						   );
						   
		$memberlist .= $screen->return_html('memberlist_data', $userData);
	}
	
	//Do we need several pages to load this one?
	$stats = $cache->query('get_forum_stats', array());
	$stats = $stats[0];
	
	if ($online)
	{
		//get online users
		$onl_users	=	$db->get_online_users(forumtime() - ($config->cut_time * 60));
		$pages = (int)ceil($onl_users->users / PAGEBREAK);
	}
	else
	{
		$pages = (int)ceil($stats->total_users / PAGEBREAK);
	}
	
	//current page
	$showfrom = ceil($showfrom / PAGEBREAK) + 1;

	//build the pagenav
	if ($pages > 1)
	{
		//include the pagefile (:p) and construct the nav
		include_once('inc/lib/pages.php');
		
		$pagenav = $lang->pages . pages($showfrom, $pages, 'members.php?s=', PAGEBREAK);
	}
	
	//Wrap page and print it
	$navigation['members.php']  =   $lang->memberlist_title;
	$tohtml = array(	'memberlist_title' => $lang->memberlist_title,
						'l_username'    => $lang->username,
						'l_email'       => $lang->email,
						'l_homepage'    => $lang->homepage,
						'l_posts'       => $lang->posts,
						'l_registred'   => $lang->registred,
						'l_title'	   => $lang->title,
						'l_group'	   => $lang->group,
						'l_up'          => $lang->up,
						'l_id'		   => $lang->id,
						'l_down'        => $lang->down,
						'l_sort'        => $lang->sort,
						'l_sort_after'  => $lang->sort_after,
						'l_sort_button' => $lang->sort_button,
						'l_status'	   => $lang->status,
						'pagenav'		=> $pagenav,
						'memberlist'  => $memberlist);
						
	//add wrappers and send it to printing
	$screen->add_html('Memberlist', $tohtml);
	$screen->add_wrapper('Memberlist', $navigation);
	
	$screen->print_page();
	
}

?>