<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Jørgen Tellnes <jorgis@jorgis.com>
 * @version 0.1
 * 
 * $Id: post.php 1112 2006-10-30 23:15:46Z jorgenboard $
 */

//yes, we are here
define("VBOARD", 1);

require_once ('inc/functions.php');


//  Get some required libraries
require_once('inc/lib/post_parser.php');
$parser = new post_parser();




//Finding out what we are going to do
switch($_GET['mode'])
{
	case '00':
	post_page('new_topic');
	break;

	case '01':
	post_it();
	break;

	case '02':
	post_page('edit_post');
	break;

	case '03':
	post_page('new_reply');
	break;

	default:
	header('Location: index.php');
	break;
}

/**
 * Post page function, handles visual activity
 * 
 * @return bool
 */
function post_page($what)
{

	//	Define used variables
	global $db, $user, $config, $screen, $parser;

	$lang			=	new lang_post;
	$forumID		=	$_GET['f'];
	$topicID		=	$_GET['t'];
	$postID			=	$_GET['p'];
	$use_poll		=	$_GET['poll'];
	$quotepostID	=	$_GET['quote'];
	

	//	Get topic ID based on post ID
	if($postID && !$topicID) {
		$sql		=	$db->get_post_information($postID);
		$sql		=	$sql->row();
		$topicID	=	$sql->id; //returns topic id
			
	}
	
	//	Get forum ID based on topic ID
	if(!$forumID) {
		$forumID	=	$db->get_topic_information($topicID);
		$forumID	=	$forumID->row();
		$forumID	=	$forumID->fid;		
	}


	//	Do we got something to do?
	if(!$what) {
		error_msg($lang->nothing_to_do, 1);
	}


	//	Soeh, got all data we want?
	if($what == "new_topic") {
		if(!$forumID) {
			error_msg($lang->missing_data, 1);
		}
	}
	elseif($what =="new_reply") {
		if(!$topicID) {
			error_msg($lang->missing_data, 1);
		}
	}
	elseif($what == "edit_post") {
		if(!$postID) {
			error_msg($lang->missing_data, 1);
		}
	}
	else {
		error_msg($lang->nothing_to_do, 1);
	}


	//	Check permissions to see if the user can post "here"

	//Can this user group post?
	if ($user->g_create_new_posts == 0) {
		$error	=	$lang->cant_post; 
	}
	
	//Allowed to poll?
	if($use_poll && $user->g_create_new_polls == 0) {
		$error	=	$lang->cant_poll;	
	}
	

	//	Show a error if any
	if ($error) {
		error_msg($error, 1);
	}


	//	Get some information about the category we are in
	$tmp	=	$db->get_forum_info($forumID);
	$category = $tmp->row();	
	$category = $category->cat;
	
	/*
	while($row = $tmp->row()) {
		$category	=	$row;
	}*/
	
	//	Get a post to quote (Singlequote)
	$quotedpost = 0;
	if($quotepostID) {
		$tmp	=	$db->get_post_information($quotepostID);
		while($row = $tmp->row()) {
			$quotedpost	=	$row;
		}
	}
	

	//	Want to multi-quote? (Quoteparty!)
	if($_COOKIE[$config->cookie . "_multiquote"])
	{
		$tmp	=	spliti("_", $_COOKIE["".$config->cookie."_multiquote"], 5);
		foreach($tmp as $row)
		{
			if(is_numeric($row))
			{
				$tofind	.=	"$row, ";
			}
		}
		$tofind	.=	"0";

		$multiquotes	=	$db->get_posts_in_topic($tofind, 0, $config->max_quotes);
	}


	//	Content to put into the post box?
	if($quotedpost || $row || $what =="edit_post") {
		
	}

	if($row && $what !="edit_post") {
		while($row = $multiquotes->row())
		{
			$post_content	.=	"[quote=".$row->author_name."]\n".$parser->post_deparse($row->post, TRUE)."\n[/quote]\n\n";
		}
		setcookie("".$config->cookie."_multiquote", "");
	}
	//	We are editing a post, get it and put it :)
	else if($what == "edit_post") {
		$tmp	=	$db->get_post_information($postID);
		$tmp	=	$tmp->row();
		$tmp	=	$tmp->post;
		$post_content	=	$parser->post_deparse($tmp, TRUE);
	}

	if($quotedpost && $what !="edit_post") {
			$post_content	.=	"[quote=".$quotedpost->author_name."]\n".$parser->post_deparse($quotedpost->post, TRUE)."[/quote]\n\n";
	}

	//	Put topic information boxes in to templates if used
	if($what == 'new_topic') {

		$topic_values	=	array(
		'topic_help'    =>  $lang->title,
		'topic_name'	=>	""
		);

		$topic_title	=	$screen->return_html('post_topic', $topic_values);

	} else if($what == 'edit_topic') {

		$topic_values	=	array(
		'topic_help'    =>  $lang->title,
		'topic_name'	=>  "NAME"
		);

		$topic_title	=	$screen->return_html('post_topic', $topic_values);
 	}

	/**
	*
	*	@todo Put in "edit topic title" here.
	*
	*/


	//	Put poll information boxes in to templates if used
	if($use_poll)
	{
		$poll_content	=	array(
		"poll_title"	=>	$lang->poll_title,
		"poll_options"	=>	$lang->poll_options,
		"poll_infotext" =>	$lang->poll_help
		);

		$poll_area	=	$screen->return_html('post_poll', $poll_content);
	}

	/**
	*
	*	@todo Put in edit poll to here
	*
	*/


	//	Posting buttons is a nice little gadget
	$action = '';
	if($what == "new_topic")
	{
		if($use_poll)
		{
			$title			=	$lang->new_poll;
			$submit_button	=	$lang->submit_newtopic;
			$preview_button	=	$lang->submit_preview;
			$action 		=	$lang->poll;
		}
		else
		{
			$title			=	$lang->new_topic;
			$submit_button	=	$lang->submit_newtopic;
			$preview_button	=	$lang->submit_preview;
			$action			=	$lang->topic;
		}
	}
	else if($what == "new_reply")
	{
		$title			=	$lang->new_reply;
		$submit_button	=	$lang->submit_newpost;
		$preview_button	=	$lang->submit_preview;
		$action			=	$lang->replying;
	}
	else if($what == "edit_post")
	{
		$title			=	$lang->edit_post;
		$submit_button	=	$lang->submit_edited;
		$preview_button	=	$lang->submit_preview;
		$action			=	$lang->editing;
	}
	
	// Including post buttons
	include 'inc/lib/post_buttons.php';
	
	// ....aaand smiley list ;D
	include 'inc/lib/smiley.php';
	

	//	Create the master array with all data
	$html	=	array(
		"topic_area"		=>	$topic_title,
		"poll_area"			=>	$poll_area,
		"post_buttons"		=>	post_buttons(),
		"smileys"			=>	show_smileylist(),
		"alternatives"		=>	$lang->alternatives,
		"submit_button"		=>	$submit_button,
		"preview_button"	=>	$preview_button,
		"category"			=>	$category,
		"do_what"			=>	$what,
		"forum_id"			=>	$forumID,
		"sid"				=>	$user->session,
		"user_id"			=>	$user->id,
		"post_id"			=>	$postID,
		"topic_id"			=>	$topicID,
		"content"			=>	$post_content,
		"get_emails"		=>	$lang->get_email_onpost,
		"show_signature"	=>	$lang->show_signature,
		"show_smileys"		=>	$lang->show_smilies,
		"title"				=>	$title,
		"alternaltives_info"=>	$lang->alternaltives
	);
	

	//	Fetch master template used in page
	$screen->add_html('post_body', $html);


	//	Navigation
	$navigation['post.php?mode='.$_GET['mode'].'&f='.$_GET['f'].'']	=	$title;


	//	Wrap up the page nicely
	$screen->add_wrapper($action, $navigation);

	//	Print finished parsed page :) (le, voila!)
	$screen->print_page();

}

/**
 * Post function, handles everything related to the actual posting or update to the database and e-mail reporting etc
 * 
 * @return none
 */

function post_it()
{


	//  Get needed variables
	global $cache, $config, $db, $user, $parser;
	$lang 		= new lang_post;
	$postID		=	$_POST['postID'];
	$forumID	=	$_POST['forum'];
	$catID		=	$_POST['cat'];
	$topicID	=	$_POST['topic'];
	$use_sig	=	$_POST['sig'];



	//  Do a quick check to make shure we got required data
	if(!$_POST['sid'] || !$_POST['post'] || !$_POST['do'] || !$forumID || !$catID) {
		error_msg($lang->missing_data, 1);
	}

	//  Also check topic name if needed
	if($_POST['do'] == "new_topic" && !$_POST['title'] || $_POST['do'] == "edit_topic" && !$_POST['title']) {
        error_msg($lang->missing_data, 1);
 	}


	//  Check permissions
	//Can poll?
	if($_POST['pollquestion'] && $_POST['pollchoices']) {
		if($user->g_create_new_polls !=1) {
			$error = $lang->cant_poll;	
		}	
	}
	
	//Can post ?
	if($_POST['do'] == "new_topic" && $user->g_create_new_posts !=1 || $_POST['do'] == "new_reply" && $user->g_create_new_posts !=1) {
		$error	=	$lang->cant_post;	
	}
	
	//Can edit...
	if($_POST['do'] == "edit_post") {
		
		$sql	=	$db->get_post_owner($postID);
		$sql	=	$sql->row();
		$postOwner= $sql->author_id;
		
		//Own posts?
		if($user->id == $postOwner && $user->g_can_edit_own_posts !=1) {
			$error	=	$lang->cant_edit;
		}
	
		//Others posts?
		if($user->id != $postOwner && $user->g_is_mod !=1) {
			$error	=	$lang->cant_edit;
		}
	}
	
	//Valid key?
	
	//any error?
	if(isset($error)) {
		error_msg($error, 1);	
	}





	//  Run post through the post parser
	$post	=	$parser->post_parse($_POST['post'], $_POST['use_smileys']);
	




	//Update an edited post
	if($_POST['do'] == "edit_post") {
		
		//A Thief? (btw: what about mods/admins?)
		if ($user->id !=$postOwner){
			error_msg($lang->cant_edit);
		}
		$time = date($config->timestamp1);
		//adding a edited by line
		$post	.=	"\n<!--startedit--><br /><br /><span class=\"post-edit\">" . $lang->edited_by . " " . $user->name . " @ " .  $time . "</span><!--endedit-->\n";

		//updating the post
		$db->update_post_data($postID, $post);		
	}
	


	//Create a new topic
	if($_POST['do'] == "new_topic" || $_POST['do'] == "new_poll") {
		
		//Get title and insert topic 
		$topicTitle	=	$_POST['title'];
		$db->insert_newtopic($forumID, $catID, $topicTitle, $user->id, $user->name);
		$sql	=	$db->get_newest_topicid_from_user($user->id);
		$sql	=	$sql->row();
		
		//New topic id
		$topicID=	$sql->id;
		
		//Insert new post
		$db->insert_new_post($topicID, $user->name, $user->id, $post, $use_sig, $_SERVER['REMOTE_ADDR']);
		$sql	=	$db->get_new_post_id($user->id, $topicID);
		$sql	=	$sql->row();		
		
		// Oh, you little statwhore! :)
		$db->update_user_postcount($user->id);
		$db->update_stats_on_newtopic($forumID, $topicTitle, $topicID, $sql->id, $user->name, $user->id);
		$db->update_global_stats("topics");
		$db->update_global_stats("posts");
		
		// Get forum subscribers
		$lang_email = new lang_emails;
		$subscriptions		=	$db->get_subscriptions_in_forum($forumID);
		$sub_message		=	$lang_email->subscribe_new_topic;
		$sub_message_title	=	$lang_email->new_topic_title;
		$topicTitle			=	$db->get_topic_title_from_id($topicID);
		
	}
	else
	{
		// Get topic subscribers
		$lang_email = new lang_emails;
		$subscriptions		=	$db->get_topic_subscribers($topicID);
		
		$sub_message		=	$lang_email->subscribe_new_reply;
		$sub_message_title	=	$lang_email->new_topic_reply_title;
		
		$topicTitle			=	$db->get_topic_title_from_id($topicID);
	}

	// Run through the subscribers, and send them an email :)
	while($row = $subscriptions->row())
	{
		$topicLink	=	"{$config->forum_url}topic.php?t={$topicID}";
		
		$mail	=	str_replace("%title%", $topicTitle->title, $sub_message);
		$mail	=	str_replace("%link%", $topicLink, $mail);
		
		emailer($row->uid, $sub_message_title, $mail);
	}




	//Create a reply
	if($_POST['do'] == "new_reply") {
		
		//post data
		$db->insert_new_post($topicID, $user->name, $user->id, $post, $use_sig, $_SERVER['REMOTE_ADDR']);

		
		//New post ID
		$sql	= $db->get_new_post_id($user->id, $topicID);
		$sql	= $sql->row();
		
		//get name of topic
		$topicName = $db->get_topic_title_from_id($topicID);
		
		//updating stats
		$db->update_forum_stats_on_reply($forumID, $topicID, $sql->id, $user->name, $user->id, $topicName->title);		
		$db->update_topic_stats_on_reply($topicID, $sql->id, $user->name, $user->id);
		$db->update_user_postcount($user->id);
		$db->update_global_stats("posts");
	
	}

	
	//  Just make shure that we got a topic ID
	if(!$topicID) {
		$topicID	=	$_POST['topic'];	
	}
	

	//  Parse poll and put it to DB
	if($_POST['pollquestion'] && $_POST['pollchoices']) {
		
		//Parse poll data
		$pollQuestion	=	$_POST['pollquestion'];
		$pollChoices	=	nl2br($_POST['pollchoices']);
		$pollChoices	=	explode("<br />", $pollChoices);
		
		//Insert poll question to DB
		$db->insert_new_poll_title($topicID, $pollQuestion);
		
		//Insert poll choices to DB
		foreach($pollChoices as $row) {
			$db->insert_new_poll_question($topicID, $row);
		}
	}
	

	//	Done, forward user to "bool"
	header("Location:topic.php?t={$topicID}&act=lastpost");
}
?>