<?php 
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.1
 * 
 * $Id: register.php 841 2006-07-06 15:27:53Z jorgenboard $
 */

//yes, we are here
define("VBOARD", 1);

//==============================================
//	Register page, we need some new users to have som activity here
//==============================================

include ('inc/functions.php');

// Lets forward users that are already registered and logged in to the frontpage.
if($user->id != '1')
{
	header('Location: index.php');
	exit;
}

//What to do?
$mode = $_GET['mode'];
switch($mode) 
{
	case '00':
	register_form();
    	break;
	
	case '01':
	register_member();
    	break;
	
	case '02':
	activate_member();
    	break;
		
	default:
	register_form();
	break;
}



	
//===========================================
//	Function that makes the register form
//===========================================
function register_form()
{
	//	Define variables to use in the function
	global $cache, $user, $screen;

	$lang_reg	=	new lang_register;

	//	Set variables that are to be used in the template

	//navigation
	$navigation['register.php']	=	$lang_reg->register;
	
	//content
	$register		=	$lang_reg->register;
	$required_info	=	$lang_reg->reg_musttitle;
	$username		=	$lang_reg->reg_usrn;
	$password		=	$lang_reg->reg_pwd;
	$password_again	=	$lang_reg->reg_pwd_x2;
	$email			=	$lang_reg->reg_mail;
	$email_again	=	$lang_reg->reg_mail_x2;
	$rules_title	=	$lang_reg->reg_rulestitle;
	$rules_info		=	$lang_reg->reg_ruleinf;
	$rules          =   $cache->query('get_help_topics', array("rules"));
	$rules			=	$rules[0]->content;
	$accept			=	$lang_reg->reg_agree;
	$submit			=	$lang_reg->submit;

	//	Put them to a nice array
	$tohtml	=	array(
		"register" => $register, 
		"required_info" => $required_info,
		"username" => $username,
		"password" => $password,
		"password_confirmation" => $password_again,
		"email_adress" => $email,
		"email_adress_confirm" => $email_again,
		"rules_title" => $rules_title,
		"rules_info" => $rules_info,
		"rules" => $rules,
		"accept" => $accept,
		"submit" => $submit
	);

	//	Add template
	$screen->add_html('registerpage', $tohtml);
	
	//	Wrap it
	$screen->add_wrapper($register, $navigation);

	// Print page
	$screen->print_page();
}

//===========================================
//	Function that registers a new member
//===========================================

function register_member()
{
	
	//Post data
	$reg_username	=	$_POST['user'];
	$reg_passwd1	=	$_POST['pwd'];
	$reg_passwd2	=	$_POST['pwd2'];
	$reg_email1		=	$_POST['email'];
	$reg_email2		=	$_POST['email2'];
	$reg_rules		=	$_POST['accepted'];
	
	//Doing a check to make shure that we got all that is needed.
	$lang_register	=	new lang_register;
	global $db, $config;
	
	//username
	if (!$reg_username)
	{
		error_msg($lang_register->no_usrname, 1);
	}	
	
	//password check
	if (!$reg_passwd1 || !$reg_passwd2)
	{
		error_msg($lang_register->no_passwd, 1);
	}
	
	//Password fields contains the same data?
	if ($reg_passwd1 != $reg_passwd2)
	{
		error_msg($lang_register->passwd_un, 1);
	}		
	
	//is the email adresses alike?
	if (!$reg_email1 || !reg_email2)
	{
		error_msg($lang_register->email_null, 1);
	}
	
	//Does the email contains an @ ? | nice to have you know..
	if (!is_valid_email_address($reg_email1))
	{
		error_msg($lang_register->no_alfa, 1);
	}
	
	//Do we allow multible registrations from the same mail adress?
	if (!$config->multi_reg)
	{
		$multimail	=	$db->get_num_emails($reg_email1);
		if ($multimail->rows !=0)
		{
			error_msg($lang_register->mail_full, 1);
		}
	}		
	
	//Email fields contains the same data?
	if ($reg_email1 != $reg_email2)
	{
		error_msg($lang_register->email_un, 1);
	}
	
	//Scream out if the user don`t accept the forum rules.
	if(!$reg_rules)
	{
		error_msg($lang_register->rules_dis, 1);
	}
	
	//check for "wrong" input
	$reg_username = htmlentities($reg_username);
	$reg_username = strip_tags($reg_username);
	
	//check the minimum length for the password
	if (strlen($reg_passwd1) < (int)$config->password_length)
	{
		error_msg($lang_register->too_short_password . $config->password_length, 1);
	}
		
	//check for the minimum password complexity
	if (password_strength($reg_passwd1) < (int)$config->password_strength)
	{
		error_msg($lang_register->too_simple_password, 1);
	}
	
	//check for minimum username length
	if (strlen($reg_username) < (int)$config->username_length)
	{
		error_msg($lang_register->too_short_username . $config->username_length, 1);
	}
	
	//Checking the username to make shure that we do not "double" our self.		
	$usr_numcheck	=	$db->get_username_from_name($reg_username);
	$usr_numcheck   =   $usr_numcheck->row();
	
	if($usr_numcheck->id)
	{
		error_msg($lang_register->name_taken, 1);
	}
	
	
	
	//Anti spam check
	$a_ip		=	$_SERVER['REMOTE_ADDR'];
	$a_browser	=	$_SERVER['HTTP_USER_AGENT'];
	
	//inserting a new row
	$db->insert_register_antispam_data($a_ip, $a_browser);
	
	//checking the anti-spam list
	$antispam	=	$db->get_register_antispam_data($a_ip, $a_browser);
	

	//=============================
	//ey, we got a spammer!
	//=============================
	if ($antispam->rows =="2") //what about > 1 instead?
	{
		error_msg($lang_register->antispam_act, 1);
	}
		

	//=============================	
	//the user is AOK, lets register "it".
	//=============================
	
	//stats update:)
	$db->update_global_stats("users");
	
	
	//=============================
	//no activation is needed
	//=============================
	if ($config->reg_act =="0")
	{
		//putting the user into the DB
		$db->insert_new_user_data($reg_username, md5($reg_passwd1), $reg_email1, 3);

		//finding the latest ID so we can add it to the member_extra table
		$new_id	=	$db->get_latest_user();
		$new_id	=	$new_id->row();
		$new_id	=	$new_id->id;
		$db->insert_extra_user_data($new_id);
		
		
		//done, inform the happy newkid :)
		notify($lang_register->welcome, 1);
	}
	
	//=============================
	//The user must activate the account via mail
	//=============================
	else if ($config->reg_act =="1")
	{
		//putting the user into the DB
		$db->insert_new_user_data($reg_username, md5($reg_passwd1), $reg_email1, 5);
		
		//finding the latest ID so we can add it to the member_extra table
		$new_id	=	$db->get_latest_user();
		$new_id	=	$new_id->id;
		$db->insert_extra_user_data($new_id);
					
		//Creating and inserting a activation key
		$act_key	=	md5("".forumtime()."$reg_username$reg_email1");

		$db->insert_new_update_key($new_id, $act_key);
		
		//make mail!
		$lang_email	=	new	lang_emails;
		$mail_title	=	str_replace("%forumname%", $config->forum_name, $lang_email->tit_newuser);
		$mail_body	=	str_replace("%forumname%", $config->forum_name, $lang_email->newuser_act);
		$mail_body	=	str_replace("%ip%", $_SERVER['REMOTE_ADDR'], $mail_body);
		$mail_body	=	str_replace("%ip%", $_SERVER['REMOTE_ADDR'], $mail_body);
		$mail_body	=	str_replace("%url%", ''.$config->forum_url.'/register.php?mode=02&key='.$act_key.'', $mail_body);
		
		//and away!....    :)	
		emailer($new_id, $mail_title, $mail_body);
		
		//done, inform the happy newkid :)
		notify($lang_register->regmail_sendt, 1);
	
	}
	//=============================
	//An admin must activate the account
	//=============================
	if ($config->reg_act =="2")
	{
		//putting the user into the DB
		$db->insert_new_user_data($reg_username, md5($reg_passwd1), $reg_email1, 5);	

		//finding the latest ID so we can add it to the member_extra table
		$new_id	=	$db->get_latest_user();
		$new_id	=	$new_id->id;
		$db->insert_extra_user_data($new_id);

		//send a message to the new registred user.
					
	}		
}

//===========================================
//	Function that activates a "deactivated" member.
//===========================================

function activate_member()
{
	//Variables to use
	$register_key	=	$_GET['key'];
	$lang_register	=	new	lang_register;

	//Making shure that we got a key.
	if (!$register_key)
	{
		error_msg($lang_register->no_regkey);
	}
	//So, is this key valid?
	global $db;
	$check_key	=	$db->get_check_regkey($register_key);

	if (!$check_key->rows)
	{
		error_msg($lang_register->regkey_invalid);
	}

	//weeel everything seems fine, let`s activate then :)
	$check_key	=	$check_key->row();
	//whoops, is this a hacing attempt?
	$keyowner	=	$db->get_key_owner($register_key);
	$keyowner	=	$keyowner->row();
	if ($keyowner->mid !=$check_key->mid)
	{
		error_msg($lang_register->wrongkey);
	}
	else
	{
		//puh, goodie :)
		$db->update_activate_user($check_key->mid, $register_key);
		error_msg($lang_register->account_activated);
	}
}

?>