<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @version 0.1
 * 
 * $Id: report.php 1111 2006-10-30 22:48:27Z jorgenboard $
 */

//yes, we are here
define("VBOARD", 1);

require_once('./inc/functions.php');


/**
 * Are we allowed to report posts?
 */
if (($user->id == '1') || ($user->group > '4'))
{
	$lang_report = new lang_report_post;
	error_msg($lang_report->report_no_rights, 1);
}

switch($_GET['act'])
{
	case 'send':
	save_report();
	break;
	
	default:
	report_post();
	break;
}



/**
 * Save report
 *
 * Adds the report to the database
 */
function save_report()
{
	global $db, $user;

	$lang			=	new lang_report_post;
	$lang_global	=	new lang_global;

	$id			=	(int)$_POST['id'];
	$message	=	$_POST['message'];

	// No user input?
	if(!$message)
	{
		error_msg($lang->missing_data, 'report.php?p=' . $id, $lang_global->back);
	}

	// Save to database
	$db->insert_new_report($id, $user->id, $message);

	notify($lang->report_ok);
}

/**
 * Report post
 *
 * Displays the form used to report a post
 */
function report_post()
{
	global $db, $cache, $screen, $user;

	$id	=	$_GET['p'];

	// Get some data
	$topic	=	$db->get_post_information($id);
	$topic	=	$topic->row();
	$topic	=	$cache->query('get_topic_information', array($topic->id));
	$topic	=   $topic[0];

	$lang	=	new lang_report_post;

	// No post to report
	if(!$topic->id)
	{
		header('Location: index.php');
	}

	// Navigation
	$navigation	=	array(
		'index.php?c=' . $topic->catid	=>	$topic->catname,
		'forum.php?f=' . $topic->fid	=>	$topic->fname,
		'topic.php?t=' . $topic->id		=>	$topic->title,
		'report.php?t=' . $id			=>	$lang->report_post,
	);

	$html	=	array(
		'report-post'	=>	$lang->report_post,
		'info'			=>	$lang->report_info,
		'id'			=>	$id,
		'submit'		=>	$lang_global->form_submit,
	);

	//html it
	$tohtml	=	array(
		'report-post'	=>	$lang->report_post,
		'img-set'		=>	$user->skin_set,
		'help-text'		=>	$lang->report_help,
		'reported-post'	=>	str_replace('%topic%', $topic->title, str_replace('%topic_id%', $topic->id, $lang->reported_post)),
		'message-title'	=>	$lang->message_title,
		'id'			=>	$id,
		'send-report'	=>	$lang->send_report,
	);

	//add html to output
	$screen->add_html('report_post', $tohtml);
	
	//add navigation to output and wrap it nicely up
	$screen->add_wrapper($lang->report_post, $navigation);

	//print page
	$screen->print_page();
}

?>