<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.1
 * 
 * $Id: search.php 1011 2006-09-21 16:54:52Z Ueland $
 */

//yes, we are here
define("VBOARD", 1);

//==========================
//	Require stuff file
//==========================
require_once('inc/functions.php');


class search {
	var $user;
	var $screen;
	var $db;
	var $config;
	var $resultList 	=	0;
	var $totalResults	=	0;
	var $search;


	//==========================
	//	Boot it
	//==========================
	function search() {

	//global variables
        global $db, $user, $config, $screen;
        $lang			=	new lang_search;
        
		$this->user		=	$user;
		$this->screen	=	$screen;
		$this->lang     =	$lang;
		$this->db       =   $db;
		$this->config   =   $config;
		$this->search	=	$_GET['search'];
		$this->timer	=	$this->microtime_float();
		
		//Do something
		$searchType	=	explode(":", $this->search);
		
		
		//Check type of search to run
		if($_GET['act'] == "dosearch") {
		  
		  	if(count($searchType) == 1) {
				$this->do_search();
				
			} else {
			  
				$searchType	=	$searchType[0];
				
				switch($searchType) {
				
					//Find int active posts
					case "active":
						$this->do_active_search();
					break;
				
					//Do a search for a users posts and topics
					case "user":
						$this->prepare_user_search();
					break;
					
					//Do a normal search
					default:
						$this->do_search();
					break;
				}
			}
		//No search tonight!
		} else {
		  
		  	//IF nothing is specified, show the search index
			$this->show_searchpage();
		}
	}
	
	
	//==========================
	//	Find the last int posts
	//==========================
	function do_active_search() {
	
	
		//Find out how many posts and topics we should show
		$num = explode(":", $this->search);
		$num = $num[1];
		
		if(is_numeric($num) == false ) {
			$num = 25;
		}

		//Where to start..
		if(!is_numeric($_GET['start'])) {
			$start  =   0;
		} else {
			$start  =   $_GET['start'];
		}
			
		$this->start = $start;
		
		
		//Hits = resutls to show
		$this->hits = $num;

		//  Find out start and end of results view
		if(!is_numeric($_GET['start'])) {
			$start  =   0;
		} else {
			$start  =   $_GET['start'];
		}
		$this->start = $start;
		
		
		//then get them (results that is)
		if($num > $this->config->show_maxposts) {
			$num = $this->config->show_maxposts;
		}
		$this->topicResult=		$this->db->getLastTopics($start, $num);
		$this->postResult =		$this->db->getLastPosts($start, $num);
		
		
		
		//Show the results
		$this->show_results();
		
	}
	
	//==========================
	//	Prepare to perform a user based search
	//==========================
	function prepare_user_search() {

		
		//Lets figure out what usersname to find posts from
		$userName = explode(":", $this->search);
		$userName = $userName[1];
		$search	=	explode(" ", $userName);
		$userName = $search[0];
		
		//Then lets find the userid we want to search for
		$user = $this->db->get_finduser_login($userName);
		$this->userID = $user->id;
		
		
		//Lets search for the correct keyword
		$search =	"{$search[1]} {$search[2]} {$search[3]} {$search[3]}"; //Did it simple
		$this->searchPhrase	=	str_replace("\\\\", "\\", htmlentities($search));
			
		//Then lets get over to the search function
		$this->do_search();
	}
		
	
	
	//==========================
	//	Perform a search
	//==========================
	function do_search() {

		$this->search	=	str_replace("\\\\", "\\", htmlentities($this->search));

		
		//  Find out start and end of results view
		if(!is_numeric($this->start)) {
			if(!is_numeric($_GET['start'])) {
				$start  =   0;
			} else {
				$start  =   $_GET['start'];
			}
			
			$this->start = $start;
		} else {
			$start = $this->start;
		}


		//  Show a list of new posts if we dont have a keyword
		if(empty($this->search)) {
			//first find total
			$hits   =   $this->db->calculateLastPosts("86400");
			$hits   =   $hits->totals;
			
			//if its more than 200, stop it there
			if($hits > 200) {
				$hits   =   200;
	  		}
			$this->hits = $hits;

			//then get them
			$this->topicResult=		$this->db->getLastTopics($start, "25");
			$this->postResult =		$this->db->getLastPosts($start, "25");
			
		}


		//  Then lets construct a search if we want to
		if(!empty($this->search) || !empty($this->searchPhrase)) {

			//Start by stripping searchwords
			if(empty($this->searchPhrase)) {
				$search		=   trim($this->search);
			} else {
				$search		=   trim($this->searchPhrase); 
			}
			$search     =   str_replace(",", "", $search);
			$tSearch	=	$search;
			
			//make it boolean
			$search     =   str_replace(" AND ", " +", $search);
			$search     =   str_replace(" NOT ", " -", $search);
			$search     =   str_replace(" OR ", " ,", $search);
			
			//explode it
			$search     =   explode(" ", $search);
			$words		=	0;
			foreach($search as $row) {
			  	$words++;
				if(strstr($row, ",") === FALSE && strstr($row, "-") === FALSE && strstr($row, "+") === FALSE) {
					$row    =   " +{$row} ";
		  		}
				$searchQuery[]  =   $row;
			}

			//query it (get total results)
			if(!is_numeric($_GET['totals']) && !is_numeric($this->hits)) {
			 
			  	if($search[0] == false) {
		
					//We are only searching for everything from a user, lets show it
					$hits   	=   $this->db->count_users_posts($this->userID);
					$hits   	=   $hits->totals;
					$this->hits	=	$hits;				
				
				} else {
				  
					$hits   	=   $this->db->runSearchCalculation($searchQuery, $this->userID);
					$hits   	=   $hits->totals;
					$this->hits	=	$hits;
				}
				
			} else {
			  
				if(!is_numeric($this->hits)) {
				  
					$hits   	=   $_GET['totals'];
					$this->hits	=	$hits;
					
				}	
	 	 	}
			
			//Prepare the topic search
			$tSearch	=	explode(" ", $tSearch);
			 	
			//Perform some kind of search
			if(is_numeric($this->userID) == false) {
			  	
			  	//Normal search
				$this->topicResult	=	$this->db->runTopicSearch($tSearch, $start, $this->config->show_maxposts, $this->userID);  
				$this->postResult	=   $this->db->runSearch($searchQuery, $start, $this->config->show_maxposts, $this->userID);	
							
			} else {
				
				if($this->searchPhrase == "   ") {
				
					//Show everything from user foo
				  	$this->topicResult	=	$this->db->get_users_topics($this->userID, $start, $this->config->show_maxposts);
					$this->postResult	=   $this->db->get_users_posts($this->userID, $start, $this->config->show_maxposts);	
								
				} else {
				
					//Normal search within a user`s content
				  	$this->topicResult	=	$this->db->runTopicSearch($tSearch, $start, $this->config->show_maxposts, $this->userID);  
					$this->postResult	=   $this->db->runSearch($searchQuery, $start, $this->config->show_maxposts, $this->userID);				
				}
			}
		}
			
		//Show the results
		$this->show_results();
	}
	
	
	
	//==========================
	//	Show the search results
	//==========================
	function show_results() {
	  
		//	Done with internal clock
		$this->totalTime = round($this->microtime_float() - $this->timer,2);	
	
		//Load post parser
		require_once("inc/lib/post_parser.php");
		
		//Loop over the post search results
		while($row = $this->postResult->row()) {
		  	
			//parse the post
			$post			=	$row->post;
			$post			=	post_parser::post_deparse($post);
			$post			=	preg_replace("#\[(.+?)\]#is", "", $post);
			$post			=	substr($post, 0, 150); //substr here
			
			
			//Set html tags
			$html['title']              =   $row->topicTitle;
			$html['link']         		=   "{$this->config->forum_url}topic.php?t={$row->tid}";
			$html['post']               =   $post;
			$html['date']               =   date($this->config->timestamp2, forumtime($row->posted));
			$html['forumName']          =   $row->forumName;
			$html['forumLink']          =   "forum.php?f={$row->forumId}";
			$html['otherThreadsLink']   =   "search.php?search={$row->topicTitle}&act=dosearch";
			$html['otherThreads']       =   $this->lang->similiar;

			
			//is this a result from the same thread as last time?
			if($row->tid	==	$lastId) {
				$inline =   'extendedrow';
			} else {
			  	$inline =   'defaultrow';
			}
			
			$content    .=  $this->screen->return_html("search_result_{$inline}", $html);
			$lastId     =   $row->tid;
		}
		
		//Soeh, did we find anything at all?
		if($this->hits == 0) {
			notify($this->lang->noHits);
            #$content    =   $this->lang->noHits;
        } else {
			$mainHTML['posts_found']	=	$this->lang->posts_found;
		}
        
        
        //Then knock up the topic results page
        while($row = $this->topicResult->row()) {
        	$topicHits++;
        	$t['forum']	=	$row->name;
        	$t['title']	=	$row->title;
        	$t['id']	=	$row->id;
        	$rows	.=	$this->screen->return_html('search_topic_row', $t);
     	}

     	if($topicHits) {
     	  	$mainHTML['topics_found']	=	$this->lang->topics_found;
     	  	$mainHTML['topics']			=	$rows;
        }
        
		//show how many results?
		if($hits < $this->config->show_maxposts) {
			$total = ($this->config->show_maxposts + $this->start);
			if($total > $this->hits) {
                $total = $this->hits;
            }
            
            //Build pagination
            require_once("inc/lib/pages.php");
            if(is_numeric($_GET['pages'])) {
				$pages = $_GET['pages'];
			} else {
				$pages	=	ceil($this->hits / $this->config->show_maxposts);
			}
			
			$thisPage	=	(ceil($this->start / $this->config->show_maxposts) + 1);
			$navdata	=	$this->lang->pages;
			$navdata	.=	pages($thisPage, $pages, "search.php?act=dosearch&amp;pages={$pages}&amp;search={$this->search}&amp;start=", $this->config->show_maxposts);
			
            
		} else {
			$total = $this->hits;
		}
		
		//boink up and print
		$navigation["search.php?act={$_GET['act']}"] = $this->lang->search;
		
		$mainHTML['searchFor']	=	$this->lang->searchFor;
		$mainHTML['result']		=   $content;
		$mainHTML['infoLine']	=	$this->lang->infoLine;
		$mainHTML['infoLine']	=	str_replace("%start%", $this->start +1, $mainHTML['infoLine']);
		$mainHTML['infoLine']	=	str_replace("%end%", $total, $mainHTML['infoLine']);
		$mainHTML['infoLine']	=	str_replace("%total%", $this->hits, $mainHTML['infoLine']);
		$mainHTML['infoLine']	=	str_replace("%time%", $this->totalTime, $mainHTML['infoLine']);
		$mainHTML['query']		=	$this->search;
		$mainHTML['search']		=	$this->lang->search;
		$mainHTML['pages']		=	$navdata;
		$mainHTML['skin_set'] 	=	$this->user->skin_set;



		//=============================
		// Print finished page
		//=============================
		$this->screen->add_html('search_result_wrapper', $mainHTML);
		$this->screen->add_wrapper($this->lang->search, $navigation);
		$this->screen->print_page();

	}

	

	//==========================
	//	Shows the search page
	//==========================
	function show_searchpage()
	{

		//=============================
		//	Set up words for the template
		//=============================
		$html['search']    		=	$this->lang->search;
		$html['searchFor'] 		=	$this->lang->searchFor;
		$html['show_searchtips']=	$this->lang->searchTips;
		$html['skin_set'] 		=	$this->user->skin_set;

		//=============================
		//	Fetch a template based on type, add a navigation line and wrap it nicely up
		//=============================
		$this->screen->add_html('search_frontpage', $html);
		$navigation	=	array("search.php?act={$_GET['act']}" => $this->lang->search);
		$this->screen->add_wrapper($this->lang->search, $navigation);


		//=============================
		// Print finished page
		//=============================
		$this->screen->print_page();
	}
	
	
	function microtime_float()
	{
	   list($usec, $sec) = explode(" ", microtime());
	   return ((float)$usec + (float)$sec);
	}
}

$search = new search;

?>